// This is an OCODE to Intcode codegenerator dated 1982 approx

//    CGHDR


// GET "LIBHDR"

// OCODE OPERATORS, 1982 compiler style:
/*
MANIFEST
$(    s_true          =    4
      s_false         =    5
      s_rv            =    8
      s_fnap          =   10
      s_mult          =   11
      s_div           =   12
      s_rem           =   13
      s_plus          =   14
      s_minus         =   15
      s_query         =   16
      s_neg           =   17
      s_abs           =   19
      s_eq            =   20
      s_ne            =   21
      s_ls            =   22
      s_gr            =   23
      s_le            =   24
      s_ge            =   25
      s_not           =   30
      s_lshift        =   31
      s_rshift        =   32
      s_logand        =   33
      s_logor         =   34
      s_eqv           =   35
      s_neqv          =   36
      s_cond          =   37
      s_lp            =   40
      s_lg            =   41
      s_ln            =   42
      s_lstr          =   43
      s_ll            =   44
      s_llp           =   45
      s_llg           =   46
      s_lll           =   47
      s_needs         =   48
      s_section       =   49
      s_rtap          =   51
      s_goto          =   52
      s_for           =   56
      s_return        =   67
      s_finish        =   68
      s_switchon      =   70
      s_global        =   76
      s_sp            =   80
      s_sg            =   81
      s_sl            =   82
      s_stind         =   83
      s_jump          =   85
      s_jt            =   86
      s_jf            =   87
      s_endfor        =   88
      s_lab           =   90
      s_stack         =   91
      s_store         =   92
      s_rstack        =   93
      s_entry         =   94
      s_save          =   95
      s_fnrn          =   96
      s_rtrn          =   97
      s_res           =   98
      s_reslab        =   99
      s_datalab       =  100
      s_iteml         =  101
      s_itemn         =  102
      s_endproc       =  103
      s_end           =  104
      s_char          =  105
      error           =  108
      s_debug         =  109
      s_startblock    =  110
      s_none          =  111
      s_mod           =  116
      s_getbyte       =  120
      s_putbyte       =  121
$)
*/

// BCPL lexical tokens, tree and ocode operators, 2010 compiler style:

MANIFEST $(	/*
s_number=1
s_name; s_string; s_true; s_false
s_valof; s_lv; s_rv; s_vecap; s_fnap						// 10
s_query
s_neg; s_abs // Integer operators
s_mult; s_div; s_rem; s_plus; s_minus
s_eq; s_ne; s_ls; s_gr; s_le; s_ge							// 24
s_slct; s_of                   // Inserted 11/7/01
s_byteap; s_mthap
s_not; s_lshift; s_rshift; s_logand; s_logor
s_eqv; s_neqv; s_cond; s_comma; s_table						// 38
s_needs; s_section
s_ass
s_rtap; s_goto; s_resultis; s_colon
s_test; s_for; s_if; s_unless								// 49
s_while; s_until; s_repeat; s_repeatwhile; s_repeatuntil
s_skip // Added 22/6/05
s_loop; s_break; s_return; s_finish
s_endcase; s_switchon; s_case; s_default					// 63
s_seq; s_let; s_and; s_manifest; s_global; s_static
s_valdef; s_vecdef; s_constdef; s_const
s_fndef; s_rtdef; s_local; s_label							// 77
*/

//	MANIFEST $(							// stack adjustments from the CintCode OCODE to the Windows BCPL system
  sspadjust		= 2
  sf1			= 1
  sf2			= 2

  free.global	= 177
//	$)


// OCODE keywords for the ng-CintCode system
s_noop=0

s_true=4
s_false=5
s_rv=8; s_fnap=10
s_mult=11; s_div=12; s_rem=13; s_plus=14; s_minus=15
s_query=16; s_neg=17; s_abs=19
s_eq=20; s_ne=21; s_ls=22; s_gr=23; s_le=24; s_ge=25
s_not=30; s_lshift=31; s_rshift=32; s_logand=33
s_logor=34; s_eqv=35; s_neqv=36
s_lf=39; s_lp=40; s_lg=41; s_ln=42; s_lstr=43
s_ll=44; s_llp=45; s_llg=46; s_lll=47
s_needs=48; s_section=49; s_rtap=51; s_goto=52; s_finish=68
s_switchon=70; s_global=76; s_sp=80; s_sg=81; s_sl=82; s_stind=83
s_jump=85; s_jt=86; s_jf=87; s_endfor=88
s_lab=90; s_stack=91; s_store=92; s_rstack=93; s_entry=94
s_save=95; s_fnrn=96; s_rtrn=97; s_res=98
s_datalab=100; s_iteml=101; s_itemn=102; s_endproc=103; s_char=105; s_none=111
s_getbyte=120; s_putbyte=121

s_end=200					// DC:	...added 8-Jun-2018, because cg-intcode.b needs it!
/*

// Other lexical token
s_be=78; s_lsect; s_rsect; s_get
s_semicolon; s_into; s_to; s_by; s_do; s_else
s_vec; s_lparen; s_rparen; s_sbra; s_sket; s_dot; s_eof		// 94
s_bitsperbcplword

// Used in the code generators
s_none														// 96

// Ocode operators
s_lf; s_lp; s_lg; s_ln; s_lstr; s_ll; s_llp; s_llg; s_lll 
s_sp; s_sg; s_sl; s_stind; s_jump; s_jt; s_jf; s_endfor		// 113
s_lab; s_stack; s_store; s_rstack; s_entry
s_save; s_fnrn; s_rtrn; s_res; s_datalab; s_itemn
s_endproc; s_getbyte; s_putbyte
s_end; s_debug; s_iteml; s_char								// 131

// The following have been added for the extended compiler xbcpl

// Floating point operators and assignment operators, added 15/07/10

s_fnum // Floating point constants							// 132
s_float; s_fix; s_fabs
s_fmul; s_fdiv; s_fadd; s_fsub;  s_fpos; s_fneg
s_feq; s_fne; s_fls; s_fgr; s_fle; s_fge					// 147

// Assign operators -- added 15/07/10
s_assvecap
s_assmul; s_assdiv; s_assrem; s_assadd; s_asssub			// 153
s_assfmul; s_assfdiv; s_assfadd; s_assfsub
s_asslshift; s_assrshift
s_asslogand; s_asslogor; s_asseqv; s_assneqv				// 163


s_selld; s_selst // Added 19/07/10

s_fltop  // FLTOP is followed by one of the fl. codes		// 166
         // eg FLTOP FADD to do a := b #+ a
         // or FLTOP FLOAT to do a := FLOAT a
*/
sf.none=0     // Assignment operators						// 167
sf.vecap
sf.fmul
sf.fdiv
sf.fadd
sf.fsub														// 172
sf.mul
sf.div
sf.rem
sf.add
sf.sub
sf.lshift													// 178
sf.rshift
sf.logand
sf.logor
sf.eqv
sf.neqv														// 183
$)




// Code Generator Globals:

GLOBAL
$(  rc:                  150
    fromfile:            151
    verstream:           152
    ocodestream:         153
    codestream:          154
    datvec:              155
    err.p:               156
    err.l:               157
    ocodefile:           158
    keepocode:           159

    // CG options

    cgworksize:          160
    cglisting:           161
    naming:              162
    callcounting:        163
    profcounting:        164
    stkchking:           165
    restricted:          166
    altobj:              167
    cg.a:                168
    cg.b:                169
    cg.y:                175
    cg.z:                176
$)



MANIFEST
$(  fg                 = 177		// next free GLOBAL
    ocbuflth           = 15			// length of circular buffer
$)


GLOBAL
$(  ch:         fg+0
    wordv:      fg+1
    sysprint:   fg+3
    sysin:      fg+4
    ssp:        fg+5
    state:      fg+6
    ad.a:       fg+7
    ad.k:       fg+8
    option:     fg+9
    datav:      fg+10
    datap:      fg+11
    datat:      fg+12
    proglength: fg+13
    linep:      fg+14
    param:      fg+15
    op:         fg+16
    readop:     fg+17
    rdn:        fg+18
    rdl:        fg+19
    gencode:    fg+20
    force.nil:  fg+21
    force.ad:   fg+22
    force.ac:   fg+23
    force.acad: fg+24
    swap:       fg+25
    load:       fg+26
    storein:    fg+27
    cgstring:   fg+28
    data:       fg+29
    nextparam:  fg+30
    code:       fg+31
    complab:    fg+32
    opcode:     fg+33
    wr:         fg+34
    wrn:        fg+35
    wrdata:     fg+36

    fixssp:     fg+40				// extra ssp adjustment for 's_stack'
    ocodebuf:   fg+41				// the OCODE circular buffer
	ocbufptr:   fg+42				// pointer within the OCODE buffer
    rocd:       fg+43

$)

MANIFEST $(
    m_n           = 0
    m_i           = 1
    m_p           = 2
    m_ip          = 3
    m_l           = 4
    m_il          = 5
    m_g           = 6
    m_ig          = 7
	m_f           = 8
	m_if          = 9
	
    f_l           = 'L'
    f_s           = 'S'
    f_a           = 'A'
    f_j           = 'J'
    f_t           = 'T'
    f_f           = 'F'
    f_k           = 'K'
    f_x           = 'X'
    f_d           = 'D'
    f_c           = 'C'
    nil           = 0
    ad            = 1
    ac            = 2
    acad          = 3
$)
