
MANIFEST $(
t_hunk  = 1000       // Object module item types.
t_bhunk = 3000       // binary hunk (not hex)
t_end   = 1002

sectword  = #xFDDF   // SECTION and Entry marker words.
entryword = #xDFDF

// OCODE keywords.
s_number=1
s_name=2; s_string=3; s_true=4; s_false=5
s_valof=6; s_lv=7; s_rv=8; s_vecap=9; s_fnap=10
s_query=11
s_neg=12; s_abs=13						// Integer operators
s_mult=14; s_div=15; s_rem=16; s_plus=17; s_minus=18
s_eq=19; s_ne=20; s_ls=21; s_gr=22; s_le=23; s_ge=24
s_slct=25; s_of=26						// Inserted 11/7/01
s_byteap=27; s_mthap=28
s_not=29; s_lshift=30; s_rshift=31; s_logand=32; s_logor=33
s_eqv=34; s_neqv=35; s_cond=36; s_comma=37; s_table=38
s_needs=39; s_section=40
s_ass=41
s_rtap=42; s_goto=43; s_resultis=44; s_colon=45
s_test=46; s_for=47; s_if=48; s_unless=49
s_while=50; s_until=51; s_repeat=52; s_repeatwhile=53; s_repeatuntil=54
s_skip=55								// Added 22/6/05
s_loop=56; s_break=57; s_return=58; s_finish=59
s_endcase=60; s_switchon=61; s_case=62; s_default=63
s_seq=64; s_let=65; s_and=66; s_manifest=67; s_global=68; s_static=69
s_valdef=70; s_vecdef=71; s_constdef=72; s_const=73
s_fndef=74; s_rtdef=75; s_local=76; s_label=77

// Other lexical tokens
s_be=78; s_lsect=79; s_rsect=80; s_get=81
s_semicolon=82; s_into=83; s_to=84; s_by=85; s_do=86; s_else=87
s_vec=88; s_lparen=89; s_rparen=90; s_sbra=91; s_sket=92; s_dot=93; s_eof=94

// Used in the code generators
s_none=95

// Ocode operators
s_lf=96; s_lp=97; s_lg=98; s_ln=99; s_lstr=100; s_ll=101; s_llp=102; s_llg=103; s_lll=104
s_sp=105; s_sg=106; s_sl=107; s_stind=108; s_jump=109; s_jt=110; s_jf=111; s_endfor=112
s_lab=113; s_stack=114; s_store=115; s_rstack=116; s_entry=117
s_save=118; s_fnrn=119; s_rtrn=120; s_res=121; s_datalab=122; s_itemn=123
s_endproc=124; s_getbyte=125; s_putbyte=126
s_end=127; s_debug=128; s_iteml=129; s_char=130

// The following have been added for the extended compiler xbcpl

// Floating point operators and assignment operators, added 15/07/10

s_fnum=131 // Floating point constants
s_float=132; s_fix=133; s_fabs=134
s_fmult=135; s_fdiv=136; s_fplus=137; s_fminus=138;  s_fpos=139; s_fneg=140
s_feq=141; s_fne=142; s_fls=143; s_fgr=144; s_fle=145; s_fge=146

// Assign operators -- added 15/07/10
s_assvecap=147
s_assmult=148; s_assdiv=149; s_assrem=150; s_assplus=151; s_assminus=152
s_assfmult=153; s_assfdiv=154; s_assfplus=155; s_assfminus=156
s_asslshift=157; s_assrshift=158
s_asslogand=159; s_asslogor=160; s_asseqv=161; s_assneqv=162


s_selld=163; s_selst=164				// Added 19/07/10

s_fltop=165	// FLTOP is followed by one of the fl_ codes
			// eg FLTOP FPLUS to do a := b #+ a
			// or FLTOP FLOAT to do a := FLOAT a


h1=0; h2=1; h3=2  // Selectors.
$)
