// This is an OCODE to Intcode codegenerator dated 1982 approx

//    CGHDR


GET "LIBHDR"

// OCODE OPERATORS
/*
MANIFEST
$(	// OCODE keywords for the ng-CintCode system
    s_noop=0

    s_true=4
    s_false=5

    s_rv=8

    s_fnap=10
    s_mult=11
    s_div=12
    s_rem=13
    s_plus=14
    s_minus=15
    s_query=16
    s_neg=17

    s_abs=19
    s_eq=20
    s_ne=21
    s_ls=22
    s_gr=23
    s_le=24
    s_ge=25

    s_not=30
    s_lshift=31
    s_rshift=32
    s_logand=33
    s_logor=34
    s_eqv=35
    s_neqv=36

    s_lf=39
    s_lp=40
    s_lg=41
    s_ln=42
    s_lstr=43
    s_ll=44
    s_llp=45
    s_llg=46
    s_lll=47
    s_needs=48
    s_section=49

    s_rtap=51
    s_goto=52

    s_finish=68
    s_switchon=70

    s_global=76

    s_sp=80
    s_sg=81
    s_sl=82
    s_stind=83

    s_jump=85
    s_jt=86
    s_jf=87
    s_endfor=88

    s_lab=90
    s_stack=91
    s_store=92
    s_rstack=93
    s_entry=94
    s_save=95
    s_fnrn=96
    s_rtrn=97
    s_res=98

    s_datalab=100
    s_iteml=101
    s_itemn=102
    s_endproc=103

    s_char=105

    s_none=111

    s_getbyte=120
    s_putbyte=121

    s_end=200					// DC:	...added 8-Jun-2018, because cg-intcode.b needs it!
$)
*/



// Code Generator Globals:

GLOBAL
$(  rc:                  150
    fromfile:            151
    verstream:           152
    ocodestream:         153
    codestream:          154
    datvec:              155
    err.p:               156
    err.l:               157
    ocodefile:           158
    keepocode:           159

    // CG options

    cgworksize:          160
    cglisting:           161
    naming:              162
    callcounting:        163
    profcounting:        164
    stkchking:           165
    restricted:          166
    altobj:              167
    cg.a:                168
    cg.b:                169
    cg.y:                175
    cg.z:                176
$)




MANIFEST $(
    m_n           = 0
    m_i           = 1
    m_p           = 2
    m_ip          = 3
    m_l           = 4
    m_il          = 5
    m_g           = 6
    m_ig          = 7
	m_f           = 8
	m_if          = 9
	
    f_l           = 'L'
    f_s           = 'S'
    f_a           = 'A'
    f_j           = 'J'
    f_t           = 'T'
    f_f           = 'F'
    f_k           = 'K'
    f_x           = 'X'
    f_d           = 'D'
    f_c           = 'C'
    nil           = 0
    ad            = 1
    ac            = 2
    acad          = 3
$)





.

SECTION "IC-CG1"



//    CG1

GET "libhdr"
GET "CGhdr"



STATIC
$(  wp = 0
    strsize = 0
$)




/*	This code reads from character format OCODE files (pre-1982!)
LET T(S) = VALOF
      $( FOR I = 0 TO STRSIZE DO UNLESS S!I=WORDV!I RESULTIS FALSE
         RESULTIS TRUE  $)

LET old.READOP() = VALOF
    $(1 LET S = VEC 20

        CH := RDCH() REPEATWHILE CH='*N' \/ CH='*S'
        WP := 0

        WHILE 'A'<=CH<='Z' DO
           $( WP := WP + 1
              S!WP := CH
              CH := RDCH()  $)

        S!0 := WP
        STRSIZE := PACKSTRING(S, WORDV)

        SWITCHON S!1 INTO
     $( DEFAULT: IF CH=ENDSTREAMCH RESULTIS S.END
                 RESULTIS ERROR

        CASE 'D':
        RESULTIS T("DATALAB") -> S.DATALAB,
                 T("DIV") -> S.DIV,
                 T("DEBUG") -> S.DEBUG, ERROR

        CASE 'E':
        RESULTIS T("EQ") -> S.EQ,
                 T("ENTRY") -> S.ENTRY,
                 T("EQV") -> S.EQV,
                 T("ENDPROC") -> S.ENDPROC,
                 T("END") -> S.END, ERROR

        CASE 'F':
        RESULTIS T("FNAP") -> S.FNAP,
                 T("FNRN") -> S.FNRN,
                 T("FALSE") -> S.FALSE,
                 T("FINISH") -> S.FINISH, ERROR


        CASE 'G':
        RESULTIS T("GOTO") -> S.GOTO,
                 T("GE") -> S.GE,
                 T("GR") -> S.GR,
                 T("GLOBAL") -> S.GLOBAL, ERROR

        CASE 'I':
        RESULTIS T("ITEMN") -> S.ITEMN,
                 T("ITEML") -> S.ITEML,  ERROR

        CASE 'J':
        RESULTIS T("JUMP") -> S.JUMP,
                 T("JF") -> S.JF,
                 T("JT") -> S.JT,  ERROR

        CASE 'L':
        IF WP=2 DO
             SWITCHON S!2 INTO
             $( DEFAULT: RESULTIS ERROR
                CASE 'E': RESULTIS S.LE
                CASE 'N': RESULTIS S.LN
                CASE 'G': RESULTIS S.LG
                CASE 'P': RESULTIS S.LP
                CASE 'L': RESULTIS S.LL
                CASE 'S': RESULTIS S.LS  $)

        RESULTIS T("LAB") -> S.LAB,
                 T("LLG") -> S.LLG,
                 T("LLL") -> S.LLL,
                 T("LLP") -> S.LLP,
                 T("LOGAND") -> S.LOGAND,
                 T("LOGOR") -> S.LOGOR,
                 T("LSHIFT") -> S.LSHIFT,
                 T("LSTR") -> S.LSTR, ERROR

        CASE 'M':
        RESULTIS T("MINUS") -> S.MINUS,
                 T("MULT") -> S.MULT, ERROR

        CASE 'N':
        RESULTIS  T("NE") -> S.NE,
                  T("NEG") -> S.NEG,
                  T("NEQV") -> S.NEQV,
                  T("NOT") -> S.NOT,  ERROR

        CASE 'P':
        RESULTIS T("PLUS") -> S.PLUS, ERROR

        CASE 'Q':
        RESULTIS T("QUERY") -> S.QUERY, ERROR

        CASE 'R':
        RESULTIS T("RES") -> S.RES,
                 T("REM") -> S.REM,
                 T("RTAP") -> S.RTAP,
                 T("RTRN") -> S.RTRN,
                 T("RSHIFT") -> S.RSHIFT,
                 T("RSTACK") -> S.RSTACK,
                 T("RV") -> S.RV, ERROR

        CASE 'S':
        RESULTIS T("SG") -> S.SG,
                 T("SP") -> S.SP,
                 T("SL") -> S.SL,
                 T("STIND") -> S.STIND,
                 T("STACK") -> S.STACK,
                 T("SAVE") -> S.SAVE,
                 T("SWITCHON") -> S.SWITCHON,
                 T("STORE") -> S.STORE, ERROR

        CASE 'T':
        RESULTIS T("TRUE") -> S.TRUE, ERROR
    $)
$)1
	*/




LET readop() = VALOF
// this version of READOP deals with INTEGER type OCODE
$(  LET a, neg = 0, FALSE
    ch := rdch() REPEATWHILE ch='*N' \/ ch='*S'
    TEST ch=endstreamch THEN a := s_end ELSE
    $(  IF ch='-' THEN
        $(  neg := TRUE
            ch := rdch()
        $)
        WHILE '0' LE ch LE '9' DO
        $(  a := a*10 +ch - '0'
            ch := rdch()
        $)

    $)
    RESULTIS (neg -> -a, a)
$)




AND rdn() = VALOF
$(  // reads a number from the OCODE file
    LET a, neg = 0, FALSE
    ch := rdch() REPEATWHILE ch='*N' \/ ch='*S'
    IF ch='-' THEN
    $(  neg := TRUE
        ch := rdch()
    $)
    WHILE '0' LE ch LE '9' DO
    $(  a := a*10 +ch - '0'
        ch := rdch()
    $)
    RESULTIS (neg -> -a, a)
$)




AND rdl() = VALOF
// reads an OCODE label
    $(1 LET a = 0

        ch := rdch() REPEATWHILE ch='*N' \/ ch='*S'

        IF ch='L' DO ch := rdch()

        WHILE '0' LE ch LE '9' DO
                  $( a := a*10 + ch - '0'
                     ch := rdch()  $)

        RESULTIS a   $)1






.


SECTION "IC-CG2"


//    CG2


GET "libhdr"
GET "CGhdr"

LET gencode() BE
$(rpt
 /* selectoutput(sysprint)					// diagnostics...
    writef("op=%n*n", op)
    selectoutput(codestream)
 */
    SWITCHON op INTO
    $(  DEFAULT:
            selectoutput(sysprint)
            writef("IC-CG: unknown OCODE number:  %N*N", op)
            selectoutput(codestream)
            ENDCASE

        CASE s_noop:
            ENDCASE

        CASE s_none:    CASE s_end:  // CASE 0:
            RETURN
/*
        CASE s_debug:
            selectoutput(sysprint)
            writef("IC-CG: STATE=%N, SSP=%N, AD.A=%N, AD.K=%N*N",
                            state,    ssp,    ad.a,    ad.k)
            selectoutput(codestream)
            ENDCASE
*/
		CASE s_section:
				$(	MANIFEST $( upb=11 $)		// Max length of entry name
					LET n = rdn()
					
					IF naming DO $(
					wr('N'); wrn(upb); wr('*S')
						// Output up to 11 character of the name including the first and last five.
						TEST n<=upb
						THEN $( FOR i = 1 TO n DO $( wr('C'); wrn(rdn()); wr('*S') $)
								FOR i = n+1 TO upb DO $( wr('C'); wrn('*S'); wr('*S') $)
							$)
						ELSE $( FOR i = 1 TO 5   DO $( wr('C'); wrn(rdn()); wr('*S') $)
								FOR i = 6 TO n-6 DO rdn() // Ignore the middle characters
								FOR i = 6 TO upb  DO $( wr('C'); wrn(rdn()); wr('*S') $)
							$)
						$)
//					op := rdn()
					ENDCASE
				$)

        CASE s_needs:
            wr('*N')
            writes("/ NEEDS ")
            FOR i=1 TO rdn() DO wrch(rdn())
            wr('*N')
            ENDCASE

        CASE s_lp:
            load(rdn(), m_ip)
            ENDCASE

        CASE s_lg:
            load(rdn(), m_ig)
            ENDCASE

        CASE s_ll:
            load(rdl(), m_il)
            ENDCASE

        CASE s_ln:
            load(rdn(), m_n)
            ENDCASE

        CASE s_lf:
            load(rdl(), m_f)
            ENDCASE

        CASE s_lstr:
            cgstring(rdn())
            ENDCASE

        CASE s_true:
            load(-1, m_n)
            ENDCASE

        CASE s_false:
            load(0, m_n)
            ENDCASE

        CASE s_llp:
            load(rdn(), m_p)
            ENDCASE

        CASE s_llg:
            load(rdn(), m_g)
            ENDCASE

        CASE s_lll:
            load(rdl(), m_l)
            ENDCASE

        CASE s_sp:
            storein(rdn(), m_p)
            ENDCASE

        CASE s_sg:
            storein(rdn(), m_g)
            ENDCASE

        CASE s_sl:
            storein(rdl(), m_l)
            ENDCASE

        CASE s_stind:
            force.acad()
            code(f_s, ad.a, ad.k)
            ssp, state := ssp-2, nil
            ENDCASE

        CASE s_putbyte:
            // args on the stack are as follows:
            //         top of stack  ->  arg1
            //                           arg2
            //                           arg3
            // where the operation is  ARG2%ARG1 := ARG3
            force.nil()
            code(f_l, ssp-3, m_p)    // load address of vector on stack!
            code(f_x, opcode(s_putbyte), m_n)
            ssp := ssp-3
            state := nil
            ENDCASE

        CASE s_mult:    CASE s_div:     CASE s_rem:
        CASE s_minus:   CASE s_eq:      CASE s_ne:
        CASE s_ls:      CASE s_gr:      CASE s_le:
        CASE s_ge:      CASE s_lshift:  CASE s_rshift:
        CASE s_logand:  CASE s_logor:   CASE s_neqv:
        CASE s_eqv:     CASE s_getbyte:
            force.acad()
            code(f_l, ad.a, ad.k)
            code(f_x, opcode(op), m_n)
            state, ssp := ac, ssp-1
            ENDCASE

        CASE s_rv:      CASE s_neg:     CASE s_not:
        CASE s_abs:
            force.ac()
            code(f_x, opcode(op), m_n)
            ENDCASE

        CASE s_plus:
            force.acad()
            code(f_a, ad.a, ad.k)
            state, ssp := ac, ssp-1
            ENDCASE

        CASE s_jump:
            force.nil()
            code(f_j, rdl(), m_l)
            ENDCASE

        CASE s_jt:      CASE s_jf:
            force.ac()
            code(op=s_jt->f_t,f_f, rdl(), m_l)
            ssp, state := ssp-1, nil
            ENDCASE

        CASE s_endfor:
            // Simulate the effect of the OCODE
            //       MINUS LN 0 LE JT
            // the label follows the ENDFOR code
            force.acad()
            code(f_l, ad.a, ad.k)
            code(f_x, opcode(s_minus), m_n)
            state := ac
            ssp := ssp - 1
            load(0, m_n)
            code(f_l, ad.a, ad.k)
            code(f_x, opcode(s_le), m_n)
            code(f_t, rdl(), m_l)
            ssp := ssp - 2
            state := nil
            ENDCASE

        CASE s_goto:
            force.ad()
            code(f_j, ad.a, ad.k)
            ssp, state := ssp-1, nil
            ENDCASE

        CASE s_lab:
            force.nil()
            complab(rdl())
            ENDCASE

        CASE s_query:
            force.nil()
            ssp := ssp + 1
            ENDCASE

        CASE s_stack:
            force.nil()
            ssp := rdn()
            ENDCASE

        CASE s_store:
            force.nil()
            ENDCASE

        CASE s_entry:
            $(  LET l = rdl()
                LET n = rdn()
                wr('*n'); wr('$'); wr('*s'); wr('/')
                FOR i = 1 TO n DO wr(rdn()) // Write the function name
                wr('*n'); wr(' ')
                complab(l)
            //  state, ad_a, ad_k := NIL, 0, m_n
            /*  wr('*N')
                wr('$')
                FOR i = 1 TO n DO rdn()
                wr(' ')
                complab(l)
            */  ENDCASE
            $)

        CASE s_save:
            ssp := rdn()
            ENDCASE

        CASE s_endproc:
         // rdn()
            ENDCASE

        CASE s_rtap:    CASE s_fnap:
            $(  LET k = rdn()
                force.ac()
                code(f_k, k, m_n)
                TEST op=s_fnap THEN
                $(  ssp := k+1
                    state := ac
                $) ELSE
                $(  ssp := k
                    state := nil
                $)
                ENDCASE
            $)

        CASE s_fnrn:
            force.ac()
            ssp := ssp - 1
        CASE s_rtrn:
            code(f_x, opcode(s_rtrn), m_n)
            state := nil
            ENDCASE

        CASE s_res:
            force.ac()
            code(f_j, rdl(), m_l)
            ssp, state := ssp-1, nil
            ENDCASE

        CASE s_rstack:
            force.nil()
            ssp, state := rdn()+1, ac
            ENDCASE

        CASE s_finish:
            code(f_x, opcode(op), m_n)
            ENDCASE

        CASE s_switchon:
            $(  LET n = rdn()
                LET d = rdl()
                force.ac()
                code(f_x, opcode(op), m_n)
                code(f_d, n, m_n)
                code(f_d, d, m_l)
                ssp, state := ssp-1, nil
                FOR i = 1 TO n DO
                $(  code(f_d, rdn(), m_n)
                    code(f_d, rdl(), m_l)
                $)
                ENDCASE
            $)

        CASE s_global:
            wr('*N')
            FOR i = 0 TO datap-2 BY 2 DO wrdata(datav!i, datav!(i+1))
            wr('*N')
            FOR i = 1 TO rdn() DO
            $(  wr('G')
                wrn(rdn())
                wr('L')
                wrn(rdl())
                wr('*S')
            $)
            wr('*N')
            wr('Z')
            wr('*N')
            RETURN

        CASE s_datalab:
        CASE s_iteml:
            data(op, rdl())
            ENDCASE

        CASE s_itemn:
            data(op, rdn())
            ENDCASE
    $)

    op := readop()

$)rpt REPEAT







.

SECTION "IC-CG3"



//    CG3


GET "libhdr"
GET "CGhdr"




//
//  This code deals with the generation of INTCODE for loads and stores.
//


//  The INTCODE stack may be in one of four states (kept in STATE):
//
//     STATE = NIL
//          top of stack - (offset SSP-1) - in stack frame
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//          No pending load
//
//     STATE = AC
//          top of stack - (offset SSP-1) - in INTCODE register A
//          second of stack - (offset SSP-2) - in stack frame
//          No pending load
//
//     STATE = AD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//
//     STATE = ACAD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in INTCODE register A
//
//  The two variables AD.A and AD.K hold the address and address modifier
//  of a pending load.  This load will be performed when next necessary.

// LOADS are made into variables on the stack - and hence use M.IP
// STORES are made from addresses on the stack - and hence use M.P







LET force.nil() BE
// Forces NIL state - so that INTCODE register A is empty and there are
// no pending loads.
    SWITCHON state INTO
    $(  CASE acad:
            code(f_s, ssp-2, m_p)
        CASE ad:
            code(f_l, ad.a, ad.k)
        CASE ac:
            code(f_s, ssp-1, m_p)
            state := nil
        CASE nil:
    $)




AND force.ad() BE
// Forces AD state in which the variables AD.A and AD.K hold details of a
// pending load and INTCODE register A is empty.
    SWITCHON state INTO
    $(  CASE acad:
            code(f_s, ssp-2, m_p)
            GOTO l

        CASE ac:
            code(f_s, ssp-1, m_p)
        CASE nil:
            ad.a := ssp-1
            ad.k := m_ip
l:          state := ad
        CASE ad:
    $)




AND force.ac() BE
// Forces AC state in which the INTCODE register A holds the top of stack
// and there are no pending loads.
    SWITCHON state INTO
    $(  CASE nil:
            code(f_l, ssp-1, m_ip)
            GOTO l

        CASE acad:
            code(f_s, ssp-2, m_p)
        CASE ad:
            code(f_l, ad.a, ad.k)
l:          state := ac
        CASE ac:
    $)





AND force.acad() BE
// Forces state ACAD in which AD.A and AD.K hold details of the pending
// load of the top of stack and INTCODE register A holds the next of stack.
    SWITCHON state INTO
    $(  CASE ad:
            code(f_l, ssp-2, m_ip)
            GOTO l

        CASE ac:
            code(f_s, ssp-1, m_p)
        CASE nil:
            code(f_l, ssp-2, m_ip)
            ad.a := ssp-1
            ad.k := m_ip
l:          state := acad
        CASE acad:
    $)




AND swap() BE
// This procedure swaps the top two elements on the stack represented
// in state STATE and leaves the stack in state ACAD.  (with the top
// two registers pending and in the A register respectively).
$(  state := acad   // for most of them:
    SWITCHON state INTO
    $(  CASE nil:
            // load A register with the top of stack:
            code(f_l, ssp-1, m_ip)
            ENDCASE

        CASE ad:
            // Do pending load
            code(f_l, ad.a, ad.k)

        CASE ac:
            // Store A into top of stack (instead of second of stack)
            code(f_s, ssp-1, m_p)
            ENDCASE

        CASE acad:
            // We want to load the stack in the order
            //       <pending load>
            //       <intcode register A>
            // this would mean saving register A whilst it is used for
            // stacking the pending load.  However, we can save the
            // intcode register A first if we are sure that it does not
            // affect the pending load which will have to be done subsequently
            // - i.e. so long as the pending load is not from the top
            // of stack to which we will write register A.
            TEST ad.a=ssp-1 & (ad.k=m_p | ad.k=m_ip) THEN
            $(  // too bad - we'll have to save A first
                code(f_s, ssp, m_p)
                code(f_l, ad.a, ad.k)   // do pending load
                code(f_s, ssp-2, m_p)   // put in swapped position
                code(f_l, ssp, m_p)     // get A back
                state := ac
            $) ELSE
            $(  code(f_s, ssp-1, m_p)
                code(f_l, ad.a, ad.k)
                code(f_s, ssp-2, m_p)   // put back into second of stack
                state := nil
            $)
    $)
    ad.a := ssp-2      // for when STATE = AD or ACAD
    ad.k := m_ip
$)





AND load(a, k) BE
// A - the new contents of the accumulator A
// K - the kind (mode) in which the operand is to be fetched
//     (an M.<flags> constant typically)
// This procedure frees the pending load given in AD.A and AD.K (if there
// is one) and then loads A and K into them.
    SWITCHON state INTO
    $( CASE nil: state := ad
                 GOTO m

       CASE acad:
       CASE ad:  force.ac()
       CASE ac:  state := acad
       m:        ad.a, ad.k := a, k
                 ssp := ssp + 1
    $)





AND storein(a, k) BE
$(  force.ac()
    code(f_s, a, k)
    ssp, state := ssp-1, nil
$)




AND cgstring(n) BE
$(1 LET l = nextparam()
    data(s_datalab, l)
    data(s_char, n)
    FOR i = 1 TO n DO data(s_char, rdn())
    load(l, m_l)
$)1




AND data(k, v) BE
$(  LET p = datap
    datav!p, datav!(p+1) := k, v
    datap := datap + 2
    IF datap>datat THEN
    $(  selectoutput(sysprint)
        writes("IC-CG: too many constants*N")
        selectoutput(codestream)
        datap := 0
    $)
$)




AND nextparam() = VALOF
$(  param := param - 1

    IF  param < 0  THEN
    $(
        selectoutput( sysprint )
        writes( "IC-CG:  too many labels (!)*N" )
        selectoutput( codestream )

        param  :=  100  // ????
    $)

    RESULTIS param
$)





.

SECTION "IC-CG4"



//    CG4


GET "libhdr"
GET "CGhdr"




LET code(f, a, k) BE
// F - function = F.L  F.S  F.A  F.J  F.T  F.F  F.K  or  F.X
// A - data (D field in INTCODE)
// K - mode in which data is to be fetched, one of:
//        M.N    -  normal
//        M.I    -  indirect
//        M.IG   -  indirect global
//        M.P    -  local variable (relative to stack frame)
//        M.IP   -  indirect local
//        M.L    -  label
//        M.IL   -  indirect label
//        M.F    -  function
//        M.IF   -  indirect function
$(  wr(f)
    SWITCHON k INTO
    $( CASE m_i: wr('I')
       CASE m_n: ENDCASE

       CASE m_ig: wr('I')
       CASE m_g:  wr('G'); ENDCASE

       CASE m_ip: wr('I')
       CASE m_p:  wr('P'); ENDCASE

       CASE m_il: wr('I')
       CASE m_l:  wr('L'); ENDCASE

       CASE m_if: wr('I')
       CASE m_f:  wr('F'); ENDCASE  $)

    wrn(a)
    wr(' ')
    proglength := proglength + 1
$)





AND complab(n) BE
$(  // writes out an INTCODE label
    wrn(n)
    wr(' ')
$)



AND wrdata(k, n) BE
// writes out an OCODE data item in INTCODE
    SWITCHON k INTO
    $(  CASE s_datalab: complab(n); RETURN

        CASE s_itemn: code(f_d, n, m_n); RETURN

        CASE s_iteml: code(f_d, n, m_l); RETURN

        CASE s_char:  code(f_c, n, m_n); RETURN
    $)




AND opcode(op) = VALOF
// returns INTCODE number <n> in X<n> for OCODE opcode OP
    SWITCHON op INTO
    $(  CASE s_rv:    RESULTIS 1
        CASE s_neg:   RESULTIS 2
        CASE s_not:   RESULTIS 3
        CASE s_rtrn:  RESULTIS 4
        CASE s_mult:  RESULTIS 5
        CASE s_div:   RESULTIS 6
        CASE s_rem:   RESULTIS 7
        CASE s_plus:  RESULTIS 8
        CASE s_minus: RESULTIS 9
        CASE s_eq:    RESULTIS 10
        CASE s_ne:    RESULTIS 11
        CASE s_ls:    RESULTIS 12
        CASE s_ge:    RESULTIS 13
        CASE s_gr:    RESULTIS 14
        CASE s_le:    RESULTIS 15
        CASE s_lshift:RESULTIS 16
        CASE s_rshift:RESULTIS 17
        CASE s_logand:RESULTIS 18
        CASE s_logor: RESULTIS 19
        CASE s_neqv:  RESULTIS 20
        CASE s_eqv:   RESULTIS 21
        CASE s_finish:RESULTIS 22
        CASE s_switchon:RESULTIS 23
        CASE s_getbyte:RESULTIS 36
        CASE s_putbyte:RESULTIS 37
        CASE s_abs:    RESULTIS 44

        DEFAULT: selectoutput(sysprint)
                 writef("IC-CG: unknown op %N*N", op)
                 selectoutput(codestream)
                 RESULTIS 0
    $)


AND wr(ch) BE
$(  IF ch='*N' THEN
    $(  wrch('*N')
        linep := 0
        RETURN
    $)

    IF linep=71 THEN
    $(  wrch('/')
        wrch('*N')
        linep := 0
    $)
    linep := linep + 1
    wrch(ch)
$)




//AND wrn(n) BE
//$(  IF n<0 THEN
//    $(  wr('-')
//        n := -n
//    $)
//    IF n>9 DO wrn(n/10)
//    wr(n REM 10 + '0')
//$)

AND wrn (n) BE
$( LET t    = VEC 10
   LET i, k = 0, -n

   IF n<0 DO k := n
   t!i, k, i := -(k REM 10), k/10, i+1 REPEATUNTIL k=0
   IF n<0 THEN wr('-')
   FOR j = i-1 TO 0 BY -1 DO wr(t!j+'0')
$)




.


SECTION "IC-CG5"



//    CG5


GET "libhdr"
GET "CGhdr"



LET start() BE
$(  LET workspace = ?
    LET v = VEC 50
    writes("Intcode CG (December 1982)*N")
    err.p , err.l := level() , exit.label
    wordv := v
    sysin := input()
    sysprint := output()

 // writef("argc=%n, argv!1=%n*n", argc, argv!1)
	ocodefile := argc>0 -> argv!0, input()
	codestream := argc>1 -> findoutput(argv!1), output()
 // writef("ocodefile = '%s'*n", ocodefile)
	cgworksize := 10000

	ocodestream := findinput(ocodefile)
    IF ocodestream = 0 THEN
    $(  writef("IC-CG: Can't open *"%S*"*N", ocodefile)
        exit(20)
    $)

    workspace := getvec(cgworksize)
    TEST workspace=0 THEN
    $(  writef("IC-CG: Can't get %N words for CG workspace*N", cgworksize)
        exit(20)
    $) ELSE
    $(  datav := workspace
        datat := cgworksize
    $)

    proglength := 0

    selectinput(ocodestream)
    selectoutput(codestream)
	naming := TRUE

    $(rpt
        op := readop()
	 // writef("op=%n*n", op)
     /* IF op=s_section THEN
        $(  wr('*N')
            writes("/ SECTION ")
            FOR i=1 TO rdn() DO wrch(rdn())
            wr('*N')
            op := readop()
        $)
     */ ssp, state := 2, nil
        datap, linep,  param := 0, 0, 1000
        gencode()
    $)rpt REPEATUNTIL op=s_end

    selectoutput(sysprint)
    writef("Program size = %N words*N", proglength)
    exit(0)

exit.label:
    RETURN
$)



AND exit(n) BE
$(  UNLESS ocodestream=0 THEN
    $(  selectinput(ocodestream)
        endread()
        ocodestream := 0
    $)
    selectinput(sysin)
    selectoutput(sysprint)

    UNLESS datav=0 THEN freevec(datav)

    rc := n

    longjump(err.p, err.l)
$)

