
GET "trnhdr_ng"

LET nextlab() = VALOF
$( labnumber := labnumber + 1
   RESULTIS labnumber
$)
 
AND trnerr(mess, a) BE
$( LET fno = comline>>24
   LET lno = comline & #xFFFFFF
   LET filename = sourcenamev!fno
   writes("Error ")
   UNLESS procname=0 DO writef("in %s ", @h3!procname)
   writef("near ")
   IF filename DO writef("%s", filename)
   writef("[%n]: ", lno)
   writef(mess, a)
   newline()
   errcount := errcount + 1
   IF errcount >= errmax DO $( writes("*nCompilation aborted*n")
                               longjump(fin_p, fin_l)
                            $)
$)

AND newblk(x, y, z) = VALOF
$( LET p = dvect - 3
   IF dvece>p DO $( errmax := 0        // Make it fatal.
                    trnerr("More workspace needed")
                 $)
   p!0, p!1, p!2 := x, y, z
   dvect := p
   RESULTIS p
$)

AND translate(x) BE
$( dvec,  dvect := treevec, treep
   h1!dvec, h2!dvec, h3!dvec := 0, 0, 0
   dvece := dvec+3
   dvecp := dvece
// selectoutput(sysprint)
   FOR i = 0 TO nametablesize-1 DO
   $( LET name = nametable!i
      UNTIL name=0 DO
      $( LET next = h2!name
         h2!name := 0 // Mark undeclared
//		 writef("Undeclare %s*n", name+2)
         name := next
      $)
   $)

   gdeflist, gdefcount := 0, 0
   caselist, casecount, defaultlab := 0, -1, 0
   resultlab, breaklab, looplab, endcaselab := -2, -2, -2, -2
   context, comline, procname, labnumber := 0, 1, 0, 0
   ssp, vecssp := savespacesize, savespacesize

   WHILE x\=0 & (h1!x=s_section | h1!x=s_needs) DO
   $( LET op, a = h1!x, h2!x
      out1(op)
      outstring(@h2!a)
      x:=h3!x
   $)

   trans(x, 0)
   out2(s_global, gdefcount)
   UNTIL gdeflist=0 DO $( out2(h2!gdeflist, h3!gdeflist)
                          gdeflist := h1!gdeflist
                       $)  
$)

LET trnext(next) BE $( IF next<0 DO out1(s_rtrn)
                       IF next>0 DO out2(s_jump, next)
                    $)
 
LET trans(x, next) BE
// x       is the command to translate
// next<0  compile x followed by RTRN
// next>0  compile x followed by JUMP next
// next=0  compile x only
$( LET sw = FALSE
   IF x=0 DO $( trnext(next); RETURN $)
 
   SWITCHON h1!x INTO
   $( DEFAULT: trnerr("Compiler error in Trans"); RETURN
 
      CASE s_let:
      $( LET cc = casecount
         LET e, s, s1 = dvece, ssp, 0
         LET v = vecssp
         casecount := -1 // Disallow CASE and DEFAULT labels
         context, comline := x, h4!x
         declnames(h2!x)
         checkdistinct(e)
         vecssp, s1 := ssp, ssp
         ssp := s
         context, comline := x, h4!x
         transdef(h2!x)
         UNLESS ssp=s1 DO trnerr("Lhs and rhs do not match")
         UNLESS ssp=vecssp DO $( ssp := vecssp; out2(s_stack, ssp) $)
         out1(s_store)
         decllabels(h3!x)
         trans(h3!x, next)
         vecssp := v
         UNLESS ssp=s DO out2(s_stack, s)
         ssp := s
         casecount := cc
         undeclare(e)
         RETURN
      $)
 
      CASE s_static:
      CASE s_global:
      CASE s_manifest:
      $( LET cc = casecount
         LET e, s = dvece, ssp
         AND op = h1!x
         AND y, n = h2!x, 0
         LET prevk = -1
         
         casecount := -1 // Disallow CASE and DEFAULT labels
         context, comline := x, h4!x
 
         UNTIL y=0 DO
         $( context, comline := y, h5!y
            n := h4!y -> evalconst(h4!y), prevk+1
            context, comline := y, h5!y
            prevk := n
            IF op=s_static DO $( LET k = n
                                 n := nextlab()
                                 out2(s_datalab, n)
                                 out2(s_itemn, k)
                              $)
            IF op=s_global UNLESS 0<=n<=65535 DO
               trnerr("Global number too large for: %s*n", @h3!(h3!y))
            addname(h3!y, op, n)
            IF xrefing DO xref(h3!y,
                               (op=s_global->"G:",op=s_static->"S:","M:"),
                               n,
                               s_constdef
                              )
            y := h2!y
         $)
 
         decllabels(h3!x)
         trans(h3!x, next)
         ssp := s
         casecount := cc
         undeclare(e)
         RETURN
      $)
 
 
      CASE s_ass:
         context, comline := x, h4!x
         assign(h2!x, h3!x)
         trnext(next)
         RETURN
 
      CASE s_rtap:
      $( LET s = ssp
         context, comline := x, h4!x
         ssp := ssp+savespacesize
         out2(s_stack, ssp)
         loadlist(h3!x)
         load(h2!x)
         out2(s_rtap, s)
         ssp := s
         trnext(next)
         RETURN
      $)
 
      CASE s_goto:
         context, comline := x, h3!x
         load(h2!x)
         out1(s_goto)
         ssp := ssp-1
         RETURN
 
      CASE s_colon:
         context, comline := x, h5!x
         out2(s_lab, h4!x)
         trans(h3!x, next)
         RETURN
 
      CASE s_unless: sw := TRUE
      CASE s_if:
         context, comline := x, h4!x
         TEST next>0 THEN $( jumpcond(h2!x, sw, next)
                             trans(h3!x, next)
                          $)
                     ELSE $( LET l = nextlab()
                             jumpcond(h2!x, sw, l)
                             trans(h3!x, next)
                             out2(s_lab, l)
                             trnext(next)
                          $)
         RETURN
 
      CASE s_test:
      $( LET l, m = nextlab(), 0
         context, comline := x, h5!x
         jumpcond(h2!x, FALSE, l)
         
         TEST next=0 THEN $( m := nextlab(); trans(h3!x, m) $)
                     ELSE trans(h3!x, next)
                     
         out2(s_lab, l)
         trans(h4!x, next)
         UNLESS m=0 DO out2(s_lab, m)
         RETURN
      $)
 
      CASE s_loop:
         context, comline := x, h2!x
         IF looplab<0 DO trnerr("Illegal use of LOOP")
         IF looplab=0 DO looplab := nextlab()
         out2(s_jump, looplab)
         RETURN
 
      CASE s_break:
         context, comline := x, h2!x
         IF breaklab=-2 DO trnerr("Illegal use of BREAK")
         IF breaklab=-1 DO $( out1(s_rtrn); RETURN $)
         IF breaklab= 0 DO breaklab := nextlab()
         out2(s_jump, breaklab)
         RETURN
 
      CASE s_return:
         context, comline := x, h2!x
         out1(s_rtrn)
         RETURN
 
      CASE s_finish:
         context, comline := x, h2!x
         out1(s_finish)
         RETURN
 
      CASE s_resultis:
         context, comline := x, h3!x
         IF resultlab=-1 DO $( fnbody(h2!x); RETURN $)
         UNLESS resultlab>0 DO trnerr("RESULTIS out of context")
         load(h2!x)
         out2(s_res, resultlab)
         ssp := ssp - 1
         RETURN
 
      CASE s_while: sw := TRUE
      CASE s_until:
      $( LET l, m = nextlab(), next
         LET bl, ll = breaklab, looplab
         context, comline := x, h4!x
         breaklab, looplab := next, 0
         IF next<=0 DO m := nextlab()
         IF next =0 DO breaklab := m
         jumpcond(h2!x, \sw, m)
         out2(s_lab, l)
         trans(h3!x, 0)
         UNLESS looplab=0 DO out2(s_lab, looplab)
         context, comline := x, h4!x
         jumpcond(h2!x, sw, l)
         IF next<=0 DO out2(s_lab, m)
         trnext(next)
         breaklab, looplab := bl, ll
         RETURN
      $)
 
      CASE s_repeatwhile: sw := TRUE
      CASE s_repeatuntil:
      $( LET l, bl, ll = nextlab(), breaklab, looplab
         context, comline := x, h4!x
         breaklab, looplab := next, 0
         out2(s_lab, l)
         trans(h2!x, 0)
         UNLESS looplab=0 DO out2(s_lab, looplab)
         context, comline := x, h4!x
         jumpcond(h3!x, sw, l)

//       UNLESS breaklab=0 DO out2(s_lab, breaklab)
         IF next=0 & breaklab>0 DO out2(s_lab, breaklab)

         trnext(next)
         breaklab, looplab := bl, ll
         RETURN
      $)
 
      CASE s_repeat:
      $( LET bl, ll = breaklab, looplab
         context, comline := x, h4!x
         breaklab, looplab := next, nextlab()
         out2(s_lab, looplab)

         trans(h2!x, looplab)

         IF next=0 & breaklab>0 DO out2(s_lab, breaklab)

         breaklab, looplab := bl, ll
         RETURN
      $)
 
      CASE s_case:
      $( LET l, k, cl = nextlab(), ?, caselist
         context, comline := x, h4!x
         k := evalconst(h2!x)
         IF casecount<0 DO trnerr("CASE label out of context")
         UNTIL cl=0 DO
         $( IF h2!cl=k DO trnerr("'CASE %n:' occurs twice", k)
            cl := h1!cl
         $)
         caselist := newblk(caselist, k, l)
         casecount := casecount + 1
         out2(s_lab, l)
         trans(h3!x, next)
         RETURN
      $)
 
      CASE s_default:
         context, comline := x, h3!x
         IF casecount<0 | defaultlab\=0 DO trnerr("Bad DEFAULT label")
         defaultlab := nextlab()
         out2(s_lab, defaultlab)
         trans(h2!x, next)
         RETURN
 
      CASE s_endcase:
         context, comline := x, h2!x
         IF endcaselab=-2 DO trnerr("Illegal use of ENDCASE")
         IF endcaselab=-1 DO out1(s_rtrn)
         // endcaselab is never equal to 0
         IF endcaselab>0  DO out2(s_jump, endcaselab)
         RETURN
 
      CASE s_switchon:
         transswitch(x, next)
         RETURN
 
      CASE s_for:
         transfor(x, next)
         RETURN
 
      CASE s_seq:
         trans(h2!x, 0)
         x := h3!x
   $)
$) REPEAT

LET declnames(x) BE UNLESS x=0 SWITCHON h1!x INTO
 
$(  DEFAULT:       trnerr("Compiler error in Declnames")
                   RETURN
 
    CASE s_vecdef:
    CASE s_valdef: context, comline := x, h4!x
                   decldyn(h2!x)
                   RETURN
 
    CASE s_rtdef:
    CASE s_fndef:  context, comline := x, h6!x
                   h5!x := nextlab()
                   declstat(h2!x, h5!x)
                   RETURN
 
    CASE s_and:    declnames(h2!x)
                   declnames(h3!x)
$)
 
AND decldyn(x) BE UNLESS x=0 DO
 
$( IF h1!x=s_name  DO $( addname(x, s_local, ssp)
                         //IF xrefing DO xref(x, "P:", ssp, h1!context)
                         ssp := ssp + 1
                         RETURN
                      $)
 
   IF h1!x=s_comma DO $( addname(h2!x, s_local, ssp)
                         //IF xrefing DO xref(h2!x, "P:", ssp, h1!context)
                         ssp := ssp + 1
                         decldyn(h3!x)
                         RETURN
                      $)
 
   trnerr("Compiler error in Decldyn")
$)
 
AND declstat(x, lab) BE
$( LET c = cellwithname(x)
 
   TEST h2!c=s_global THEN $( LET gn = h3!c
                              gdeflist := newblk(gdeflist, gn, lab)
                              gdefcount := gdefcount + 1
                              addname(x, s_global, gn)
                              IF xrefing DO xref(x, "G:", gn, h1!context)
                              IF defsing DO writef("G%i3 = %s*n", gn, @h3!x)
                           $)
                      ELSE $( addname(x, s_label, lab)
                              IF xrefing DO xref(x, "F:", lab, h1!context)
                           $)
$)
 
AND decllabels(x) BE
$( LET e = dvece
   scanlabels(x)
   checkdistinct(e)
$)
 
AND checkdistinct(p) BE
$( LET lim = dvece - 3
   FOR q = p TO lim-3 BY 3 DO
   $( LET n = h1!q
      FOR c = q+3 TO lim BY 3 DO
          IF h1!c=n DO trnerr("Name %s defined twice", @h3!n)
   $)
$)
 
AND addname(name, k, a) BE
$( LET p = dvece + 3
   IF p>dvect DO trnerr("More workspace needed")
   h1!dvece, h2!dvece, h3!dvece := name, k, a
   h2!name := dvece // Remember the declaration
   dvece := p
$)
 
AND undeclare(e) BE 
$( FOR t = e TO dvece-3 BY 3 DO
   $( LET name = h1!t
      h2!name := 0   // Forget its declaration
   $)
   dvece := e
$)

AND cellwithname(n) = VALOF
$( LET t = h2!n
   UNLESS t=0 RESULTIS t  // It has been looked up before
   t := dvece
   t := t - 3 REPEATUNTIL h1!t=n | h1!t=0
   h2!n := t  // Associate the name with declaration item
   RESULTIS t
$)
 
AND scanlabels(x) BE UNLESS x=0 SWITCHON h1!x INTO
 
$( CASE s_colon:   context, comline := x, h5!x
                   h4!x := nextlab()
                   declstat(h2!x, h4!x)
 
   CASE s_if: CASE s_unless: CASE s_while: CASE s_until:
   CASE s_switchon: CASE s_case:
                   scanlabels(h3!x)
                   RETURN
 
   CASE s_seq:     scanlabels(h3!x)
 
   CASE s_repeat: CASE s_repeatwhile: CASE s_repeatuntil:
   CASE s_default: scanlabels(h2!x)
                   RETURN
 
   CASE s_test:    scanlabels(h3!x)
                   scanlabels(h4!x)
   DEFAULT:        RETURN
$)
 
AND transdef(x) BE
$( LET ctxt, ln = context, comline
   transdyndefs(x)
   context, comline := ctxt, ln
   IF statdefs(x) DO $( LET l, s= nextlab(), ssp
                        out2(s_jump, l)
                        transstatdefs(x)
                        ssp := s
                        out2(s_stack, ssp)
                        out2(s_lab, l)
                     $)
   context, comline := ctxt, ln
$)
 
 
AND transdyndefs(x) BE SWITCHON h1!x INTO
$( CASE s_and:    transdyndefs(h2!x)
                  transdyndefs(h3!x)
                  RETURN
 
   CASE s_vecdef: context, comline := x, h4!x
                  out2(s_llp, vecssp)
                  ssp := ssp + 1
                  vecssp := vecssp + 1 + evalconst(h3!x)
                  RETURN
 
   CASE s_valdef: context, comline := h3!x, h4!x
                  loadlist(h3!x)
 
   DEFAULT:       RETURN
$)
 
AND transstatdefs(x) BE SWITCHON h1!x INTO
$( CASE s_and:  transstatdefs(h2!x)
                transstatdefs(h3!x)
                RETURN
 
   CASE s_fndef:
   CASE s_rtdef:
             $( LET e, p = dvece, dvecp
                AND oldpn = procname
                AND bl, ll = breaklab,  looplab
                AND rl, el = resultlab, endcaselab
                AND cl, cc = caselist,  casecount
                breaklab,  looplab    := -2, -2
                resultlab, endcaselab := -2, -2
                caselist,  casecount  :=  0, -1
                procname := h2!x
                context, comline := x, h6!x

                out2(s_entry, h5!x)
                outstring(@h3!procname)
                ssp := savespacesize
                dvecp := dvece
                context, comline := x, h6!x
                decldyn(h3!x)
                checkdistinct(e)
                context, comline := h4!x, h6!x
                decllabels(h4!x)
                out2(s_save, ssp)
                context, comline := h4!x, h6!x
                TEST h1!x=s_rtdef THEN trans(h4!x, -1)
                                  ELSE fnbody(h4!x)
                out1(s_endproc)
 
                breaklab,  looplab    := bl, ll
                resultlab, endcaselab := rl, el
                caselist,  casecount  := cl, cc
                procname := oldpn
                dvecp := p
                undeclare(e)
             $)
 
   DEFAULT:     RETURN
$)
 
AND statdefs(x) = h1!x=s_fndef | h1!x=s_rtdef -> TRUE,
                  h1!x \= s_and               -> FALSE,
                  statdefs(h2!x)              -> TRUE,
                  statdefs(h3!x)
 
 
LET jumpcond(x, b, l) BE
$( LET sw = b

   SWITCHON h1!x INTO
   $( CASE s_false:  b := NOT b
      CASE s_true:   IF b DO out2(s_jump, l)
                     RETURN
 
      CASE s_not:    jumpcond(h2!x, NOT b, l)
                     RETURN
 
      CASE s_logand: sw := NOT sw
      CASE s_logor:  TEST sw THEN $( jumpcond(h2!x, b, l)
                                     jumpcond(h3!x, b, l)
                                     RETURN
                                  $)
 
                             ELSE $( LET m = nextlab()
                                     jumpcond(h2!x, NOT b, m)
                                     jumpcond(h3!x, b, l)
                                     out2(s_lab, m)
                                     RETURN
                                  $)
 
        DEFAULT:     load(x)
                     out2(b -> s_jt, s_jf, l)
                     ssp := ssp - 1
                     RETURN
   $)
$)
 
AND transswitch(x, next) BE
$( LET cl, cc = caselist, casecount 
   LET dl, el = defaultlab, endcaselab
   LET l, dlab = nextlab(), ?
   caselist, casecount, defaultlab := 0, 0, 0
   endcaselab := next=0 -> nextlab(), next
 
   context, comline := x, h4!x
   out2(s_jump, l)
   trans(h3!x, endcaselab)
 
   context, comline := x, h4!x
   out2(s_lab, l)
   load(h2!x)

   dlab := defaultlab>0 -> defaultlab,
           endcaselab>0 -> endcaselab,
           nextlab()

   out2(s_switchon, casecount); out1(dlab) 
   UNTIL caselist=0 DO $( out2(h2!caselist, h3!caselist)
                          caselist := h1!caselist
                       $)
   ssp := ssp - 1

   IF next=0                DO    out2(s_lab, endcaselab)
   IF next<0 & defaultlab=0 DO $( out2(s_lab, dlab)
                                  out1(s_rtrn)
                               $)

   defaultlab, endcaselab := dl, el
   caselist,   casecount  := cl, cc
$)
 
AND transfor(x, next) BE
$( LET e, m, blab = dvece, nextlab(), 0
   LET bl, ll = breaklab, looplab
   LET cc = casecount
   LET k, n, step = 0, 0, 1
   LET s = ssp

   casecount := -1  // Disallow CASE and DEFAULT labels.   
   breaklab, looplab := next, 0
   
   context, comline := x, h7!x
 
   addname(h2!x, s_local, s)
   load(h3!x)       // The initial value
 
   // Set k, n to load the end limit
   TEST h1!(h4!x)=s_number THEN    k, n := s_ln, h2!(h4!x)
                           ELSE $( k, n := s_lp, ssp
                                   load(h4!x)
                                $)
 
   UNLESS h5!x=0 DO step := evalconst(h5!x)
 
   out1(s_store)
   
   TEST k=s_ln & h1!(h3!x)=s_number  // check for constant limits 
   THEN $( LET initval = h2!(h3!x)
           IF step>=0 & initval>n | step<0 & initval<n DO
           $( TEST next<0
              THEN out1(s_rtrn)
              ELSE TEST next>0
                   THEN out2(s_jump, next)
                   ELSE $( blab := breaklab>0 -> breaklab, nextlab()
                           out2(s_jump, blab)
                        $)
           $)
        $)
   ELSE $( IF next<=0 DO blab := nextlab()
           out2(s_lp, s)
           out2(k, n)
           out1(step>=0 -> s_gr, s_ls)
           out2(s_jt, next>0 -> next, blab)
        $)

   IF breaklab=0 & blab>0 DO breaklab := blab
   
   context, comline := x, h7!x
   decllabels(h6!x)
   context, comline := x, h7!x
   out2(s_lab, m)
   trans(h6!x, 0)
   UNLESS looplab=0 DO out2(s_lab, looplab)
   out2(s_lp, s); out2(s_ln, step); out1(s_plus); out2(s_sp, s)
   out2(s_lp,s); out2(k,n); out1(step>=0 -> s_le, s_ge)
   out2(s_jt, m)
 
   IF next<=0 TEST blab>0 
              THEN                  out2(s_lab, blab)
              ELSE IF breaklab>0 DO out2(s_lab, breaklab)
   trnext(next)
   casecount := cc
   breaklab, looplab, ssp := bl, ll, s
   out2(s_stack, ssp)
   undeclare(e)
$)

.

GET "trnhdr_ng"

LET load(x) BE
$( LET op = h1!x

   IF isconst(x) DO
   $( out2(s_ln, evalconst(x))
      ssp := ssp + 1
      RETURN
   $)
 
   SWITCHON op INTO
   $( DEFAULT:          trnerr("Compiler error in Load")
                        out2(s_ln, 0)
                        ssp := ssp + 1
                        RETURN
 
      CASE s_of:      $( LET slct = evalconst(h2!x) // Inserted 11/7/01
                        LET len = slct>>24
                        LET sh  = slct>>16 & 255
                        LET offset = slct & #xFFFF
                        load(h3!x)
//writef("Compiling (SLCT %n:%n:%n) OF v*n", len, sh, offset)
                        IF offset DO $( out2(s_ln, offset); out1(s_plus) $)
                        out1(s_rv)
                        IF sh DO $( out2(s_ln, sh); out1(s_rshift)
//writef("shift by %n*n", sh)
 $)
                        IF len>0 & len+sh<32 DO    // Assume a 32 bit m/c
                        $( LET mask = (1<<len)-1
                          out2(s_ln, mask)
                          out1(s_logand)
//writef("mask with %x8*n", mask)
                        $)
                        RETURN
                      $)

      CASE s_byteap:    op:=s_getbyte

      CASE s_div: CASE s_rem: CASE s_minus:
      CASE s_ls: CASE s_gr: CASE s_le: CASE s_ge:
      CASE s_lshift: CASE s_rshift:
                        load(h2!x); load(h3!x); out1(op)
                        ssp := ssp - 1
                        RETURN
 
      CASE s_vecap: CASE s_mult: CASE s_plus: CASE s_eq: CASE s_ne:
      CASE s_logand: CASE s_logor: CASE s_eqv: CASE s_neqv:
         $( LET a, b = h2!x, h3!x
            TEST h1!a=s_name |
                 h1!a=s_number THEN $( load(b); load(a) $)
                               ELSE $( load(a); load(b) $)
            TEST op=s_vecap THEN out2(s_plus, s_rv)
                            ELSE out1(op)
            ssp := ssp - 1
            RETURN
         $)
 
      CASE s_neg: CASE s_not: CASE s_rv: CASE s_abs:
                       load(h2!x)
                       out1(op)
                       RETURN
 
      CASE s_true: CASE s_false: CASE s_query:
                       out1(op)
                       ssp := ssp + 1
                       RETURN
 
      CASE s_lv:       loadlv(h2!x); RETURN
 
      CASE s_number:   out2(s_ln, h2!x); ssp := ssp + 1; RETURN
 
      CASE s_string:   out1(s_lstr)
                       outstring(@ h2!x)
                       ssp := ssp + 1
                       RETURN
 
      CASE s_name:     transname(x, s_lp, s_lg, s_ll, s_lf, s_ln)
                       ssp := ssp + 1
                       RETURN
 
      CASE s_valof: $( LET e, rl, cc = dvece, resultlab, casecount
                       casecount := -1 // Disallow CASE & DEFAULT labels
                       resultlab := nextlab()
                       decllabels(h2!x)
                       trans(h2!x, 0)
                       out2(s_lab, resultlab)
                       out2(s_rstack, ssp)
                       ssp := ssp + 1
                       resultlab, casecount := rl, cc
                       undeclare(e)
                       RETURN
                    $)
 
      CASE s_fnap:  $( LET s = ssp
                       ssp := ssp + savespacesize
                       out2(s_stack, ssp)
                       loadlist(h3!x)
                       load(h2!x)
                       out2(s_fnap, s)
                       ssp := s + 1
                       RETURN
                    $)
 
      CASE s_cond:  $( LET l, m = nextlab(), nextlab()
                       LET s = ssp
                       jumpcond(h2!x, FALSE, m)
                       load(h3!x)
                       out2(s_res,l)
                       ssp := s; out2(s_stack, ssp)
                       out2(s_lab, m)
                       load(h4!x)
                       out2(s_res,l)
                       out2(s_lab, l)
                       out2(s_rstack,s)
                       RETURN
                    $)
 
      CASE s_table: $( LET m = nextlab()
                       out2(s_datalab, m)
                       x := h2!x
                       WHILE h1!x=s_comma DO
                       $( out2(s_itemn, evalconst(h2!x))
                          x := h3!x
                       $)
                       out2(s_itemn, evalconst(x))
                       out2(s_lll, m)
                       ssp := ssp + 1
                       RETURN
                    $)
   $)
$)

AND fnbody(x) BE SWITCHON h1!x INTO
$( DEFAULT:         load(x)
                    out1(s_fnrn)
                    ssp := ssp - 1
                    RETURN
                   
   CASE s_valof: $( LET e, rl, cc = dvece, resultlab, casecount
                    casecount := -1 // Disallow CASE & DEFAULT labels
                    resultlab := -1
                    decllabels(h2!x)
                    trans(h2!x, -1)
                    resultlab, casecount := rl, cc
                    undeclare(e)
                    RETURN
                 $)

   CASE s_cond:  $( LET l = nextlab()
                    jumpcond(h2!x, FALSE, l)
                    fnbody(h3!x)
                    out2(s_lab, l)
                    fnbody(h4!x)
                 $)
$)
 
 
AND loadlv(x) BE
$( UNLESS x=0 SWITCHON h1!x INTO
   $( DEFAULT:         ENDCASE
 
      CASE s_name:     transname(x, s_llp, s_llg, s_lll, 0, 0)
                       ssp := ssp + 1
                       RETURN
 
      CASE s_rv:       load(h2!x)
                       RETURN
 
      CASE s_vecap: $( LET a, b = h2!x, h3!x
                       IF h1!a=s_name DO a, b := h3!x, h2!x
                       load(a)
                       load(b)
                       out1(s_plus)
                       ssp := ssp - 1
                       RETURN
                    $)
   $)

  trnerr("Ltype expression needed")
  out2(s_ln, 0)
  ssp := ssp + 1
$)
 
AND loadlist(x) BE UNLESS x=0 TEST h1!x=s_comma
                              THEN $( loadlist(h2!x); loadlist(h3!x) $)
                              ELSE load(x)

LET isconst(x) = VALOF
$( IF x=0 RESULTIS FALSE
 
   SWITCHON h1!x INTO
   $( CASE s_name:
        $( LET c = cellwithname(x)
           RESULTIS h2!c=s_manifest
        $)
 
      CASE s_number:
      CASE s_slct:
      CASE s_true:
      CASE s_false:  RESULTIS TRUE
 
      CASE s_neg:
      CASE s_abs:
      CASE s_not:    RESULTIS isconst(h2!x)
       
      CASE s_mult:
      CASE s_div:
      CASE s_rem:
      CASE s_plus:
      CASE s_minus:
      CASE s_lshift:
      CASE s_rshift:
      CASE s_logor:
      CASE s_logand:
      CASE s_eqv:
      CASE s_neqv:   IF isconst(h2!x) & isconst(h3!x) RESULTIS TRUE

      DEFAULT:       RESULTIS FALSE

   $)
$)

.

GET "trnhdr_ng"

LET evalconst(x) = VALOF
$( LET a, b = 0, 0

   IF x=0 DO $( trnerr("Compiler error in Evalconst")
                RESULTIS 0
             $)
 
   SWITCHON h1!x INTO
   $( CASE s_name:
        $( LET c = cellwithname(x)
           IF h2!c=s_manifest DO
           $( LET k = h3!c
             IF xrefing DO xref(x, "M:", k, s_const)
             RESULTIS k
           $)
           trnerr("%s must be a manifest constant", @h3!x)
           RESULTIS 0
        $)
 
      CASE s_number: RESULTIS h2!x
      CASE s_true:   RESULTIS TRUE
      CASE s_false:  RESULTIS FALSE
      CASE s_query:  RESULTIS 0
 
      CASE s_slct: $( LET len, sh, offset = 0, 0, 0     // Inserted 11/7/01
                     IF h2!x DO len    := evalconst(h2!x)
                     IF h3!x DO sh     := evalconst(h3!x)
                     IF h4!x DO offset := evalconst(h4!x)
                     UNLESS 0<=len<=255 & 0<=sh<=255 & 0<=offset<=#xFFFF DO
                       trnerr("A field too large in a SLCT expression")
                     RESULTIS len<<24 | sh<<16 | offset
                   $)

      CASE s_neg:
      CASE s_abs:
      CASE s_not:    a := evalconst(h2!x)
                     ENDCASE
       
      CASE s_mult:
      CASE s_div:
      CASE s_rem:
      CASE s_plus:
      CASE s_minus:
      CASE s_lshift:
      CASE s_rshift:
      CASE s_logor:
      CASE s_logand:
      CASE s_eqv:
      CASE s_neqv:   a, b := evalconst(h2!x), evalconst(h3!x)
                     ENDCASE

      DEFAULT:
   $)
    
   SWITCHON h1!x INTO
   $( CASE s_neg:    RESULTIS    -a
	  CASE s_abs:    RESULTIS ABS a
      CASE s_not:    RESULTIS NOT a
       
      CASE s_mult:   RESULTIS a   *    b
      CASE s_plus:   RESULTIS a   +    b
      CASE s_minus:  RESULTIS a   -    b
      CASE s_lshift: RESULTIS a   <<   b
      CASE s_rshift: RESULTIS a   >>   b
      CASE s_logor:  RESULTIS a   |    b
      CASE s_logand: RESULTIS a   &    b
      CASE s_eqv:    RESULTIS a  EQV   b
      CASE s_neqv:   RESULTIS a  NEQV  b
      CASE s_div:    UNLESS b=0 RESULTIS a   /    b
      CASE s_rem:    UNLESS b=0 RESULTIS a  REM   b
       
      DEFAULT:
   $)

   trnerr("Error in manifest expression")
   RESULTIS 0
$)

AND assign(x, y) BE
$( IF x=0 | y=0 DO $( trnerr("Compiler error in assign")
                      RETURN
                   $)
   
   UNLESS (h1!x=s_comma)=(h1!y=s_comma) DO
   $( trnerr("Bad simultaneous assignment")
      RETURN
   $)
 
   SWITCHON h1!x INTO
   $( CASE s_comma:  assign(h2!x, h2!y)
                     assign(h3!x, h3!y)
                     RETURN
 
      CASE s_name:   load(y)
                     transname(x, s_sp, s_sg, s_sl, 0, 0)
                     ssp := ssp - 1
                     RETURN
 
      CASE s_byteap: load(y)
                     load(h2!x)
                     load(h3!x)
                     out1(s_putbyte)
                     ssp:=ssp-3
                     RETURN
 
      CASE s_rv:
      CASE s_vecap:  load(y)
                     loadlv(x)
                     out1(s_stind)
                     ssp := ssp - 2
                     RETURN
 
      CASE s_of:   $( LET slct = evalconst(h2!x) // Inserted 11/7/01
                     LET len = slct>>24
                     LET sh  = slct>>16 & 255
                     LET offset = slct & #xFFFF
                     LET mask = -1
                     IF len>0 DO mask := (1<<len)-1
                     mask := mask<<sh
//writef("Compiling (SLCT %n:%n:%n) OF x := y*n", len, sh, offset)
//writef("Load y*n")
                     load(y)
                     IF sh DO
                     $( out2(s_ln, sh)
                       out1(s_lshift)
//writef("lshift by %n*n", sh)
                     $)

                     UNLESS mask=-1 DO
                     $( load(h3!x)
                       IF offset DO
                       $( out2(s_ln, offset)
                         out1(s_plus)
                       $)
                       out1(s_rv)
                       out1(s_neqv)
                       ssp := ssp-1
//writef("xor x!%n*n", offset)
                       out2(s_ln, mask)
                       out1(s_logand) // bits to change in x
//writef("mask with %bW*n", mask)

                       load(h3!x)
                       IF offset DO
                       $( out2(s_ln, offset)
                         out1(s_plus)
                       $)
                       out1(s_rv)
                       out1(s_neqv)
//writef("xor with x!%n*n", offset)
                       ssp := ssp-1
                     $)

                     load(h3!x)
                     IF offset DO
                     $( out2(s_ln, offset)
                       out1(s_plus)
                     $)
                     out1(s_stind)
//writef("store in x!%n*n", offset)
                     ssp := ssp-2
//writef("stind*n")
                     RETURN
                   $)

      DEFAULT:       trnerr("Ltype expression needed")
   $)
$)
 
 
AND transname(x, p, g, l, f, n) BE
$( LET c = cellwithname(x)
   LET k, a = h2!c, h3!c
 
   SWITCHON k INTO
   $( DEFAULT:        trnerr("Name '%s' not declared", @h3!x)
   
      CASE s_global:  out2(g, a)
                      IF xrefing DO xref(x, "G:", a, g)
                      RETURN
 
      CASE s_local:   IF c<dvecp DO
                         trnerr("Dynamic free variable '%s' used", @h3!x)
                      out2(p, a)
                      //IF xrefing DO xref(x, "P:", a, p)
                      RETURN
 
      CASE s_static:  out2(l, a)
                      IF xrefing DO xref(x, "S:", a, l)
                      RETURN
 
      CASE s_label:   IF f=0 DO
                      $( trnerr("Misuse of entry name '%s'", @h3!x)
                         f := p
                      $)
                      out2(f, a)
                      IF xrefing DO xref(x, "F:", a, f)
                      RETURN

      CASE s_manifest:IF n=0 DO
                      $( trnerr("Misuse of MANIFEST name '%s'", @h3!x)
                         n := p
                      $)
                      out2(n, a)
                      IF xrefing DO xref(x, "M:", a, n)
  $)
$)

AND xref(x, kstr, n, op) BE
$( LET name = @h3!x
  LET fno = comline>>24
  LET lno = comline & #xFFFFFF
  LET file = sourcenamev!fno
  writef("%s %s%n ", name, kstr, n)

  SWITCHON op INTO
  $( DEFAULT:         writef("op%n", op); ENDCASE
    CASE s_fndef:    writef("FN");       ENDCASE
    CASE s_rtdef:    writef("RT");       ENDCASE
    CASE s_valdef:   writef("VAL");      ENDCASE
    CASE s_vecdef:   writef("VEC");      ENDCASE
    CASE s_constdef: writef("DEF");      ENDCASE
    CASE s_const:    writef("MAN");      ENDCASE
    CASE s_colon:    writef("LAB");      ENDCASE
    CASE s_sp:       writef("SP");       ENDCASE
    CASE s_sg:       writef("SG");       ENDCASE
    CASE s_sl:       writef("SL");       ENDCASE
    CASE s_llp:      writef("LLP");      ENDCASE
    CASE s_llg:      writef("LLG");      ENDCASE
    CASE s_lll:      writef("LLL");      ENDCASE
    CASE s_lp:       writef("LP");       ENDCASE
    CASE s_lg:       writef("LG");       ENDCASE
    CASE s_ll:       writef("LL");       ENDCASE
    CASE s_lf:       writef("LF");       ENDCASE
    CASE s_ln:       writef("LN");       ENDCASE
  $)
  wrch(' ')
  IF file DO writef("%s", file)
  writef("[%n] ", lno)

  prctxt(context)

  newline()
$)

AND prctxt(x) BE IF x DO 
$( LET op = h1!x
  SWITCHON op INTO
  $( DEFAULT:  prctxte(x, 4, 0); RETURN

    CASE s_fndef:
         writef("LET ")
         prctxte(h2!x, 5, 0)
         wrch('(')
         prctxte(h3!x, 7, 0)
         writef(")=..")
         RETURN

    CASE s_rtdef:
         writef("LET ")
         prctxte(h2!x, 5, 0)
         wrch('(')
         prctxte(h3!x, 7, 0)
         writef(")BE..")
         RETURN

    CASE s_valdef:
         writef("LET ")
         prctxte(h2!x, 5, 0)
         writef("=")
         prctxte(h3!x, 5, 0)
         RETURN

    CASE s_vecdef:
         writef("LET ")
         prctxte(h2!x, 5, 0)
         writef("=VEC ")
         prctxte(h3!x, 5, 0)
         RETURN

    CASE s_constdef:
         prctxte(h3!x, 5, 0)
         writef("=")
         prctxte(h4!x, 5, 0)
         RETURN

    CASE s_let:
         writef("LET ")
         prctxtd(h2!x, 2)
         writef("; ")
         prctxtc(h3!x, 2)
         RETURN
 
    CASE s_static:    writef("STATIC..");  RETURN
    CASE s_global:    writef("GLOBAL..");  RETURN
    CASE s_manifest:  writef("MANIFEST..");  RETURN

    CASE s_ass:
         prctxte(h2!x, 4, 0)
         writef(":=")
         prctxte(h3!x, 4, 0)
         RETURN
 
    CASE s_rtap:
         prctxte(h2!x, 2, 12)
         writef("(")
         prctxte(h3!x, 3, 0)
         writef(")")
         RETURN
 
    CASE s_goto:
         writef("GOTO ")
         prctxte(h2!x, 4, 0)
         RETURN
 
    CASE s_colon:
         prctxte(h2!x, 2, 0)
         writef(":")
         prctxtc(h3!x, 3)
         RETURN
 
    CASE s_unless:
    CASE s_if:
    CASE s_while:
    CASE s_until:
         writef(op=s_unless->"UNLESS ",
                op=s_if->"IF ",
                op=s_until->"UNTIL ",
                "WHILE "
               )
         prctxte(h2!x, 4, 0)
         writef(" DO ")
         prctxtc(h3!x, 3)
         RETURN

 
    CASE s_test:
         writef("TEST ")
         prctxte(h2!x, 4, 0)
         writef(" THEN ")
         prctxtc(h3!x, 2)
         writef(" ELSE ")
         prctxtc(h4!x, 2)
         RETURN
 
    CASE s_loop:
         writef("LOOP")
         RETURN
 
    CASE s_break:
         writef("BREAK")
         RETURN
 
    CASE s_return:
         writef("RETURN")
         RETURN
 
    CASE s_finish:
         writef("FINISH")
         RETURN
 
    CASE s_resultis:
         writef("RESULTIS ")
         prctxte(h2!x, 4, 0)
         RETURN
 
    CASE s_repeatwhile:
    CASE s_repeatuntil:
         prctxtc(h2!x, 4)
         writef(op=s_repeatwhile -> " REPEATWHILE ", " REPEATUNTIL ")
         prctxte(h3!x, 4, 0)
         RETURN
 
    CASE s_repeat:
         prctxtc(h2!x, 4)
         writef(" REPEAT")
         RETURN
 
    CASE s_case:
         writef("CASE ")
         prctxte(h2!x, 4, 0)
         writef(":.. ")
         RETURN
 
    CASE s_default:
         writef("DEFAULT:..")
         RETURN
 
    CASE s_endcase:
         writef("ENDCASE")
         RETURN
 
    CASE s_switchon:
         writef("SWITCHON ")
         prctxte(h2!x, 4, 0)
         writef(" INTO..")
         RETURN
 
    CASE s_for:
         writef("FOR ")
         prctxte(h2!x, 4, 0)
         writef("=")
         prctxte(h3!x, 4, 0)
         writef(" TO ")
         prctxte(h4!x, 4, 0)
         IF h5!x DO $( writef(" BY "); prctxte(h5!x, 4, 0) $)
         writef(" DO..")
         RETURN
 
    CASE s_seq:
         prctxtc(h2!x, 4)
         writef(";")
         prctxtc(h3!x, 4)
         RETURN
  $)
$)

AND prctxtd(x, d) BE writef("..")
AND prctxtc(x, d) BE writef("..")

AND prctxte(x, d, prec) BE IF x DO
$( LET op = h1!x

  SWITCHON op INTO
  $( DEFAULT: ENDCASE

    CASE s_number: writef("%n", h2!x);         RETURN 
    CASE s_name:   writef("%s", @h3!x);        RETURN
    CASE s_true:   writef("TRUE");             RETURN
    CASE s_false:  writef("FALSE");            RETURN
    CASE s_query:  wrch('?');                  RETURN

    CASE s_string: 
                 $( LET s = @h2!x
                   LET len = getbyte(s, 0)
                   wrch('"')
                   FOR i = 1 TO len DO
                   $( LET ch = getbyte(s, i)
                     IF i=6 & len>6+8 DO $( writef(".."); LOOP $)
                     IF i<=6 | i>len-8 DO // First 5 and last 8 chars
                     $( SWITCHON ch INTO
                       $( CASE '**': writef("****"); LOOP
                         CASE '*"': writef("***""); LOOP
                         CASE '*n': writef("**n");  LOOP
                       $)
                       UNLESS 32<=ch<=127 DO ch := '?'
                       wrch(ch)
                     $)
                   $)
                   wrch('"')
                   RETURN
                 $)

  $)

  IF d=0 DO $( writef("..."); RETURN $)

  IF prec>=12 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE

    CASE s_fnap:
         prctxte(h2!x, d-1, 11)
         wrch('(')
         prctxte(h3!x, d-1, 0)
         wrch(')')
         RETURN
  $)

  IF prec>=11 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE

    CASE s_of:
    CASE s_byteap:
    CASE s_vecap:
         prctxte(h2!x, d-1, 10)
         writes(op=s_of->"::", op=s_byteap->"%", "!")
         prctxte(h3!x, d-1, 10)
         RETURN

    CASE s_rv:
    CASE s_lv:
         writef(op=s_rv->"!","@")
         prctxte(h2!x, d-1, 10)
         RETURN
  $)

  IF prec>=10 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_mult: CASE s_div: CASE s_rem:
         prctxte(h2!x, d-1, 9)
         writef(op=s_mult->"**", op=s_div->"/", " REM ")
         prctxte(h3!x, d-1, 9)
         RETURN
  $)

  IF prec>=9 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_plus:
    CASE s_minus:
         prctxte(h2!x, d-1, 8)
         writef(op=s_plus->"+","-")
         prctxte(h3!x, d-1, 8)
         RETURN

    CASE s_neg:
    CASE s_abs:
         writef(op=s_neg->"-","ABS ")
         prctxte(h2!x, d-1, 8)
         RETURN

  $)

  IF prec>=8 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_eq: CASE s_ne:
         prctxte(h2!x, d-1, 7)
         writef(op=s_eq->"=","~=")
         prctxte(h3!x, d-1, 7)
         RETURN
    CASE s_ls: CASE s_gr:
         prctxte(h2!x, d-1, 7)
         writef(op=s_ls->"<",">")
         prctxte(h3!x, d-1, 7)
         RETURN
    CASE s_le: CASE s_ge:
         prctxte(h2!x, d-1, 7)
         writef(op=s_le->"<=",">=")
         prctxte(h3!x, d-1, 7)
         RETURN
  $)

  IF prec>=7 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_lshift: CASE s_rshift:
         prctxte(h2!x, d-1, 6)
         writef(op=s_lshift->"<<",">>")
         prctxte(h3!x, d-1, 6)
         RETURN
  $)

  IF prec>=6 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_not:
         wrch('~')
         prctxte(h2!x, d-1, 5)
         RETURN
  $)

  IF prec>=5 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_logand:
         prctxte(h2!x, d-1, 4)
         wrch('&')
         prctxte(h3!x, d-1, 4)
         RETURN
  $)

  IF prec>=4 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_logor:
         prctxte(h2!x, d-1, 3)
         wrch('|')
         prctxte(h3!x, d-1, 3)
         RETURN
  $)

  IF prec>=3 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_eqv:
    CASE s_neqv:
         prctxte(h2!x, d-1, 2)
         writef(op=s_eqv->" EQV "," XOR ")
         prctxte(h3!x, d-1, 2)
         RETURN

  $)

  IF prec>=2 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: ENDCASE
    CASE s_cond:
         prctxte(h2!x, d-1, 1)
         writef("->")
         prctxte(h3!x, d-1, 1)
         writef(",")
         prctxte(h4!x, d-1, 1)
         RETURN
  $)

  IF prec>=1 DO $( wrch('('); prctxte(x, d, 0); wrch(')'); RETURN $)

  SWITCHON op INTO
  $( DEFAULT: writef("Op%n", op); RETURN

    CASE s_table:
         writef("TABLE ")
         prctxte(h2!x, d-1, 0)
         RETURN
         
    CASE s_valof:
         writef("VALOF $(")
         prctxtc(h2!x, d-1)
         writef("$)")
         RETURN

    CASE s_comma:
         prctxte(h2!x, d-1, 0)
         writef(",")
         prctxte(h3!x, d-1, 0)
         RETURN
  $)
$)


AND out1(x) BE wrn(x)
 
AND out2(x, y) BE $( out1(x); out1(y) $)
 
AND outstring(s) BE FOR i = 0 TO getbyte(s, 0) DO out1(getbyte(s, i))

