/* Copyright (c) 2014 Dave Cannon.  All rights reserved. */

/* A macro pre-processor for BCPL: inspired by:
		op,   Copyright (c) 2012 Robert Nordier, and
		copt, Copyright (c) Christopher W. Fraser	*/

GET "libhdr"

GLOBAL $(
	buf		:ug
	macros	:ug+1
$)

MANIFEST $(
	SZ=255			// Input line size
	LN=16			// Lines in buffer
	BSZ=(LN*SZ)		// buffer size, in bytes
	NIL=0
$)


LET loadmacros() BE $(
	LET m0="testmacro,@1,@2,,LET @1 = @2"
	AND ch, x = ?, 0
	AND m00 = TABLE
	"testmacro",				// macro name
		"@1",0,					// arg 1
		"@2",0,					// arg 2
		NIL,					// no more args
		"LET @1 = @2",			// replacement text
		NIL,					// no more text
	NIL							// end of macro

	macros := TABLE
    m00,
    NIL
	
	$(	ch := rdch()
		
	$) REPEATUNTIL ch=endstreamch
$)

AND isdigit(ch) = '0'<=ch<='9'				// Check if character is a digit

AND match(macstr, ix) = VALOF				// Match input text
{	LET arg, c, i, j = ?, ?, 0, 0
	ix := ix-1
	$(	i := i+1
		c := macstr%i
        TEST c = '@' $(
            FOR k=1 TO macstr%0 DO $(
                IF macstr%k ~= buf%(ix+k) $(
					p := p+1
                    RESULTIS false
				$)
			$)
            TEST !arg = 0 $(
                WHILE !s & !s ~= !p {
                    !arg, arg, s := !s, arg+1, s+1
				}
                !arg := 0
            $) ELSE $(
                IF !arg ~= !s
                    RESULTIS false
			$) REPEATWHILE !arg
        $) ELSE IF buf%(ix+i) ~= c RESULTIS false
    $) REPEATWHILE i<=macstr%0
    RESULTIS true
}

AND subst(p, s) BE							// Substitute replacement text
{	LET c, r = ?, ?
    {	c := !p
		p := p+1
        TEST c = '@' & isdigit(!p) {
        //  FOR r = reg[!p++ - '0']; !r; r++
		r := reg[!p - '0']
			WHILE !r~=0 {
                !s := !r
				s := s+1
				p := p+1
				r := reg[!p - '0']
			}
        } ELSE {
            !s := c
			s := s+1
		}
    } REPEATWHILE c~=0
}


LET start() BE
{	LET m, p = macros, ?
    LET eof, lz, ln, lwm, hwm, k, ch = false, 0, 0, 0, 0, ?, ?

	buf := getvec(BSZ/bytesperword)			// create a (cyclic) buffer for the file
    UNTIL eof $(
        $(	ch := rdch()					// fill the buffer
            TEST ch = endstreamch THEN $(
				eof := true
				BREAK
			$) ELSE $(
				hwm := (hwm REM BSZ)+1
				buf%hwm := ch
                IF ch='*n' ln := ln+1
			$)
		$) REPEATUNTIL hwm = lwm
        IF ln = 0 RESULTIS 0				// no lines were read; nothing new in buffer. Bail out

        $(
            $(	j := lwm
				ch := buf%j
				IF ch='*n' $( i := j; LOOP	// remember last newline
					$)
				IF ch='*s' | ch='*t' LOOP	// skip white space
				UNTIL !m=NIL $( 
					IF match(m!0, j) BREAK
				$)
			$) REPEATUNTIL (!m~=NIL) | (j=hwm)
			
            IF !m~=NIL BREAK				// we found a match
        $) REPEATUNTIL j=hwm

        $(	lwm := (lwm REM BSZ)+1
			ch := buf%lwm
			IF ch='*n' ln := ln-1
			wrch(ch)						// empty the buffer...
		$) REPEATUNTIL lwm=j				// ...up to start of match, or hwm

		IF !m~=NIL THEN $(					// if we found a match...
			subst(m!0, j)					// ...substitute the replacement text
			BREAK
		$)
    $)
}
