/*
This program converts Intcode into a marginally more readable form.

*/

SECTION "printcode"

GET "libhdr"
GET "bcplfecg"

GLOBAL {
  ch	: 200
}

LET start() = VALOF
{ LET argv = VEC 20
  LET intcodein = ?
  AND intcodeprn = 0
  LET sysprint = output()
  IF rdargs("FROM,TO/K", argv, 20)=0 DO
  { writes("Bad args for printcode*n")
    RESULTIS 20
  }
  IF argv!0=0 DO argv!0 := "intcode"
  IF argv!1=0 DO argv!1 := "intcode.txt"
  intcodein := findinput(argv!0)
  IF intcodein=0 DO
  { writef("Trouble with file %s*n", argv!0)
    RESULTIS 20
  }
  intcodeprn := findoutput(argv!1)

  IF intcodeprn=0 DO
  { writef("Trouble with file %s*n", argv!1)
    RESULTIS 20
  }

  writef("Converting %s to %s*n", argv!0, argv!1)
  selectinput(intcodein)
  selectoutput(intcodeprn)
//selectoutput(SYSOUT)
  scan()
  endread(intcodein)
  UNLESS intcodeprn=sysprint DO endwrite(intcodeprn)
  selectoutput(sysprint)
  writef("*nConversion complete*n")
  RESULTIS 0
}

AND scan() BE
{ LET c, f, m, n = 0, 0, 0, 0
  LET gv = VEC 100
  LET xc = VEC 25
  
  FOR i=0 TO 100 gv!i := 0
  FOR i=0 TO 25 xc!i := 0

//	global interfaces to the routines (and variables) offered by "libhdr.h"
//	...if that changes, these will need realigning!

  gv!1 := "start"
  gv!2 := "sys"
  gv!3 := "abort"
  gv!4 := "backtrace"
  gv!5 := "trap"

  gv!11 := "selectinput"
  gv!12 := "selectoutput"
  gv!13 := "rdch"
  gv!14 := "wrch"
  gv!15 := "unrdch"
  gv!16 := "input"
  gv!17 := "output"

  gv!27 := "timeofday"
  gv!28 := "time"
  gv!29 := "date"
  gv!30 := "stop"
  gv!31 := "level"
  gv!32 := "longjump"
  gv!33 := "rewind"

  gv!40 := "aptovec"
  gv!41 := "findoutput"
  gv!42 := "findinput"
  gv!43 := "findappend"
  gv!45 := "endstream"
  gv!46 := "endread"
  gv!47 := "endwrite"
  gv!48 := "filetable"
  gv!49 := "rename"
  gv!50 := "delete"
  gv!51 := "endtoinput"
  gv!52 := "getenv"
  gv!53 := "pathfindinput"
  gv!54 := "findfile"
  gv!55 := "fseek"

  gv!60 := "writes"
  gv!62 := "writen"
  gv!63 := "newline"
  gv!64 := "newpage"
  gv!66 := "packstring"
  gv!67 := "unpackstring"
  gv!68 := "writed"
  gv!70 := "readn"
  gv!71 := "terminator"

  gv!74 := "capitalch"
  gv!75 := "writehex"
  gv!76 := "writef"
  gv!77 := "writeoct"
  gv!78 := "mapstore"

  gv!85 := "getbyte"
  gv!86 := "putbyte"
  gv!87 := "getvec"
  gv!88 := "freevec"

  gv!90 := "rdargs"
  gv!91 := "result2"
  gv!92 := "strcat"
  gv!93 := "str2no"
  gv!94 := "str2numb"
  gv!95 := "stackbase"
  gv!96 := "stackend"
  gv!97 := "argc"
  gv!98 := "argv"
  gv!99 := "param"

//	functions delivered by the BCPL Intcode-to-assembler program, "xg.b":
  xc!1 := "A := !A"
  xc!2 := "A := -A"
  xc!3 := "A := not A"
  xc!4 := "Return"
  xc!5 := "A := B**A"
  xc!6 := "A := B/A"
  xc!7 := "A := B rem A"
  xc!8 := "A := B+A"
  xc!9 := "A := B-A"
  xc!10 := "A := B=A"
  xc!11 := "A := B~=A"
  xc!12 := "A := B<A"
  xc!13 := "A := B>=A"
  xc!14 := "A := B>A"
  xc!15 := "A := B<=A"
  xc!16 := "A := B<<A"
  xc!17 := "A := B>>A"
  xc!18 := "A := B&A"
  xc!19 := "A := B|A"
  xc!20 := "A := B NEQV A"
  xc!21 := "A := B EQV A"
  xc!22 := "finish"
  xc!23 := "switchon..."

clear:
   ch := '*n'

next:
   rch()
// newline()
sw:
// writef("...in scan(): ch='%c'*n", ch)
   c, f, m, n := 0, 0, 0, 0
   SWITCHON ch INTO

   {  DEFAULT: IF ch=endstreamch RETURN
               writef("*nbad ch '%c'*n", ch)
               GOTO next

      CASE '0':CASE '1':CASE '2':CASE '3':CASE '4':
      CASE '5':CASE '6':CASE '7':CASE '8':CASE '9':
               writef("lab L%n:*n", rdn())
               GOTO sw

      CASE '$':	CASE '*s':	CASE '*n':	GOTO next

      CASE 'N': writes("*nSection: *"")
                rch()
                FOR i=1 TO rdn() DO {
				  rch(); rch()				// discard leading 'C'
                  c := rdn()
				  TEST c<'*s' THEN writef("[%n]", c) ELSE wrch(c)
                }
				writes("*"*n*n")
				GOTO sw
      CASE 'L': CASE 'S': CASE 'A': CASE 'J':
	  CASE 'T': CASE 'F': CASE 'K':
				c := ch; f := ""
                writef("	%s ", ch='L' -> "load ",
				                  ch='S' -> "store",
								  ch='A' -> "add  ",
								  ch='J' -> "jump ",
								  ch='T' -> "jumpt",
								  ch='F' -> "jumpf",
								  ch='K' -> "call	(stkfm =",	"mehh")
                rch(); m := ch				// 'P', 'G', 'I', 'F' or a numeric
				IF (c='J' | c='L') & m='F' m := 'L'	
				IF ch<='9' & ch>='0' THEN {
				  n := rdn()
				  writef("%n", n)
				  writef("%s*n", c='K' -> ")", "")
                  GOTO sw
				}
				IF ch='I' THEN {
				  f := "I"
				  rch(); m := ch
				}
				rch(); n := rdn()
				writef("%s%c%n", f, m, n)
				IF m='G' & n<100 THEN IF gv!n~=0 writef("	# %s()", gv!n)
				newline()
                GOTO sw
	  CASE 'X': writes("	exec  ")
                rch(); m := ch				// 'P', 'G', 'I' or a numeric
				IF ch<='9' & ch>='0' THEN {
				  n := rdn()
				  writef("%n", n)
				}
				IF n<25 THEN {
				  IF xc!n~=0 writef("	%s# %s*n", n<=9 -> "*t", "", xc!n)
				}
				IF n=23 THEN {			// switchon cases follow...
				  wrch('*n')
				  { rch()
					IF ch~='D' BREAK
					rch()
					TEST ch='L' THEN {
					  rch()
					  writef("   jump L%n*n", rdn())
					} ELSE writef("	case  %n:", rdn())
				  } REPEAT
				}
                GOTO sw
      CASE 'C': rch(); n := rdn()			// read the string length
				writes("	*"")
				FOR i=1 TO n DO {
				  rch()
				  IF ch~='C' BREAK
				  rch()
				  m := rdn()
				  TEST m<'*s' DO writef("[%n]", m) ELSE writef("%c", m)
				}
				writes("*"*n")
				GOTO sw

      CASE 'D': rch()
				c := ch
				IF c='L' rch()
                writef("	data  %s%n*n", c='L' -> "L", "", rdn())
                GOTO sw

      CASE 'G': rch()
                writef("  G%n", rdn())
                IF ch='L' THEN {
				  rch()
                  writef("	L%n*n", rdn())
				}
                GOTO sw

      CASE 'Z': GOTO clear
   }

   GOTO sw
}

AND rch() BE {
   ch := rdch()
   IF ch='$' DO {
     { ch := rdch()
       IF ch='*n' BREAK
       writef("%c", ch)
     } REPEATUNTIL ch='*n'
     newline()
   }
   UNLESS ch='/' RETURN
   UNTIL ch='*n' DO ch := rdch()
} REPEAT

AND rdn() = VALOF
{  LET a, b = 0, FALSE
   IF ch='-' DO { b := TRUE; rch()  }
   WHILE '0'<=ch<='9' DO { a := 10*a + ch - '0'; rch()  }
   IF b DO a := -a
   RESULTIS a
}


