// This is an OCODE to Intcode codegenerator dated 1982 approx
// Implemented and revised by Martin Richards (c) Sept 2012

// ...amended to handle the 2014 compiler, as enhanced to support
// EXTERNAL declarations and in-line CODE sections in the 2020
// compiler
// 										Dave Cannon: 29-Apr-2020

//    CGdefs	...used by cg-intcode.b


// Code Generator Globals:

GLOBAL
$(  rc 			: 150
    fromfile
    verstream
    ocodestream
    codestream
    datvec
    err.p
    err.l
    ocodefile
    keepocode

    // CG options

    cgworksize	: 160
    cglisting
    naming
    callcounting
    profcounting
    stkchking
    restricted
    altobj
    cg_a
    cg_b
    cg_y
    cg_z
$)



MANIFEST
$(  free_global	= 180
$)




GLOBAL
$(  ch			: free_global+0
    wordv
    sysprint
    sysin
    ssp
    state
    ad_a
    ad_k
    option
    datav
    datap
    datat
    proglength
    linep
    param
    op
    readop
    rdn
    rdl
    gencode
    force.nil
    force.ad
    force.ac
    force.acad
    swap
    load
    storein
    cgstring
    data
    nextparam
    code
    complab
    opcode
    wr
    wrn
    wrdata

	codev
	codep
	codet
	
	exit
	c_wrch
	real_wrch
	extdefs
	scanexternals
$)


MANIFEST $(								// offsets of extdefs entries
	ex_lnk		= 0
	ex_used		= 1
	ex_lab		= 2
	ex_name		= 3
$)

MANIFEST $(
	cgcodesize	= 20000					// buffer size for the Intcode text
$)


MANIFEST $(
    m_n           = 0
    m_i           = 1
    m_p           = 2
    m_ip          = 3
    m_l           = 4
    m_il          = 5
    m_g           = 6
    m_ig          = 7
	m_f           = 8
	m_if          = 9
	
    f_l           = 'L'
    f_s           = 'S'
    f_a           = 'A'
    f_j           = 'J'
    f_t           = 'T'
    f_f           = 'F'
    f_k           = 'K'
    f_x           = 'X'
    f_d           = 'D'
    f_c           = 'C'
	f_m           = 'M'
    nil           = 0
    ad            = 1
    ac            = 2
    acad          = 3
$)



.

SECTION "IC-CG1"



//    CG1

GET "libhdr"
GET "bcplfecg"
GET "CGdefs"



STATIC
$(  wp = 0
    strsize = 0
$)



/*
	This code reads from character format OCODE files (pre-1982!)
LET T(S) = VALOF
      $( FOR I = 0 TO STRSIZE DO UNLESS S!I=WORDV!I RESULTIS FALSE
         RESULTIS TRUE  $)

LET old.READOP() = VALOF
    $(1 LET S = VEC 20

        CH := RDCH() REPEATWHILE CH='*N' \/ CH='*S'
        WP := 0

        WHILE 'A'<=CH<='Z' DO
           $( WP := WP + 1
              S!WP := CH
              CH := RDCH()  $)

        S!0 := WP
        STRSIZE := PACKSTRING(S, WORDV)

        SWITCHON S!1 INTO
     $( DEFAULT: IF CH=ENDSTREAMCH RESULTIS s_end
                 RESULTIS ERROR

        CASE 'D':
        RESULTIS T("DATALAB") -> s_datalab,
                 T("DIV") -> s_div,
                 T("DEBUG") -> s_debug, ERROR

        CASE 'E':
        RESULTIS T("EQ") -> s_eq,
                 T("ENTRY") -> s_entry,
                 T("EQV") -> s_eqv,
                 T("ENDPROC") -> s_endproc,
                 T("END") -> s_end, ERROR

        CASE 'F':
        RESULTIS T("FNAP") -> s_fnap,
                 T("FNRN") -> s_fnrn,
                 T("FALSE") -> s_false,
                 T("FINISH") -> s_finish, ERROR


        CASE 'G':
        RESULTIS T("GOTO") -> s_goto,
                 T("GE") -> s_ge,
                 T("GR") -> s_gr,
                 T("GLOBAL") -> s_global, ERROR

        CASE 'I':
        RESULTIS T("ITEMN") -> s_itemn,
                 T("ITEML") -> s_iteml,  ERROR

        CASE 'J':
        RESULTIS T("JUMP") -> s_jump,
                 T("JF") -> s_jf,
                 T("JT") -> s_jt,  ERROR

        CASE 'L':
        IF WP=2 DO
             SWITCHON S!2 INTO
             $( DEFAULT: RESULTIS ERROR
                CASE 'E': RESULTIS s_le
                CASE 'N': RESULTIS s_ln
                CASE 'G': RESULTIS s_lg
                CASE 'P': RESULTIS s_lp
                CASE 'L': RESULTIS s_ll
                CASE 'S': RESULTIS s_ls  $)

        RESULTIS T("LAB") -> s_lab,
                 T("LLG") -> s_llg,
                 T("LLL") -> s_lll,
                 T("LLP") -> s_llp,
                 T("LOGAND") -> s_logand,
                 T("LOGOR") -> s_logor,
                 T("LSHIFT") -> s_lshift,
                 T("LSTR") -> s_lstr, ERROR

        CASE 'M':
        RESULTIS T("MINUS") -> s_minus,
                 T("MULT") -> s_mul, ERROR

        CASE 'N':
        RESULTIS  T("NE") -> s_ne,
                  T("NEG") -> s_neg,
                  T("NEQV") -> s_neqv,
                  T("NOT") -> s_not,  ERROR

        CASE 'P':
        RESULTIS T("PLUS") -> s_plus, ERROR

        CASE 'Q':
        RESULTIS T("QUERY") -> s_query, ERROR

        CASE 'R':
        RESULTIS T("RES") -> s_res,
                 T("REM") -> s_rem,
                 T("RTAP") -> s_rtap,
                 T("RTRN") -> s_rtrn,
                 T("RSHIFT") -> s_rshift,
                 T("RSTACK") -> s_rstack,
                 T("RV") -> s_rv, ERROR

        CASE 'S':
        RESULTIS T("SG") -> s_sg,
                 T("SP") -> s_sp,
                 T("SL") -> s_sl,
                 T("STIND") -> s_stind,
                 T("STACK") -> s_stack,
                 T("SAVE") -> s_save,
                 T("SWITCHON") -> s_switchon,
                 T("STORE") -> s_store, ERROR

        CASE 'T':
        RESULTIS T("TRUE") -> s_true, ERROR
    $)
$)1
	*/




LET readop() = VALOF
// this version of READOP deals with INTEGER type OCODE
$(  LET a, neg = 0, FALSE
    ch := rdch() REPEATWHILE ch='*N' | ch='*S'
    TEST ch=endstreamch THEN a := s_end ELSE
    $(  IF ch='-' THEN
        $(  neg := TRUE
            ch := rdch()
        $)
        WHILE '0' LE ch LE '9' DO
        $(  a := a*10 +ch - '0'
            ch := rdch()
        $)

    $)
    RESULTIS (neg -> -a, a)
$)




AND rdn() = VALOF
$(  // reads a number from the OCODE file
    LET a, neg = 0, FALSE
    ch := rdch() REPEATWHILE ch='*N' \/ ch='*S'
    IF ch='-' THEN
    $(  neg := TRUE
        ch := rdch()
    $)
    WHILE '0' LE ch LE '9' DO
    $(  a := a*10 +ch - '0'
        ch := rdch()
    $)
    RESULTIS (neg -> -a, a)
$)




AND rdl() = VALOF
// reads an OCODE label
    $(1 LET a = 0

        ch := rdch() REPEATWHILE ch='*N' \/ ch='*S'

        IF ch='L' DO ch := rdch()

        WHILE '0' LE ch LE '9' DO
                  $( a := a*10 + ch - '0'
                     ch := rdch()  $)

        RESULTIS a   $)1






.


SECTION "IC-CG2"


//    CG2


GET "libhdr"
GET "bcplfecg"
GET "CGdefs"

LET gencode() BE
$(rpt
 // writef("op=%n*n", op)
    SWITCHON op INTO
    $(  DEFAULT:
            selectoutput(sysprint)
            writef("IC-CG: unknown OCODE number:  %N*N", op)
            selectoutput(codestream)
            ENDCASE

        CASE s_none:    CASE s_end:     CASE 0:
			wrch := real_wrch							// restore wrch() to file
            FOR i = 0 TO codep-1 DO wr(codev%i)			// write out contents of codespace
			wr('Z'); wr('*n'); wr('*n')
            RETURN

        CASE s_section:
			$(  LET l=rdn()
				wrch := real_wrch						// 'SECTION' gets written directly to the head of the Intcode file...
				writef("N%n ", l)
				FOR i=1 TO l DO writef("C%n ", rdn())
				wr('*n')
				wrch := c_wrch							// ...then back to code buffer
				ENDCASE
			$)

        CASE s_debug:
            selectoutput(sysprint)
            writef("IC-CG: STATE=%N, SSP=%N, AD_A=%N, AD_K=%N*N",
                            state,    ssp,    ad_a,    ad_k)
            selectoutput(codestream)
            ENDCASE

        CASE s_needs:
            wr('*N')
            writes("/ NEEDS ")
            FOR i=1 TO rdn() DO wrch(rdn())
            wr('*N')
            ENDCASE

        CASE s_external:		/*	Here's the plan:
								 *	Build a linked list of all the declared EXTERNALs, details to include
								 *	label, name (string) and a flag to indicate if it's defined in the code.
								 *	Later, on stumbling across a label, check this list and flag 'defined'
								 *	if we find it.
								 *	On reaching the end of the OCODE stream, scan along this list, outputting
								 *	code for those that have the 'defined' flag set - the rest are irrelevant
								 *	to the OCODE module...
								 *		 _______	  ______________________________________________
								 *		| list  | -->|  link	|defined| label	|  ....name...		|
								 */
			$(	LET lab, lth, entry = rdn(), rdn(), ?	// read the label & length of the EXTERNAL id string
				entry := getvec(lth/bytesperword + 3)
				FOR i=1 TO lth DO (entry+ex_name)%i := rdn()
				(entry+ex_name)%0 := lth
				entry!ex_used := FALSE					// not defined yet
				entry!ex_lab := lab
				entry!ex_lnk := extdefs					// extdefs=0 initially
				extdefs := entry						// put this entry at the head of the list
				ENDCASE
			$)

        CASE s_lp:
            load(rdn(), m_ip)
            ENDCASE

        CASE s_lg:
            load(rdn(), m_ig)
            ENDCASE

        CASE s_ll:
            load(rdl(), m_il)
            ENDCASE

        CASE s_ln:
            load(rdn(), m_n)
            ENDCASE

        CASE s_lf:
            load(rdl(), m_f)
            ENDCASE

        CASE s_lstr:
            cgstring(rdn())
            ENDCASE

	//	CASE s_lcode:										// backwards compatibility - these two have the same MANIFEST value...
		CASE s_mctxt:	
			$(	LET n=rdn()
				writef("%c%n ", f_m, n)
				FOR i = 1 TO n DO $( writef("C%n ", rdn()) $)
				ENDCASE
			$)

        CASE s_true:
            load(-1, m_n)
            ENDCASE

        CASE s_false:
            load(0, m_n)
            ENDCASE

        CASE s_llp:
            load(rdn(), m_p)
            ENDCASE

        CASE s_llg:
            load(rdn(), m_g)
            ENDCASE

        CASE s_lll:
            load(rdl(), m_l)
            ENDCASE

        CASE s_sp:
            storein(rdn(), m_p)
            ENDCASE

        CASE s_sg:
            storein(rdn(), m_g)
            ENDCASE

        CASE s_sl:
            storein(rdl(), m_l)
            ENDCASE

        CASE s_stind:
            force.acad()
            code(f_s, ad_a, ad_k)
            ssp, state := ssp-2, nil
            ENDCASE

        CASE s_putbyte:
            // args on the stack are as follows:
            //         top of stack  ->  arg1
            //                           arg2
            //                           arg3
            // where the operation is  ARG2%ARG1 := ARG3
            force.nil()
            code(f_l, ssp-3, m_p)    // load address of vector on stack!
            code(f_x, opcode(s_putbyte), m_n)
            ssp := ssp-3
            state := nil
            ENDCASE

        CASE s_mul:     CASE s_div:     CASE s_rem:
        CASE s_sub:     CASE s_eq:      CASE s_ne:
        CASE s_ls:      CASE s_gr:      CASE s_le:
        CASE s_ge:      CASE s_lshift:  CASE s_rshift:
        CASE s_logand:  CASE s_logor:   CASE s_neqv:
        CASE s_eqv:     CASE s_getbyte:
            force.acad()
            code(f_l, ad_a, ad_k)
            code(f_x, opcode(op), m_n)
            state, ssp := ac, ssp-1
            ENDCASE

        CASE s_rv:      CASE s_neg:     CASE s_not:
        CASE s_abs:
            force.ac()
            code(f_x, opcode(op), m_n)
            ENDCASE

        CASE s_add:
            force.acad()
            code(f_a, ad_a, ad_k)
            state, ssp := ac, ssp-1
            ENDCASE

        CASE s_jump:
            force.nil()
            code(f_j, rdl(), m_l)
            ENDCASE

        CASE s_jt:      CASE s_jf:
            force.ac()
            code(op=s_jt->f_t,f_f, rdl(), m_l)
            ssp, state := ssp-1, nil
            ENDCASE

        CASE s_endfor:
            // Simulate the effect of the OCODE
            //       MINUS LN 0 LE JT
            // the label follows the ENDFOR code
            force.acad()
            code(f_l, ad_a, ad_k)
            code(f_x, opcode(s_sub), m_n)
            state := ac
            ssp := ssp - 1
            load(0, m_n)
            code(f_l, ad_a, ad_k)
            code(f_x, opcode(s_le), m_n)
            code(f_t, rdl(), m_l)
            ssp := ssp - 2
            state := nil
            ENDCASE

        CASE s_goto:
            force.ad()
            code(f_j, ad_a, ad_k)
            ssp, state := ssp-1, nil
            ENDCASE

        CASE s_lab:
            force.nil()
            complab(rdl())
            ENDCASE

        CASE s_query:
            force.nil()
            ssp := ssp + 1
            ENDCASE

        CASE s_stack:
            force.nil()
            ssp := rdn()
            ENDCASE

        CASE s_store:
            force.nil()
            ENDCASE

        CASE s_entry:
            $(  LET l = rdl()
                LET n = rdn()
				AND ent = scanexternals(l, TRUE)
// IF ent writef("...in scan(): scanexternals(L%n) - ENTRY to EXTERNAL '%s'*n", ent!ex_lab, ent+ex_name)
				writes("*n$ /")
				FOR i = 1 TO n DO wr(rdn())		// Write the function name
                wr('*n'); wr(' ')
				complab(l)
            /*  state, ad_a, ad_k := NIL, 0, m_n
             *  wr('*N')
             *  wr('$')
             *  FOR i = 1 TO n DO rdn()
             *  wr(' ')
             *  complab(l)
             */
				ENDCASE
            $)

        CASE s_save:
            ssp := rdn()
            ENDCASE

        CASE s_endproc:
         // rdn()
            ENDCASE

        CASE s_rtap:    CASE s_fnap:
            $(  LET k = rdn()
                force.ac()
                code(f_k, k, m_n)
                TEST op=s_fnap THEN
                $(  ssp := k+1
                    state := ac
                $) ELSE
                $(  ssp := k
                    state := nil
                $)
                ENDCASE
            $)

        CASE s_fnrn:
            force.ac()
            ssp := ssp - 1
        CASE s_rtrn:
            code(f_x, opcode(s_rtrn), m_n)
            state := nil
            ENDCASE

        CASE s_res:
            force.ac()
            code(f_j, rdl(), m_l)
            ssp, state := ssp-1, nil
            ENDCASE

        CASE s_rstack:
            force.nil()
            ssp, state := rdn()+1, ac
            ENDCASE

        CASE s_finish:
            code(f_x, opcode(op), m_n)
            ENDCASE

        CASE s_switchon:
            $(  LET n = rdn()
                LET d = rdl()
                force.ac()
                code(f_x, opcode(op), m_n)
                code(f_d, n, m_n)
                code(f_d, d, m_l)
                ssp, state := ssp-1, nil
                FOR i = 1 TO n DO
                $(  code(f_d, rdn(), m_n)
                    code(f_d, rdl(), m_l)
                $)
                ENDCASE
            $)

        CASE s_global:
            wr('*N')
            FOR i = 0 TO datap-2 BY 2 DO wrdata(datav!i, datav!(i+1))
            wr('*N')
            FOR i = 1 TO rdn() DO
            $(  wr('G')
                wrn(rdn())
                wr('L')
                wrn(rdl())
                wr('*S')
            $)
			wr('*N')
            ENDCASE

        CASE s_extdef:
             $(	LET n, lab, lth, str = rdn(), ?, ?, ?	// number of EXTERNAL definitions
				LET outstream = output()
				AND ent = ?
				wrch := real_wrch						// this gets written directly to the head of the Intcode file...
				FOR i = 1 TO n DO $(
				  lab := rdn()							// label
				  ent := scanexternals(lab, TRUE)		// mark EXTERNAL list entry defined (in this module)
// IF ent writef("...in scan(): scanexternals(L%n) - EXTERNAL '%s' defined locally*n", ent!ex_lab, ent+ex_name)
				  lth := rdn()							// string length
				  str := getvec(lth/bytesperword + 1)
				  FOR i=1 TO lth DO str%i := rdn()
				  str%0 := lth
				$)
				UNTIL extdefs = 0 DO $(					// ...and any referenced EXTERNALs
					IF extdefs!ex_used = TRUE $(		// has this EXTERNAL been referenced?
						LET n = (extdefs+ex_name)%0		// EXTERNAL references must be at head of INTCODE file...
						writef("E%n", n)
						FOR i = 1 TO n DO writef(" C%n", (extdefs+ex_name)%i)
						writes(" *n")
				/*		codeb('E')						// (this version would place EXTERNAL references at end of file)
				 *		coden(n)
				 *		FOR i = 1 TO n DO { codeb('*S'); codeb('C'); coden((extdefs+ex_name)%i) }	// Write the function name
				 *		codeb(' ')
				 *		codeb('*N')
				 */
					$)
					extdefs := extdefs!ex_lnk			// next
				$)
				wrch := c_wrch							// ...then back to code buffer
				ENDCASE
			$)

        CASE s_datalab:
        CASE s_iteml:
            data(op, rdl())
            ENDCASE

        CASE s_itemn:
            data(op, rdn())
            ENDCASE
    $)

    op := readop()

$)rpt REPEAT

AND scanexternals(exlab, mod) = VALOF $(
	LET entry = extdefs					// head of chain of EXTERNAL definitions
	UNTIL entry = 0 DO $(
	  IF entry!ex_lab = exlab $(
		IF mod entry!ex_used := TRUE	// mark entry as used
		RESULTIS entry					// return pointer to this entry
	  $)
	  entry := entry!ex_lnk				// next
	$)
	RESULTIS 0							// not found
$)







.

SECTION "IC-CG3"



//    CG3


GET "libhdr"
GET "bcplfecg"
GET "CGdefs"



//
//  This code deals with the generation of INTCODE for loads and stores.
//


//  The INTCODE stack may be in one of four states (kept in STATE):
//
//     STATE = NIL
//          top of stack - (offset SSP-1) - in stack frame
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//          No pending load
//
//     STATE = AC
//          top of stack - (offset SSP-1) - in INTCODE register A
//          second of stack - (offset SSP-2) - in stack frame
//          No pending load
//
//     STATE = AD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//
//     STATE = ACAD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in INTCODE register A
//
//  The two variables AD_A and AD_K hold the address and address modifier
//  of a pending load.  This load will be performed when next necessary.

// LOADS are made into variables on the stack - and hence use M_IP
// STORES are made from addresses on the stack - and hence use M_P







LET force.nil() BE
// Forces NIL state - so that INTCODE register A is empty and there are
// no pending loads.
    SWITCHON state INTO
    $(  CASE acad:
            code(f_s, ssp-2, m_p)
        CASE ad:
            code(f_l, ad_a, ad_k)
        CASE ac:
            code(f_s, ssp-1, m_p)
            state := nil
        CASE nil:
    $)




AND force.ad() BE
// Forces AD state in which the variables AD_A and AD_K hold details of a
// pending load and INTCODE register A is empty.
    SWITCHON state INTO
    $(  CASE acad:
            code(f_s, ssp-2, m_p)
            GOTO l

        CASE ac:
            code(f_s, ssp-1, m_p)
        CASE nil:
            ad_a := ssp-1
            ad_k := m_ip
l:          state := ad
        CASE ad:
    $)




AND force.ac() BE
// Forces AC state in which the INTCODE register A holds the top of stack
// and there are no pending loads.
    SWITCHON state INTO
    $(  CASE nil:
            code(f_l, ssp-1, m_ip)
            GOTO l

        CASE acad:
            code(f_s, ssp-2, m_p)
        CASE ad:
            code(f_l, ad_a, ad_k)
l:          state := ac
        CASE ac:
    $)





AND force.acad() BE
// Forces state ACAD in which AD_A and AD_K hold details of the pending
// load of the top of stack and INTCODE register A holds the next of stack.
    SWITCHON state INTO
    $(  CASE ad:
            code(f_l, ssp-2, m_ip)
            GOTO l

        CASE ac:
            code(f_s, ssp-1, m_p)
        CASE nil:
            code(f_l, ssp-2, m_ip)
            ad_a := ssp-1
            ad_k := m_ip
l:          state := acad
        CASE acad:
    $)




AND swap() BE
// This procedure swaps the top two elements on the stack represented
// in state STATE and leaves the stack in state ACAD.  (with the top
// two registers pending and in the A register respectively).
$(  state := acad   // for most of them:
    SWITCHON state INTO
    $(  CASE nil:
            // load A register with the top of stack:
            code(f_l, ssp-1, m_ip)
            ENDCASE

        CASE ad:
            // Do pending load
            code(f_l, ad_a, ad_k)

        CASE ac:
            // Store A into top of stack (instead of second of stack)
            code(f_s, ssp-1, m_p)
            ENDCASE

        CASE acad:
            // We want to load the stack in the order
            //       <pending load>
            //       <intcode register A>
            // this would mean saving register A whilst it is used for
            // stacking the pending load.  However, we can save the
            // intcode register A first if we are sure that it does not
            // affect the pending load which will have to be done subsequently
            // - i.e. so long as the pending load is not from the top
            // of stack to which we will write register A.
            TEST ad_a=ssp-1 & (ad_k=m_p | ad_k=m_ip) THEN
            $(  // too bad - we'll have to save A first
                code(f_s, ssp, m_p)
                code(f_l, ad_a, ad_k)   // do pending load
                code(f_s, ssp-2, m_p)   // put in swapped position
                code(f_l, ssp, m_p)     // get A back
                state := ac
            $) ELSE
            $(  code(f_s, ssp-1, m_p)
                code(f_l, ad_a, ad_k)
                code(f_s, ssp-2, m_p)   // put back into second of stack
                state := nil
            $)
    $)
    ad_a := ssp-2      // for when STATE = AD or ACAD
    ad_k := m_ip
$)





AND load(a, k) BE
// A - the new contents of the accumulator A
// K - the kind (mode) in which the operand is to be fetched
//     (an M_<flags> constant typically)
// This procedure frees the pending load given in AD_A and AD_K (if there
// is one) and then loads A and K into them.
    SWITCHON state INTO
    $( CASE nil: state := ad
                 GOTO m

       CASE acad:
       CASE ad:  force.ac()
       CASE ac:  state := acad
       m:        ad_a, ad_k := a, k
                 ssp := ssp + 1
    $)





AND storein(a, k) BE
$(  force.ac()
    code(f_s, a, k)
    ssp, state := ssp-1, nil
$)




AND cgstring(n) BE
$(1 LET l = nextparam()
    data(s_datalab, l)
    data(s_char, n)
    FOR i = 1 TO n DO data(s_char, rdn())
    load(l, m_l)
$)1




AND data(k, v) BE
$(  LET p = datap
    datav!p, datav!(p+1) := k, v
    datap := datap + 2
    IF datap>datat THEN
    $(  selectoutput(sysprint)
        writes("IC-CG: too many constants*N")
        selectoutput(codestream)
        datap := 0
    $)
$)




AND nextparam() = VALOF
$(  param := param - 1

    IF  param < 0  THEN
    $(
        selectoutput( sysprint )
        writes( "IC-CG:  too many labels (!)*N" )
        selectoutput( codestream )

        param  :=  100  // ????
    $)

    RESULTIS param
$)





.

SECTION "IC-CG4"



//    CG4


GET "libhdr"
GET "bcplfecg"
GET "CGdefs"



LET code(f, a, k) BE
// F - function = F_L  F_S  F_A  F_J  F_T  F_F  F_K  or  F_X
// A - data (D field in INTCODE)
// K - mode in which data is to be fetched, one of:
//        M_N    -  normal
//        M_I    -  indirect
//        M_IG   -  indirect global
//        M_P    -  local variable (relative to stack frame)
//        M_IP   -  indirect local
//        M_L    -  label
//        M_IL   -  indirect label
//        M_F    -  function
//        M_IF   -  indirect function
$(  LET ent, n = 0, 0
    wr(f)
    SWITCHON k INTO
    $( CASE m_i: wr('I')
       CASE m_n: ENDCASE

       CASE m_ig: wr('I')
       CASE m_g:  wr('G')
                  ENDCASE

       CASE m_ip: wr('I')
       CASE m_p:  wr('P'); ENDCASE

       CASE m_il: wr('I')
       CASE m_l:  ent := scanexternals(a, FALSE)
				  TEST ent THEN $(
// writef("...in code(F=%n, A=%n, K=%n): L%n = '%s'*n", F, A, K, ent!ex_lab, ent+ex_name)
					wr('E')
					n := (ent+ex_name)%0
					wrn(n)
					FOR i = 1 TO n DO writef(" C%n", (ent+ex_name)%i)			// Write the function name
				  $) ELSE $(
					wr('L')
				  $)
                           ENDCASE
       CASE m_if: wr('I')
       CASE m_f:  ent := scanexternals(a, FALSE)
				  TEST ent THEN $(
// writef("...in code(F=%n, A=%n, K=%n): L%n = '%s'*n", F, A, K, ent!ex_lab, ent+ex_name)
					wr('E')
					n := (ent+ex_name)%0
					wrn(n)
					FOR i = 1 TO n DO writef(" C%n", (ent+ex_name)%i)			// Write the function name
				  $) ELSE $(
					wr('F')
				  $)
                           ENDCASE
		$)

    UNLESS ent wrn(a)
    wr(' ')
    proglength := proglength + 1
$)





AND complab(n) BE
$(  // writes out an INTCODE label
    wrn(n)
    wr(' ')
$)



AND wrdata(k, n) BE
// writes out an OCODE data item in INTCODE
    SWITCHON k INTO
    $(  CASE s_datalab: complab(n); RETURN

        CASE s_itemn: code(f_d, n, m_n); RETURN

        CASE s_iteml: code(f_d, n, m_l); RETURN

        CASE s_char:  code(f_c, n, m_n); RETURN
    $)


AND opcode(op) = VALOF
// returns INTCODE number <n> in X<n> for OCODE opcode OP
    SWITCHON op INTO
    $(  CASE s_rv:		RESULTIS 1				// 1)	A := Location (A)
        CASE s_fneg:
        CASE s_neg:		RESULTIS 2				// 2)	A := -A
        CASE s_not:		RESULTIS 3				// 3)	A := NOT A
        CASE s_rtrn:	RESULTIS 4				// 4)	This causes a return from the current function or routine;
												//		by convention the result of a function is left in A.
												//		C := Location(P + 1)
												//		P := Location(P)
        CASE s_fmul:
        CASE s_mul:		RESULTIS 5				// 5)	A := B * A
        CASE s_fdiv:
        CASE s_div:		RESULTIS 6				// 6)	A := B / A
        CASE s_rem:		RESULTIS 7				// 7)	A := B REM A
        CASE s_fadd:
        CASE s_add:		RESULTIS 8				// 8)	A := B + A
        CASE s_fsub:
        CASE s_sub:		RESULTIS 9				// 9)	A := B - A
        CASE s_feq:
        CASE s_eq:		RESULTIS 10				// 10)	A := B = A
        CASE s_fne:
        CASE s_ne:		RESULTIS 11				// 11)	A := B ~= A
        CASE s_fls:
        CASE s_ls:		RESULTIS 12				// 12)	A := B < A
        CASE s_fge:
        CASE s_ge:		RESULTIS 13				// 13)	A := B >= A
        CASE s_fgr:
        CASE s_gr:		RESULTIS 14				// 14)	A := B > A
        CASE s_fle:
        CASE s_le:		RESULTIS 15				// 15)	A := B <= A
        CASE s_lshift:	RESULTIS 16				// 16)	A := B LSHIFT A
        CASE s_rshift:	RESULTIS 17				// 17)	A := B RSHIFT A
        CASE s_logand:	RESULTIS 18				// 18)	A := B LOGAND A
        CASE s_logor:	RESULTIS 19				// 19)	A := B LOGOR A
        CASE s_neqv:	RESULTIS 20				// 20)	A := B NEQV A
        CASE s_eqv:		RESULTIS 21				// 21)	A := B EQV A
        CASE s_finish:	RESULTIS 22				// 22)	FINISH
        CASE s_switchon:RESULTIS 23				// 23)	Switch on the value of A using data in the location
												//		addressed by C, C+1 etc.
												//		B, D := Location(C), Location(C + 1)
												//		UNTIL B = 0 DO
												//			{	B, C := B - 1, C + 2
												//				IF A=Location(C) DO
												//					{	D := Location(C + 1)
												//						BREAK }       }
												//		C := D
												// 24) - 35) are implementation dependent)
        CASE s_getbyte:	RESULTIS 36				// 36)	GETBYTE()
        CASE s_putbyte:	RESULTIS 37				// 37)	PUTBYTE()
												// 38) - 43) are implementation dependent)
        CASE s_fabs:
        CASE s_abs:		RESULTIS 44				// 44)	A := ABS A
        CASE s_selld:	RESULTIS 46				// 46)	Load selector
        CASE s_selst:	RESULTIS 47				// 47)	Store selector

        DEFAULT: selectoutput(sysprint)
                 writef("IC-CG: unknown op %n for Intcode 'Xn' operation*n", op)
                 selectoutput(codestream)
                 RESULTIS 0
    $)


AND c_wrch(ch) BE
$(	IF codep > codet $(
		selectoutput(sysprint)
        writes("IC-CG: code exceeds codespace (%n bytes)*n", cgcodesize*bytesperword)
        selectoutput(codestream)
        exit(30)
    $)
	codev%codep := ch
	codep := codep+1
$)


AND wr(ch) BE
$(  IF ch='*N' THEN
    $(  wrch('*N')
        linep := 0
        RETURN
    $)

    IF (real_wrch=wrch) & (linep=80) THEN
    $(  wrch('/')
        wrch('*N')
        linep := 0
    $)
    linep := linep + 1
    wrch(ch)
$)


//AND wrn(n) BE
//$(  IF n<0 THEN
//    $(  wr('-')
//        n := -n
//    $)
//    IF n>9 DO wrn(n/10)
//    wr(n REM 10 + '0')
//$)


AND wrn (n) BE
$( LET t    = VEC 10
   LET i, k = 0, -n

   IF n<0 DO k := n
   t!i, k, i := -(k REM 10), k/10, i+1 REPEATUNTIL k=0
   IF n<0 THEN wr('-')
   FOR j = i-1 TO 0 BY -1 DO wr(t!j+'0')
$)


.

SECTION "IC-CG5"



//    CG5


GET "libhdr"
GET "bcplfecg"
GET "CGdefs"




LET start() BE
$(  LET workspace, codespace = ?, ?
    LET v = VEC 50
    writes("Intcode CG (11 June 2020)*N")
    err.p , err.l := level() , exit.label
    wordv := v
    sysin := input()
    sysprint := output()

	extdefs := 0

 // writef("argc=%n, argv!1=%n*n", argc, argv!1)
	ocodefile := argc>0 -> argv!0, input()
	codestream := argc>1 -> findoutput(argv!1), output()
 // writef("ocodefile = '%s'*n", ocodefile)
	cgworksize := 10000

	ocodestream := findinput(ocodefile)
    IF ocodestream = 0 THEN
    $(  writef("IC-CG: Can't open *"%S*"*N", ocodefile)
        exit(20)
    $)

    workspace := getvec(cgworksize)
	codespace := getvec(cgcodesize)
    TEST workspace=0 | codespace=0 THEN
    $(  writef("IC-CG: Can't get %N words for CG %s*n", workspace=0 -> cgworksize, cgcodesize, workspace=0 -> "workspace", "codespace")
        exit(20)
    $) ELSE
    $(  datav := workspace
        datat := cgworksize
		codev := codespace
		codet := cgcodesize
    $)

    proglength := 0

	real_wrch := wrch									// save the address of wrch()!

    selectinput(ocodestream)
    selectoutput(codestream)

    $(rpt
		wrch := c_wrch									// set up to 'write' to codespace
        op := readop()
	/*  writef("op=%n*n", op)
     *  IF op=s_section THEN
     *  $(  LET l=rdn()
	 *		writef("*nN%n ", l)
     *      FOR i=1 TO l DO writef("C%n ", rdn())
     *      wr('*N')
     *      op := readop()
     *  $)
	 */
        ssp, state := 2, nil
        datap, codep, linep,  param := 0, 0, 0, 1000
        gencode()
    $)rpt REPEATUNTIL op=s_end

    selectoutput(sysprint)
    writef("Program size = %n words*n", proglength)
    exit(0)

exit.label:
    RETURN
$)



AND exit(n) BE
$(  UNLESS ocodestream=0 THEN
    $(  selectinput(ocodestream)
        endread()
        ocodestream := 0
    $)
    selectinput(sysin)
    selectoutput(sysprint)

    UNLESS datav=0 THEN freevec(datav)
    UNLESS codev=0 THEN freevec(codev)

    rc := n

    longjump(err.p, err.l)
$)

