// $Id: blib.bcpl,v 2.2 2021/05/11 09:52:10 rn Exp $

//   BLIB

GET "LIBHDR"
GET "TMHDR"

STATIC $(
	sptr = 0											// SWRCH() needs to know where to 'write' CH
$)

LET WRITES(S) BE  FOR I = 1 TO GETBYTE(S, 0) DO WRCH(GETBYTE(S, I))

AND UNPACKSTRING(S, V) BE
         FOR I = 0 TO GETBYTE(S, 0) DO V!I := GETBYTE(S, I)

AND PACKSTRING(V, S) = VALOF
    $( LET N = V!0 & 255
       LET I = N/BYTESPERWORD
       FOR P = 0 TO N DO PUTBYTE(S, P, V!P)
    // TEST BYTESPERWORD=2 THEN IF (N&(BYTESPERWORD-1))=0 DO PUTBYTE(S, N+1, 0) ELSE
       SWITCHON N&(BYTESPERWORD-1) INTO
       $( CASE 0: PUTBYTE(S, N+3, 0)
          CASE 1: PUTBYTE(S, N+2, 0)
          CASE 2: PUTBYTE(S, N+1, 0)
          CASE 3: $)
       RESULTIS I  $)

AND STR2NUMB(S) = VALOF					// Deprecated
$(	LET A = 0
	FOR I = 1 TO GETBYTE(S, 0) DO $( LET DIG = GETBYTE(S, I) - '0'
									IF 0<=DIG<=9 DO A := 10*A + DIG
									$)
	RESULTIS GETBYTE(S, 1)='-' -> -A, A  $)

// THE DEFINITIONS THAT FOLLOW ARE MACHINE INDEPENDENT

AND WRITED(N, D) BE
$(1 LET T = VEC 20
    AND I, K = 0, N
	TEST N<0 THEN D := D-1 ELSE K := -N
    T!I, K, I := K REM 10, K/10, I+1 REPEATUNTIL K=0
    FOR J = I+1 TO D DO WRCH('*S')
    IF N<0 DO WRCH('-')
    FOR J = I-1 TO 0 BY -1 DO WRCH('0'-T!J)  $)1

AND WRITEN(N) BE WRITED(N, 0)

AND NEWLINE() BE WRCH('*N')

AND NEWPAGE() BE WRCH('*P')

AND READN() = VALOF
$(1 LET SUM = 0
    AND NEG = FALSE

L: TERMINATOR := RDCH()
    SWITCHON TERMINATOR INTO
    $(  CASE '*S':
        CASE '*T':
        CASE '*N':    GOTO L

        CASE '-':     NEG := TRUE
        CASE '+':     TERMINATOR := RDCH()   $)
    WHILE '0'<=TERMINATOR<='9' DO
                 $( SUM := 10*SUM + TERMINATOR - '0'
                    TERMINATOR := RDCH()  $)
    IF NEG DO SUM := -SUM
    RESULTIS SUM   $)1

AND WRITEOCT(N, D) BE
    $( IF D>1 DO WRITEOCT(N>>3, D-1)
       WRCH((N/\7)+'0')  $)

AND WRITEHEX(N, D) BE
    $( IF D>1 DO WRITEHEX(N>>4, D-1)
       WRCH((N&15)!TABLE
            '0','1','2','3','4','5','6','7',
            '8','9','A','B','C','D','E','F')  $)

/*
 *								The original version of WRITEF():
 *
 * AND WRITEF(FORMAT, A, B, C, D, E, F, G, H, I, J, K) BE
 * $(1 LET T = @A
 * 
 *     FOR P = 1 TO GETBYTE(FORMAT, 0) DO
 *     $(2 LET K = GETBYTE(FORMAT, P)
 * 
 *         TEST K='%'
 * 
 *           THEN $(3 LET F, Q, N = 0, T!0, 0
 *                    AND TYPE = GETBYTE(FORMAT, P+1)
 *                    P := P + 1
 *                    SWITCHON TYPE INTO
 *                 $( DEFAULT: WRCH(TYPE); ENDCASE
 * 
 *                    CASE 'S': CASE 's': F := WRITES; GOTO L
 *                    CASE 'C': CASE 'c': F := WRCH; GOTO L
 *                    CASE 'O': CASE 'o': F := WRITEOCT; GOTO M
 *                    CASE 'X': CASE 'x': F := WRITEHEX; GOTO M
 *                    CASE 'I': CASE 'i': F := WRITED; GOTO M
 *                    CASE 'N': CASE 'n': F := WRITED; GOTO L
 * 
 *                 M: P := P + 1
 *                    N := GETBYTE(FORMAT, P)
 *                    N := '0'<=N<='9' -> N-'0', N-'A'+10
 * 
 *                 L: F(Q, N); T := T + 1  $)3
 * 
 *             OR WRCH(K)  $)2  $)1
 */

/*
 *        The following routines provide and extended version of writef.
 *	They support the following extra substitution items:
 *
 *        1. %F   - Takes next argument as a writef format string and
 *                calls writef recursively using the remaining arguments.
 *                The argument pointer is positioned to the next available
 *                argument on return.
 *
 *        2. %M   - The next argument is taken as a message number and processed
 *                as for %F above. The message format string is looked up by
 *                get_text(messno, str, upb) where str is a vector local to
 *                writef to hold the message string. This is provided to easy
 *                the generation of messages in different languages.
 *							(Not supported!					DC	20-June-2020)
 *
 *        3. %+   - The argument pointer is incremented by 1.
 *
 *        4. %-   - The argument pointer is decremented by 1.
 *
 *        5. %P   - Plural formation. The singular form is use if and only if
 *                the next argument is one. So that the argument can be used
 *                twice it is normal to preceed or follow the %P item with %-.
 *                There are two forms as follows:
 *
 *                a. %Pc  - The character c is output if the the next argument
 *                        not one.
 *
 *                b. %P\singular\plural\  - The appropriate text is printed,
 *                        skipping the other. The '\' chars are not printed.
 *
 *				  Example: FOR count = 0 TO 2 DO
 * 							writef("There %p\is\are\ %-%n thing%-%ps.*n", count)
 *				  outputs:
 *		  		  There are 0 things.
 *				  There is 1 thing.
 *				  There are 2 things.
 *
 *        6. %nOp  eg %12i as an alternative to %iB
 *                where n is a decimal number and Op is a format letter
 *                expecting a field width. If n is given it specifies the
 *                field width otherwise it is specified, as before, by the
 *                single character (0-9, A-Z) following Op.
 *
 *        7. %n.md  eg %8.2d
 *                print a fixed point scaled decimal number in a field
 *                width of n with m digits after the decimal point. For
 *                example writef("%8.2d", 1234567) would output: 12345.67
 *                and     writef("%8.0d", 1234567) would output:  1234567
 *
 *        8. %#   Write the next argument using codewrch, ie convert the
 *                next argument to UTF-8 format.
 *							(Not supported!					DC	20-June-2020)
 */

// The following version of writef is new -- MR 21/1/04

AND writez(n, d) BE writedz(n, d, TRUE,  n<0)

AND writedz(n, d, zeroes, neg) BE
$( LET t = VEC 10
  LET i = 0
  LET k = -n

  IF neg DO $( d := d - 1; k := n $)

  $( t!i := -(k REM 10)
    k   := k/10
    i   := i + 1
  $) REPEATWHILE k

  IF neg & zeroes DO wrch('-')
  FOR j = i+1 TO d DO wrch(zeroes -> '0', '*s')
  IF neg & NOT zeroes DO wrch('-')
  FOR j = i-1 TO 0 BY -1 DO wrch(t!j+'0')
$)

AND writebin(n, d) BE
$( IF d > 1 DO writebin(n>>1, d-1)
  wrch((n&1)+'0')
$)

AND writet(s, d) BE
$( writes(s)
  FOR i = 1 TO d-getbyte(s, 0) DO wrch('*s')
$)

AND writeu(n, d) BE
$( LET m = (n>>1)/5
  IF m DO $( writed(m, d-1); d := 1 $)
  writed(n-m*10, d)
$)

AND writefp(fp, d) BE
$( LET v = VEC 20
  LET i = 0
  LET k, m, neg = ?, 1, 0
  FOR j=1 TO d DO m := m * 10
  m := FLOAT m
  k := FIX (fp #* m)
  TEST k<0 THEN neg := 1 ELSE k := -k
  v!i, k, i := k REM 10, k/10, i+1 REPEATUNTIL k=0
  IF neg DO wrch('-')
  FOR j = i-1 TO 0 BY -1 DO $(
    IF j+1=d wrch('.')
    wrch('0'-v!j)
  $)
$)

AND WRITEF(format,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z) BE
$( LET nextarg = @a
  write_format(format, @nextarg)
$)

AND write_format(format, lvnextarg) BE
$( // WRITEF must preserve RESULT2
  LET res2 = RESULT2

  FOR p = 1 TO getbyte(format, 0) DO
  $( LET k, type, f, n, m, arg = getbyte(format, p), ?, ?, ?, ?, ?
    LET widthgiven = FALSE
    UNLESS k='%' DO $( wrch(k); LOOP $)

    // Deal with a substitution item
    p := p + 1
    type, arg, n, m := getbyte(format, p), !!lvnextarg, 0, 0

sw: SWITCHON capitalch(type) INTO
    $( DEFAULT:    wrch(type)
                  LOOP

      CASE '0':CASE '1':CASE '2':CASE '3':CASE '4':
      CASE '5':CASE '6':CASE '7':CASE '8':CASE '9':
                  $( n := 10*n + type - '0'
                    p := p+1
                    type := getbyte(format, p)
                    widthgiven := TRUE
                  $) REPEATWHILE '0'<=type<='9'
                  IF type='.' DO
                  $( p := p+1
                    type := getbyte(format, p)
                    WHILE '0'<=type<='9' DO
                    $( m := 10*m + type - '0'
                      p := p+1
                      type := getbyte(format, p)
                    $)
                  $)
                  GOTO sw

      CASE 'D':   IF m DO
                  $( // Write a number of the form nnn.nn
                    LET scale = 1
                    FOR i = 1 TO m DO scale := scale * 10
                    writedz(arg/scale, n-1-m, FALSE, arg<0)
                    wrch('.')
            //      writez( ABS arg REM scale, m)				// early compilers didn't support ABS
                    writez( (arg<0->-arg, arg) REM scale, m)
                    !lvnextarg := !lvnextarg + 1
                    LOOP
                  $)
                  f := writed;    GOTO getarg


      CASE 'S':   f := writes;    GOTO noargs
      CASE 'T':   f := writet;    GOTO getarg
      CASE 'C':   f := wrch;      GOTO noargs
  //  CASE '#':   f := codewrch;  GOTO noargs
      CASE 'O':   f := writeoct;  GOTO getarg
      CASE 'X':   f := writehex;  GOTO getarg
      CASE 'I':   f := writed;    GOTO getarg
      CASE 'N':   f := writen;    GOTO noargs
      CASE 'U':   f := writeu;    GOTO getarg
      CASE 'Z':   f := writez;    GOTO getarg
      CASE 'B':   f := writebin;  GOTO getarg
      CASE 'R':   f := writefp;   GOTO getarg					// print a Real (floating point) number with 'n' decimal places

    getarg:       UNLESS widthgiven DO
                  $( p := p + 1
                    n := capitalch(getbyte(format, p))
                    n := '0' <= n <= '9' -> n - '0', 10 + n - 'A'
                  $)

    noargs:       f(arg, n)
                  !lvnextarg := !lvnextarg + 1
                  LOOP

      CASE '$':
      CASE '+':   !lvnextarg := !lvnextarg + 1
                  LOOP

      CASE '-':   !lvnextarg := !lvnextarg - 1
                  LOOP
	/*
     *CASE 'M': $( LET buf = VEC 256/bytesperword
     *            !lvnextarg := !lvnextarg + 1
     *            UNLESS get_text(arg, buf, 256/bytesperword) DO
     *              buf := "<<mess:%-%n>>"  // No message text
     *            write_format(buf, lvnextarg)
     *            LOOP
     *          $)
	 */
      CASE 'F':   !lvnextarg := !lvnextarg + 1
                  write_format(arg, lvnextarg)
                  LOOP

      CASE 'P': $( LET plural = arg NE 1
                  !lvnextarg := !lvnextarg + 1
                  p := p+1
                  type := getbyte(format, p)
                  IF type = '\' DO
                  $( // Deal with %P\singular\plural\ item
                    LET skipping = plural
                    p := p + 1
                    UNTIL p > getbyte(format, 0) DO
                    $( LET ch = getbyte(format, p)
                      TEST ch = '\' THEN $( skipping := NOT skipping
                                           IF skipping = plural BREAK
                                         $)
                                    ELSE UNLESS skipping DO wrch(ch)
                      p := p + 1
                    $)
                    LOOP
                  $)

                  // Deal with simple %Pc items
                  IF plural DO wrch(type)
                  LOOP
                $)
    $) // End of SWITCHON ...
  $) // End of FOR p = ...

  RESULT2 := res2
$)

AND SWRCH(ch) BE
$(	LET xlth, xptr = ?, sptr

	IF xptr=0 RETURN									// if there's nowhere to plant the character...
	xlth := GETBYTE(xptr, 0)+1
	IF xlth>maxstrlength RETURN							// ...get out!
	PUTBYTE(xptr, xlth, ch)
	PUTBYTE(xptr, 0, xlth)
$)

AND SWRITEF(PTR, FORMAT, A, B, C, D, E, F, G, H, I, J, K) = VALOF
/*	SWRITEF() is remarkably similar to c's sprintf() - it outputs to an in-memory string,
	rather than an output file.  It achieves this by replacing WRCH() by SWRCH() for the
	duration of its task	*/
$(	LET OWRCH=WRCH

	IF PTR=0 $(
		PTR := GETVEC(maxstrlength/bytesperword)
		PTR!0 := 0									// initialise length of string
	$)
	sptr := PTR
	WRCH := SWRCH									// substitute SWRCH() for WRCH()
	WRITEF(FORMAT, A, B, C, D, E, F, G, H, I, J, K)
	
	WRCH := OWRCH
	sptr := 0										// return to former state
	RESULTIS PTR
$)

AND TIMEOFDAY() = VALOF
/*	TIMEOFDAY() returns a string of the form: "16:44:11 GMT"	*/
$(	LET t = GETVEC(12/bytesperword)
	AND timevec = GETVEC(tvs)
	AND tptr = TIME()								// get the time elapsed since the 'epoch'

	FOR i=0 TO tvs DO timevec!i := tptr!i			// copy the time elements to timevec
	t!0 := 0										// initialise length of time string
	
	t := SWRITEF(t, "%n%n:%n%n:%n%n %s", (timevec!tm_hour)/10, (timevec!tm_hour) REM 10, (timevec!tm_min)/10, (timevec!tm_min) REM 10, (timevec!tm_sec)/10, (timevec!tm_sec) REM 10, timevec!tm_isdst=0->"GMT", "BST")
	FREEVEC(timevec)
	RESULTIS t
$)

AND DATE() = VALOF
/*	DATE() returns a string of the form: "Wed, 01 Jan 2014"	*/
$(	LET t = GETVEC(20/bytesperword)
	AND timevec = GETVEC(tvs)
	AND tptr = TIME()								// get the time elapsed since the 'epoch'
	AND dow, mth = ?, ?

	FOR i=0 TO tvs DO timevec!i := tptr!i			// copy the time elements to timevec
	t!0 := 0										// initialise length of date string

	SWITCHON timevec!tm_wday INTO $(
		CASE  0: dow:="Sun"; ENDCASE
		CASE  1: dow:="Mon"; ENDCASE
		CASE  2: dow:="Tue"; ENDCASE
		CASE  3: dow:="Wed"; ENDCASE
		CASE  4: dow:="Thu"; ENDCASE
		CASE  5: dow:="Fri"; ENDCASE
		CASE  6: dow:="Sat"; ENDCASE
		DEFAULT: dow:="???"; ENDCASE
	$)
	SWITCHON timevec!tm_mon INTO $(
		CASE  0: mth:="Jan"; ENDCASE
		CASE  1: mth:="Feb"; ENDCASE
		CASE  2: mth:="Mar"; ENDCASE
		CASE  3: mth:="Apr"; ENDCASE
		CASE  4: mth:="May"; ENDCASE
		CASE  5: mth:="Jun"; ENDCASE
		CASE  6: mth:="Jul"; ENDCASE
		CASE  7: mth:="Aug"; ENDCASE
		CASE  8: mth:="Sep"; ENDCASE
		CASE  9: mth:="Oct"; ENDCASE
		CASE 10: mth:="Nov"; ENDCASE
		CASE 11: mth:="Dec"; ENDCASE
		DEFAULT: mth:="???"; ENDCASE
	$)

	t := SWRITEF(t, "%s, %n%n %s %i4", dow, (timevec!tm_mday)/10, (timevec!tm_mday) REM 10, mth, (timevec!tm_year)+1900)
	FREEVEC(timevec)
	RESULTIS t
$)

AND CAPITALCH(ch) = 'a' <= ch <= 'z' -> ch + 'A' - 'a', ch

AND STR2NO(s) = VALOF
// Return TRUE if OK with value in result2
//        FALSE and result2=0 if s is not a number
// Example strings: 
//  'A'
//  123    -99    +63
//  #377   -#x7FF +#b1011011 
$( LET p, len = 1, getbyte(s, 0)
   LET neg, radix = FALSE, 10
   LET ch = ?

   result2 := 0
   UNLESS len RESULTIS FALSE
   ch := CAPITALCH(getbyte(s, p))
   IF ch = '*'' & len = 3 & getbyte(s, 3) = '*'' DO
   $( result2 := getbyte(s, 2)
      RESULTIS TRUE
   $)

   IF ch = '+' | ch = '-' DO
   $( neg := ch = '-'
      IF p = len RESULTIS TRUE
      p := p + 1
      ch := CAPITALCH(getbyte(s, p))
   $)
   IF ch = '#' DO
   $( radix := 8
      IF p = len RESULTIS TRUE
      p := p + 1
      ch := CAPITALCH(getbyte(s, p))
      IF ch = 'O' | ch = 'X' | ch = 'B' DO
      $( IF ch = 'X' DO radix := 16
         IF ch = 'B' DO radix := 2
         IF p = len RESULTIS TRUE
         p := p + 1
         ch := CAPITALCH(getbyte(s, p))
      $)
   $)
   $( LET n = '0' <= ch <= '9' -> ch - '0',
            'A' <= ch <= 'Z' -> ch - 'A' + 10, 1000
      UNLESS n < radix RESULTIS FALSE
      result2 := result2 * radix + n
      p := p + 1
      IF p > len BREAK
      ch := CAPITALCH(getbyte(s, p))
   $) REPEAT

   IF neg DO result2 := -result2
   RESULTIS TRUE
$)

AND RDARGS(ignored, v, c) = VALOF
$(	/*	This is a simple version of RDARGS().  It scans the program's offered
		calling arguments as presented in ARGV and copies them to the user's
		vector V.  C must be the size of V, and should be at least equal to
		ARGC-1.  As implied, the IGNORED parameter is ignored.
		
		Any arguments offered as the strings ","  "-"  "."  or  "/" are
		converted to 0 (zero).
		
		Any numeric argument strings (see STR2NO() above) are converted to
		their value.
		
		All other arguments are copied unchanged.
	*/
	FOR i=0 TO c>=ARGC-1 -> c, ARGC-1 DO $(
		IF i>c RESULTIS FALSE				// We've moved beyond the capacity of 'v'
		v!i := i>ARGC-1 -> 0, ARGV!i
		IF i<=ARGC-1 THEN $(
			//	WRITEF("i=%n, argv!%n=%n, argc=%n*n", i, i, argv!i, argc)
			TEST getbyte(ARGV!i, 0)=1 & ','<=getbyte(ARGV!i, 1)<='/' THEN v!i := 0
                                   //   ","     "-"     "."     "/"  may be used to force blank/zero fields
			ELSE IF STR2NO(ARGV!i) THEN v!i := RESULT2
		$)
	$)
	RESULTIS TRUE
$)

AND TRAP(ng) BE
$(
	GLOBAL $( GADDR	: 0	$)
	
	LET gvec = GADDR
	AND gvect=ng>1000 | ng<1 -> gvec+FIRSTFREEGLOBAL, gvec+ng
	
	FOR gno = gvec TO gvect DO $(
	//	TEST ((gno-gvec) REM 3) = 0 THEN WRITES("*n		") ELSE WRITES("	")
	//	WRITEF("G %i3 | %i7", gno-gvec, !gno)
		IF !gno=0 THEN !gno := TRAP_X
		$)
$)

AND TRAP_X(protect, protect1, protect2, protect3) BE
$(
	LET here = LEVEL()>>2
	AND cptr = (here!1)>>2
	AND os = OUTPUT()
	AND gno=0

	SELECTOUTPUT(SYSERR)
	WRITES("*n	TRAP():*n*n")
	FOR cp=-25 TO 4 DO $(		// Look back through the calling code to find the global which called this routine...
								// NB: this is very implementation/platform specific!!
		LET byte0=GETBYTE(cptr, cp)
		AND byte1=GETBYTE(cptr, cp+1)
		// WRITEF("		code: %n:%n	[%n] | %x2*n", cptr, cp, (cptr<<2)+cp, byte0)
		IF byte0=#X8B /\ (byte1=#X87 \/ byte1=#X47) THEN $(
			FOR i=byte1=#X47->cp+2,cp+5 TO cp+2 BY -1 DO $(
				gno := (gno<<8)+GETBYTE(cptr, i)
				// WRITEF("%x2", GETBYTE(cptr, i))
			$)
			WRITEF("	Your code called undefined GLOBAL #%n*n	Diagnostics follow:*n", gno>>2)
			BREAK
		$)
	$)
	IF gno=0 WRITES("	Your code called an undefined GLOBAL*n	Diagnostics follow:*n")

	STACKTRACE()
	MAPSTORE(120)
	SELECTOUTPUT(os)
$)

AND STRCAT(DEST, SRCE) = VALOF
$(	LET CP=GETBYTE(DEST, 0)

	FOR I=1 TO GETBYTE(SRCE, 0) DO $(
		CP := CP+1
		IF CP>maxstrlength $(			// too many characters in the concatenated string...
			CP := CP-I
			BREAK
			$)
		PUTBYTE(DEST, CP, GETBYTE(SRCE, I))
		$)

	PUTBYTE(DEST, 0, CP)
//	WRITEF("Concatenated string length %n: *"%s*"*n", CP, DEST)
	RESULTIS DEST	$)

AND PATHFINDINPUT(FN, PATH) = VALOF
$(	LET DFPATH="\Users\Dave\Apps\BCPL\BCPLkit\include"
	AND STRM=FINDINPUT(FN)				// First check the current directory for the file
	AND CH=?
	AND D=1
	AND P=0
	AND SUBSTR=?
	AND STR=VEC 256/BYTESPERWORD

	UNLESS STRM=0 RESULTIS STRM
	SUBSTR := GETVEC(256/BYTESPERWORD)	// This needs to be semi-permanent to hold constructed path/filename...
										// ...FINDINPUT() associates it with the filetable entry
	STR!0, SUBSTR!0 := 0, 0
//	WRITEF("GETVEC(%n) returns %n*n%s GETENV(%n)...*n", 256/BYTESPERWORD, SUBSTR, PATH=0 -> "Not calling", "Calling", PATH)
	UNLESS PATH=0 DO P := GETENV(PATH)
	UNLESS P=0 DO $(
		STRCAT(STR, P)
		STRCAT(STR, ";")
		$)
	STRCAT(STR, DFPATH)

	FOR I=1 TO GETBYTE(STR, 0) DO $(
		CH := GETBYTE(STR, I)
		TEST CH=';' | I=GETBYTE(STR, 0) THEN $(
			IF CH\=';' PUTBYTE(SUBSTR, D, CH)
			PUTBYTE(SUBSTR, 0, CH=';' -> D-1, D)
			STRCAT(SUBSTR, "\")
			STRCAT(SUBSTR, FN)
		//	WRITEF("FINDINPUT(%S) returns: ", SUBSTR)
			STRM := FINDINPUT(SUBSTR)
		//	WRITEF("%N*n", STRM)
			UNLESS STRM=0 RESULTIS STRM
			D := 1
			$)
		ELSE $(
			PUTBYTE(SUBSTR, D, CH)
			D := D+1
			$)
		$)

	IF STRM=0 FREEVEC(SUBSTR)
	RESULTIS STRM	$)
			
AND ENDSTREAM(STRM) BE
$(	LET CIP=INPUT()
		// NB: Since the underlying code for ENDREAD() & ENDWRITE()
		//     both call the c function '_fclose' this also works
		//     where the stream was opened for output or append!
	SELECTINPUT(STRM)
	ENDREAD()
	SELECTINPUT(CIP)
$)

AND ENDTOINPUT() BE
$(	LET f=OUTPUT()
	AND fn = FILETABLE!(f+21)

	IF f=SYSOUT $(
		WRITES("SYSOUT may not be opened for input!*n")
		RETURN
		$)
	ENDWRITE()
	f := FINDINPUT(fn)
	SELECTINPUT(f)	$)

AND ABORT(ecode, addr) BE
$(	
	WRITEF("*n*tABORT(%n, %n) called:*n*n", ecode, addr)
	MAPSTORE()
	STACKTRACE()
	STOP(ecode = 0 -> 9999, ecode)	$)

AND STACKTRACE() BE
$(	LET var1 = @var1
	LET here = LEVEL()>>2
	AND fbase = here
	
	WRITEF("*n	STACKTRACE():*n*n	STACKBASE=%n	STACKEND=%n*n*n", STACKBASE, STACKEND)
	WRITES("		STK ...*n")
	FOR sp = var1+5 TO STACKBASE BY -1 DO $(
		WRITEF("		STK %n [%n] | %n	%S*n", sp, sp<<2, !sp, sp = here ->  "<- STACKTRACE()", sp = STACKBASE -> "<- START()", sp = fbase -> "<-", "")
		IF fbase = sp THEN fbase := (!sp)>>2
	$)	$)

// AND MAPSTORE() BE WRITES("*NMAPSTORE NOT IMPLEMENTED*N")

AND MAPSTORE(ng) BE
$(
	GLOBAL $( GADDR	: 0	$)
	
	LET gvec = GADDR
	AND ft = FILETABLE
	AND gvect=ng>1000 | ng<1 -> gvec+FIRSTFREEGLOBAL, gvec+ng
	
	WRITEF("*n	MAPSTORE():*n*n	GLOBAL vector starts at: %n*n*n", gvec)
	FOR gno = gvec TO gvect DO $(
		TEST ((gno-gvec) REM 3) = 0 THEN WRITES("*n		") ELSE WRITES("	")
		WRITEF("G %i3 | %i7", gno-gvec, !gno = TRAP_X -> 0, !gno)
		$)
	WRCH('*n')
	
	WRITEF("*n	File table: %n	input: %n	output: %n*n", ft, INPUT(), OUTPUT())
	FOR fp = ft TO ft+20 DO $(
		WRITEF("*n		_ft %i2 | %x8", fp-ft, !fp)
		IF !fp THEN $(
			WRITEF("	*"%s*"*n", fp!21\=0 ->  fp!21, fp=ft -> "SYSIN", fp=ft+1 -> "SYSOUT", fp=ft+2 -> "SYSERR", "")
			FOR i=0 TO 39 DO $(
				TEST (i REM 16) = 0 THEN WRITES("*n			") ELSE IF (i REM 4) = 0 DO WRCH(' ')
				WRITEF("%x2", GETBYTE((!fp)>>2, i))
				$)
			WRCH('*n')
			$)
		$)
	WRCH('*n')
	$)

