// $Id: cg.b,v 2.1 2013/10/27 20:24:17 rn Exp $

SECTION "CG1"

GET "BCPL-CG.h"

STATIC $( WP=0; STRSIZE=0  $)


// Read an OCODE operator or argument.

/*
LET rdn() = VALOF
$( LET byte = obuf%obufp
  IF obufp>=obufq RESULTIS 0
  obufp := obufp+1
  IF byte<223 RESULTIS byte
  IF byte=223 RESULTIS -1
  RESULTIS (byte&31) + (rdn()<<5)
$)
*/

LET rdn() = VALOF
$( LET a, sign = 0, '+'
   ch := rdch() REPEATWHILE ch='*s' | ch='*n'
   IF ch=endstreamch RESULTIS 0
   IF ch='-' DO $( sign := '-'; ch := rdch() $)
   WHILE '0'<=ch<='9' DO $( a := 10*a - (ch - '0'); ch := rdch()  $)
   IF sign='-' RESULTIS a
   RESULTIS -a
$)

// Read in an OCODE label.
LET rdl() = VALOF
$( LET l = rdn()
   IF maxlab<l DO $( maxlab := l; checklab() $)
   RESULTIS l
$)

AND checklab() BE IF maxlab>=labnumber DO
$( cgerror("Too many labels - increase workspace")
   errcount := errcount+1
   longjump(fin_p, fin_l)
$)

AND cgerror(mes, a) BE
$( writes("*nError: ")
   writef(mes, a)
   newline()
   errcount := errcount+1
   IF errcount>errmax DO $( writes("Too many errors*n")
                            longjump(fin_p, fin_l)
                         $)
$)

AND outputsection() BE
$( LET outstream = output()
   UNTIL reflist=0 DO $( cgerror("Label L%n unset", h3!reflist)
                         reflist := !reflist
                      $)
   selectoutput(codestream)								// Output a section of INTCODE

/* IF bining writes("bining enabled...*n")
   TEST bining
		THEN $( writef("%X3 ", t_bhunk)					// writes 4 chars "BB8 "
          FOR p=0 TO 3      DO wrch(getbyte(stv, p))	// write bhunk size
          FOR p=0 TO stvp-1 DO wrch(getbyte(stv, p))	// write the bhunk
        $) ELSE	*/
		$(
          LET lf=0
          FOR p=0 TO stvp-1 DO
          $( LET c=getbyte(stv, p)
			 lf := c='*n' -> 0, lf+1
             wrch(c)
			 IF lf >= 80 /\ c='*s' DO $(
				writes("/*n")
				lf := 0
				$)
          $)
          newline()
		$)
   selectoutput(outstream)
$)


// .

//    CG2

// GET "BCPL-CG.h"


// MANIFEST $( CONST_SIZE = 9500 $)			// Was originally 4000.  DC: 28-Nov-2012

LET bcpl_cg() BE
	$(	LET workspacesize = 20000
		AND workspace = getvec(workspacesize)

		outstream := sysout
	//	gostream := codestream
		selectinput(findinput(ocodefile))
		codegenerate(workspace, workspacesize)
	$)


LET codegenerate(workspace, workspacesize) BE
    $(	LET cgid="INTCODE 32 CG (23-October-2013)*n"
		IF cgid%0~=0 writef("%s", cgid)
		cgid%0 := 0

		IF workspacesize<2000 DO $( cgerror("Too little workspace")
                               errcount := errcount+1
                               longjump(fin_p, fin_l)
                            $)

		progsize := 0

//	writef("...attempting rdn() [workspace=%x8, workspacesize=%n]*n", workspace, workspacesize)
		op := rdn()

//	writef("...calling cgsects(%n, %n)*n", workspace, workspacesize)
		cgsects(workspace, workspacesize)
		writef("Code size = %n bytes*n", progsize)
	$)

AND cgsects(workvec, vecsize) BE UNTIL op=0 DO
$( LET p = workvec				// start of workspace
   tempv := p					// temporary workspace(?)
   p := p+90
   tempt := p
   casek := p					// case constants(?)
   p := p+400
   casel := p					// case labels(?)
   p := p+400
   labv := p					// string constants, etc
   dp := workvec+vecsize		// end of workspace
   labnumber := (dp-p)/10+10
   labcheck := labnumber-500	// debugging...
   p := p+labnumber
   FOR lp = labv TO p-1 DO !lp := -1
   stv := p
   stvp := 0
   incode := FALSE
   linep := 0
   maxgn := 0
   maxlab := 0
   maxssp := 0
   procdepth := 0
   info_a, info_b := 0, 0
   initstack(3)
// writef("...workspace initialised:*n	tempv=#x%x8	casek=#x%x8	casel=#x%x8*n	labv=#x%x8	labnumber=%n stv=#x%x8	dp=#x%x8*n*n", tempv, casek, casel, labv, labnumber, stv, dp)
   initdatalists()

   IF op=s_section DO
	$(	MANIFEST $( upb=11 $)		// Max length of entry name
		LET n = rdn()
		LET v = VEC upb/bytesperword
		putbyte(v, 0, upb)
			// Pack up to 11 character of the name into v including
			// the first and last five.
					
		IF naming DO $(
		codeb('N'); coden(upb); codeb('*S')
			// Output up to 11 character of the name including the first and last five.
			TEST n<=upb
			THEN $( FOR i = 1 TO n DO $( codeb('C'); coden(rdn()); codeb('*S') $)
					FOR i = n+1 TO upb DO $( codeb('C'); coden('*S'); codeb('*S') $)
				$)
			ELSE $( FOR i = 1 TO 5   DO $( codeb('C'); coden(rdn()); codeb('*S') $)
					FOR i = 6 TO n-6 DO rdn() // Ignore the middle characters
					FOR i = 6 TO upb  DO $( codeb('C'); coden(rdn()); codeb('*S') $)
				$)
			$)
		op := rdn()
	$)
   
   scan()
   op := rdn()
   outputsection()
   labp := 0
//	writef("labp cleared to 0*n")
//	progsize := progsize + stvp
$)

// Initialize the simulated stack (SS).
LET initstack(n) BE
$( arg2, arg1, ssp := tempv, tempv+3, n
   pendingop := s_none
   h1!arg2, h2!arg2, h3!arg2 := k_loc, ssp-2, ssp-2
   h1!arg1, h2!arg1, h3!arg1 := k_loc, ssp-1, ssp-1
   IF maxssp<ssp DO maxssp := ssp
$)

AND initdatalists() BE
$( reflist, refliste := 0, @reflist
   rlist,   rliste   := 0, @rlist
   nlist,   nliste   := 0, @nlist
   freelist := 0
$)


// .

//    CG3


// GET "BCPL-CG.h"


LET scan() BE
    $(
	IF debug>1 DO $( writef("OP=%i3 PND=%i3 ", op, pendingop)
                    dboutput()
                 $)
	SWITCHON op INTO

	$(	DEFAULT:		cgerror("Bad OCODE op %n", op)
						ENDCASE

		CASE s_fnum:
						load(rdn(), m_n)				// first the mantissa...
						load(rdn(), m_n)				// ...then the exponent
						force_nil()
						code(f_w, opcode(op), m_n)		// flag as floating-point op
						state, ssp := NIL, ssp-2
						ENDCASE

		CASE s_selld:
						load(rdn(), m_n)				// Stack the length...
						load(rdn(), m_n)				// ...and the shift value
						force_nil()
						code(f_x, opcode(op), m_n)
						state, ssp := NIL, ssp-2
						ENDCASE

		CASE s_selst:
						load(rdn(), m_n)				// Stack the operator...
						load(rdn(), m_n)				// ...the length...
						load(rdn(), m_n)				// ...and the shift value
						force_nil()
						code(f_x, opcode(op), m_n)
						state, ssp := NIL, ssp-3
						ENDCASE

		CASE 0:			RETURN

		CASE s_end:		RETURN

		CASE s_needs:	codeb('*N')
						codeb('$'); codeb('*S'); codeb('/'); codeb('N'); codeb('E'); codeb('E'); codeb('D'); codeb('S'); codeb('*S')
						FOR i=1 TO rdn() DO codeb(rdn())
						codeb('*N')
						ENDCASE

		CASE s_debug:	WRITEF("*NState=%N, ssp=%N, ad_a=%N, ad_k=%N*N",
							state,    ssp,    ad_a,    ad_k)
						ENDCASE

		CASE s_section:
					$(	MANIFEST $( upb=11 $)		// Max length of entry name
						LET n = rdn()
					
						IF naming DO $(
						codeb('N'); coden(upb); codeb('*S')
							// Output up to 11 character of the name including the first and last five.
							TEST n<=upb
							THEN $( FOR i = 1 TO n DO $( codeb('C'); coden(rdn()); codeb('*S') $)
								FOR i = n+1 TO upb DO $( codeb('C'); coden('*S'); codeb('*S') $)
								$)
							ELSE $( FOR i = 1 TO 5   DO $( codeb('C'); coden(rdn()); codeb('*S') $)
								FOR i = 6 TO n-6 DO rdn() // Ignore the middle characters
								FOR i = 6 TO upb  DO $( codeb('C'); coden(rdn()); codeb('*S') $)
								$)
							$)
//						op := rdn()
						ENDCASE
					$)

		CASE s_lp:		load(rdn(), m_ip);	ENDCASE
		CASE s_lg:		load(rdn(), m_ig);	ENDCASE
		CASE s_ll:		load(rdl(), m_il);	ENDCASE
		CASE s_ln:		load(rdn(), m_n);	ENDCASE
		CASE s_lf:		load(rdl(), m_f);	ENDCASE

		CASE s_lstr:	cgstring(rdn()); ENDCASE

		CASE s_true:	load(-1, m_n); ENDCASE
		CASE s_false:	load(0, m_n); ENDCASE


		CASE s_llp:		load(rdn(), m_p); ENDCASE
		CASE s_llg:		load(rdn(), m_g); ENDCASE
		CASE s_lll:		load(rdl(), m_l); ENDCASE

		CASE s_sp:		storein(rdn(), m_p); ENDCASE
		CASE s_sg:		storein(rdn(), m_g); ENDCASE
		CASE s_sl:		storein(rdl(), m_l); ENDCASE

		CASE s_stind:	force_acad()
						code(f_s, ad_a, ad_k)
						ssp, state := ssp-2, NIL
						ENDCASE

		CASE s_putbyte:
			// args on the stack are as follows:
			//         top of stack  ->  arg1
			//                           arg2
			//                           arg3
			// where the operation is  arg2%arg1 := arg3
						force_nil()
						code(f_l, ssp-3, m_p)    // load address of vector on stack!
						code(f_x, opcode(s_putbyte), m_n)
						ssp := ssp-3
						state := NIL
						ENDCASE

		CASE s_float:	CASE s_fix:		CASE s_fneg:	CASE s_fabs:
		CASE s_fmult:	CASE s_fdiv:	CASE s_fplus:
		CASE s_fminus:	CASE s_feq:		CASE s_fne:
		CASE s_fls:		CASE s_fgr:		CASE s_fle:
		CASE s_fge:

		CASE s_mult:	CASE s_div:		CASE s_rem:
		CASE s_minus:	CASE s_eq:		CASE s_ne:
		CASE s_ls:		CASE s_gr:		CASE s_le:
		CASE s_ge:		CASE s_lshift:	CASE s_rshift:
		CASE s_logand:	CASE s_logor:	CASE s_neqv:
		CASE s_eqv:		CASE s_getbyte:
						force_acad()
						code(f_l, ad_a, ad_k)
						code(s_float<=op<=s_fge -> f_w, f_x, opcode(op), m_n)
						state, ssp := AC, ssp-1
						ENDCASE

		CASE s_rv:		CASE s_neg:		CASE s_not:
		CASE s_abs:
						force_ac()
						code(f_x, opcode(op), m_n)
						ENDCASE

		CASE s_plus:	force_acad()
						code(f_a, ad_a, ad_k)
						state, ssp := AC, ssp-1
						ENDCASE

		CASE s_jump:	force_nil()
						code(f_j, rdl(), m_l)
						ENDCASE

		CASE s_jt:		CASE s_jf:
						force_ac()
						code(op=s_jt->f_t, f_f, rdl(), m_l)
						ssp, state := ssp-1, NIL
						ENDCASE

		CASE s_endfor:
			// Simulate the effect of the OCODE
			//       MINUS LN 0 LE JT
			// the label follows the ENDFOR code
						force_acad()
						code(f_l, ad_a, ad_k)
						code(f_x, opcode(s_minus), m_n)
						state := AC
						ssp := ssp - 1
						load(0, m_n)
						code(f_l, ad_a, ad_k)
						code(f_x, opcode(s_le), m_n)
						code(f_t, rdl(), m_l)
						ssp := ssp - 2
						state := NIL
						ENDCASE

		CASE s_goto:	force_ad()
						code(f_j, ad_a, ad_k)
						ssp, state := ssp-1, NIL
						ENDCASE

		CASE s_lab:		force_nil()
						complab(rdl())
						ENDCASE

		CASE s_query:	force_nil(); ssp := ssp + 1; ENDCASE

		CASE s_stack:	force_nil(); ssp := rdn(); ENDCASE

		CASE s_store:	force_nil(); ENDCASE

		CASE s_entry: $(
						LET n = rdn()
						LET l = rdl()
						codeb('*n'); codeb('$'); codeb('*s'); codeb('/')
						FOR i = 1 TO n DO codeb(rdn()) // Write the function name
						codeb('*n'); codeb(' ')
						complab(l)
						state, ad_a, ad_k := NIL, 0, m_n
						ENDCASE	$)

		CASE s_save:	ssp := rdn(); ENDCASE

		CASE s_endproc: rdn();							//	discard the ending status code
						ENDCASE
		CASE s_rtap:
		CASE s_fnap: $(
						LET K = rdn()
						force_ac()
						code(f_k, K, m_n)
						TEST op=s_fnap
							THEN ssp, state := K+1, AC
							OR ssp, state := K, NIL
						ENDCASE   $)

		CASE s_fnrn:	force_ac()
						ssp := ssp - 1
		CASE s_rtrn:	code(f_x, opcode(s_rtrn), m_n)
						state := NIL
						ENDCASE

		CASE s_res:		force_ac()
						code(f_j, rdl(), m_l)
						ssp, state := ssp-1, NIL
						ENDCASE

		CASE s_rstack:	force_nil()
						ssp, state := rdn()+1, AC
						ENDCASE

		CASE s_finish:	code(f_x, opcode(op), m_n); ENDCASE

		CASE s_switchon: $(
						LET N = rdn()
						LET D = rdl()
						force_ac()
						code(f_x, opcode(op), m_n)
						code(f_d, N, m_n)
						code(f_d, D, m_l)
						ssp, state := ssp-1, NIL
						FOR i = 1 TO N DO $(
							code(f_d, rdn(), m_n)
							code(f_d, rdl(), m_l)  $)
						ENDCASE  $)

		CASE s_global:
						codeb('*N')
//	writef("labp=%n*n", labp)
						FOR i = 0 TO labp-2 BY 2 DO wrdata(labv!i, labv!(i+1))
						codeb('*N')
						FOR i = 1 TO rdn() DO $(
							codeb('G'); coden(rdn())
							codeb('L'); coden(rdl()); codeb('*S')	$)
						codeb('*N'); codeb('Z'); codeb('*N')
						RETURN

		CASE s_datalab:
		CASE s_iteml:	data(op, rdl())
						ENDCASE

		CASE s_itemn:	data(op, rdn())
						ENDCASE

	$)
	op := rdn()

$) REPEAT


// .

//    CG4


// GET "BCPL-CG.h"
 

//
//  This code deals with the generation of INTCODE for loads and stores.
//


//  The INTCODE stack may be in one of four states (kept in STATE):
//
//     STATE = NIL
//          top of stack - (offset SSP-1) - in stack frame
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//          No pending load
//
//     STATE = AC
//          top of stack - (offset SSP-1) - in INTCODE register A
//          second of stack - (offset SSP-2) - in stack frame
//          No pending load
//
//     STATE = AD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//
//     STATE = ACAD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in INTCODE register A
//
//  The two variables AD_A and AD_K hold the address and address modifier
//  of a pending load.  This load will be performed when next necessary.

// LOADS are made into variables on the stack - and hence use M_IP
// STORES are made from addresses on the stack - and hence use M_P

LET force_nil() BE
// Forces NIL state - so that INTCODE register A is empty and there are
// no pending loads.
      SWITCHON state INTO
      $(	 CASE ACAD: code(f_s, ssp-2, m_p)

         CASE AD:   code(f_l, ad_a, ad_k)

         CASE AC:   code(f_s, ssp-1, m_p)
                    state := NIL

         CASE NIL:  $)

AND force_ad() BE
// Forces AD state in which the variables AD_A and AD_K hold details of a
// pending load and INTCODE register A is empty.
      SWITCHON state INTO
      $(	 CASE ACAD:	code(f_s, ssp-2, m_p)
                    GOTO L

         CASE AC:   code(f_s, ssp-1, m_p)

         CASE NIL:	ad_a, ad_k := ssp-1, m_ip
         L:			state := AD

         CASE AD:    $)

AND force_ac() BE
// Forces AC state in which the INTCODE register A holds the top of stack
// and there are no pending loads.
      SWITCHON state INTO
      $(	 CASE NIL:  code(f_l, ssp-1, m_ip)
                    GOTO L

         CASE ACAD: code(f_s, ssp-2, m_p)

         CASE AD:   code(f_l, ad_a, ad_k)
         L:         state := AC

         CASE AC:   $)

AND force_acad() BE
// Forces state ACAD in which AD_A and AD_K hold details of the pending
// load of the top of stack and INTCODE register A holds the next of stack.
      SWITCHON state INTO
      $(	 CASE AD:   code(f_l, ssp-2, m_ip)
                    GOTO L

         CASE AC:   code(f_s, ssp-1, m_p)

         CASE NIL:  code(f_l, ssp-2, m_ip)
                    ad_a, ad_k := ssp-1, m_ip
         L:         state := ACAD

         CASE ACAD:  $)

AND swap() BE
// This procedure swaps the top two elements on the stack represented
// in state STATE and leaves the stack in state ACAD.  (with the top
// two registers pending and in the A register respectively).
	$(	state := ACAD   // for most of them:
		SWITCHON state INTO
		$(	CASE NIL:
			// load A register with the top of stack:
					code(f_l, ssp-1, m_ip)
					ENDCASE

			CASE AD:
			// Do pending load
					code(f_l, ad_a, ad_k)

			CASE AC:
			// Store A into top of stack (instead of second of stack)
					code(f_s, ssp-1, m_p)
					ENDCASE

			CASE ACAD:
			// We want to load the stack in the order
			//       <pending load>
			//       <intcode register A>
			// this would mean saving register A whilst it is used for
			// stacking the pending load.  However, we can save the
			// intcode register A first if we are sure that it does not
			// affect the pending load which will have to be done subsequently
			// - i.e. so long as the pending load is not from the top
			// of stack to which we will write register A.
					TEST ad_a=ssp-1 & (ad_k=m_p | ad_k=m_ip)
					THEN $( // too bad - we'll have to save A first
						code(f_s, ssp, m_p)
						code(f_l, ad_a, ad_k)   // do pending load
						code(f_s, ssp-2, m_p)   // put in swapped position
						code(f_l, ssp, m_p)     // get A back
						state := AC
						$)
					ELSE $( code(f_s, ssp-1, m_p)
						code(f_l, ad_a, ad_k)
						code(f_s, ssp-2, m_p)   // put back into second of stack
						state := NIL
						$)
		$)
		ad_a := ssp-2      // for when STATE = AD or ACAD
		ad_k := m_ip	$)

AND load(A, K) BE
// A - the new contents of the accumulator A
// K - the kind (mode) in which the operand is to be fetched
//     (an M_<flags> constant typically)
// This procedure frees the pending load given in AD_A and AD_K (if there
// is one) and then loads A and K into them.
      SWITCHON state INTO
      $(	 CASE NIL: state := AD
                   GOTO M

         CASE ACAD:
         CASE AD:  force_ac()
         CASE AC:  state := ACAD
         M:        ad_a, ad_k := A, K
                   ssp := ssp + 1  $)


AND storein(A, K) BE
    $(	force_ac()
		code(f_s, A, K)
		ssp, state := ssp-1, NIL  $)

AND cgstring(n) BE
    $(	LET l = nextparam()
        data(s_datalab, l)
        data(s_char, n)
        FOR i = 1 TO n DO data(s_char, rdn())
        load(l, m_l)
        RETURN  $)

AND data(k, v) BE
    $(	LET p = labp
		labv!p, labv!(p+1) := k, v
		labp := labp + 2
//	writef("labv(#x%x8)+labp(#x%x8) = #x%x8, stv=#x%x8*n", labv, labp, labv+labp, stv)
		IF labv+labp>stv DO
              $( cgerror("Too many constants - increase workspace")
				 labp := 0  $)  $)

AND nextparam() = VALOF $( labnumber := labnumber - 1
						   IF labnumber = 0 cgerror("Too many labels - increase workspace")
                           RESULTIS labnumber  $)

// .

//    CG5


// GET "BCPL-CG.h"


LET code(F, A, K) BE
// F - function = F_L  F_S  F_A  F_J  F_T  F_F  F_K  F_X or F_W
// A - data (D field in INTCODE)
// K - mode in which data is to be fetched, one of:
//        M_N    -  normal
//        M_I    -  indirect
//        M_IG   -  indirect global
//        M_P    -  local variable (relative to stack frame)
//        M_IP   -  indirect local
//        M_L    -  label
//        M_IL   -  indirect label
//        M_F    -  function
//        M_IF   -  indirect function
    $(  codeb(F)
       SWITCHON K INTO
       $(  CASE m_i:		codeb('I')
          CASE m_n:		ENDCASE

          CASE m_ig:	codeb('I')
          CASE m_g:		codeb('G'); ENDCASE

          CASE m_ip:	codeb('I')
          CASE m_p:		codeb('P'); ENDCASE

          CASE m_il:	codeb('I')
          CASE m_l:		codeb('L'); ENDCASE

          CASE m_if:	codeb('I')
          CASE m_f:		codeb('F'); ENDCASE  $)

       coden(A)
       codeb(' ')
	   $)

AND complab(N) BE $( coden(N); codeb(' ')  $)

AND wrdata(K, N) BE SWITCHON K INTO
      $( CASE s_datalab: complab(N); RETURN

         CASE s_itemn: code(f_d, N, m_n); RETURN

         CASE s_iteml: code(f_d, N, m_l); RETURN

         CASE s_char:  code(f_c, N, m_n); RETURN  $)

AND checkspace() BE IF stvp/4>dp-stv DO
$( cgerror("Program too large, %n bytes compiled", stvp)
   errcount := errcount+1
   longjump(fin_p, fin_l)
$)

AND codeb(byte) BE
$( putbyte(stv, stvp, byte)
   stvp := stvp + 1
   checkspace()
   progsize := progsize + 1
$)

AND coden(n) BE
$( IF debug>0 DO writef("%i4:  DATAW 0x%x8*n", stvp, n)

//	This next is ugly: on a 32-bit machine MAXINT is 2147483647 while MININT is -2147483648 (#X80000000)
//	Negating MININT is too big for MAXINT (2^31 = #X7FFFFFFF), so we have to cheat...
	IF n<(-MAXINT) DO $( codeb('-'); codeb('2'); n := 147483648 $)
	IF n<0 DO $( codeb('-'); n := -n $)
	IF n>=10 DO coden(n / 10)
	codeb('0' + n REM 10)
$)

AND opcode(op) = VALOF SWITCHON op INTO
     $(	CASE s_rv:		RESULTIS 1				// 1)	A := Location (A)
        CASE s_fneg:
        CASE s_neg:		RESULTIS 2				// 2)	A := -A
        CASE s_not:		RESULTIS 3				// 3)	A := NOT A
        CASE s_rtrn:	RESULTIS 4				// 4)	This causes a return from the current function or routine;
												//		by convention the result of a function is left in A.
												//		C := Location(P + 1)
												//		P := Location(P)
        CASE s_fmult:
        CASE s_mult:	RESULTIS 5				// 5)	A := B * A
        CASE s_fdiv:
        CASE s_div:		RESULTIS 6				// 6)	A := B / A
        CASE s_rem:		RESULTIS 7				// 7)	A := B REM A
        CASE s_fplus:
        CASE s_plus:	RESULTIS 8				// 8)	A := B + A
        CASE s_fminus:
        CASE s_minus:	RESULTIS 9				// 9)	A := B - A
        CASE s_feq:
        CASE s_eq:		RESULTIS 10				// 10)	A := B = A
        CASE s_fne:
        CASE s_ne:		RESULTIS 11				// 11)	A := B ~= A
        CASE s_fls:
        CASE s_ls:		RESULTIS 12				// 12)	A := B < A
        CASE s_fge:
        CASE s_ge:		RESULTIS 13				// 13)	A := B >= A
        CASE s_fgr:
        CASE s_gr:		RESULTIS 14				// 14)	A := B > A
        CASE s_fle:
        CASE s_le:		RESULTIS 15				// 15)	A := B <= A
        CASE s_lshift:	RESULTIS 16				// 16)	A := B LSHIFT A
        CASE s_rshift:	RESULTIS 17				// 17)	A := B RSHIFT A
        CASE s_logand:	RESULTIS 18				// 18)	A := B LOGAND A
        CASE s_logor:	RESULTIS 19				// 19)	A := B LOGOR A
        CASE s_neqv:	RESULTIS 20				// 20)	A := B NEQV A
        CASE s_eqv:		RESULTIS 21				// 21)	A := B EQV A
        CASE s_finish:	RESULTIS 22				// 22)	FINISH
        CASE s_switchon:RESULTIS 23				// 23)	Switch on the value of A using data in the location
												//		addressed by C, C+1 etc.
												//		B, D := Location(C), Location(C + 1)
												//		UNTIL B = 0 DO
												//			$(	B, C := B - 1, C + 2
												//				IF A=Location(C) DO
												//					$(	D := Location(C + 1)
												//						BREAK $)       $)
												//		C := D
												// (24) - 35) are implementation dependent)
        CASE s_getbyte:	RESULTIS 36				// 36)	GETBYTE()
        CASE s_putbyte:	RESULTIS 37				// 37)	PUTBYTE()
												// (38) - 43) are implementation dependent)
        CASE s_fabs:
        CASE s_abs:		RESULTIS 44				// 44)	A := ABS A
        CASE s_selld:	RESULTIS 46				// 46)	Load selector
        CASE s_selst:	RESULTIS 47				// 47)	Store selector

		//	Floating point ops:
        CASE s_fnum:	RESULTIS 60				// 60)
        CASE s_float:	RESULTIS 61				// 61)
        CASE s_fix:		RESULTIS 62				// 62)

        DEFAULT: WRITEF("*NUnknown OP %N*N", op)
                 RESULTIS 0  $)

AND wr(ch) BE
    $( IF ch='*N' DO $( wrch('*N')
                        linep := 0
                        RETURN  $)

       IF linep=71 DO
              $( wrch('/')
                 wrch('*N')
                 linep := 0  $)
       linep := linep + 1
       wrch(ch)  $)

AND dboutput() BE
$( LET p = info_a
   writes("A=(")
   UNTIL p=0 DO $( wrkn(h2!p, h3!p)
                   p := !p
                   UNLESS p=0 DO wrch('*s')
                $)
    
   p := info_b
   writes(") B=(")
   UNTIL p=0 DO $( wrkn(h2!p, h3!p)
                   p := !p
                   UNLESS p=0 DO wrch('*s')
                $)
   wrch(')')
   
   IF debug=2 DO $( writes("  STK: ")
                    FOR p=tempv TO arg1 BY 3  DO
                    $( IF (p-tempv) REM 30 = 10 DO newline()
                       wrkn(h1!p,h2!p)
                       wrch('*s')
                    $)
                 $)
   
   IF debug=3 DO $(  LET l = rlist
                     writes("*nREFS ")
                     UNTIL l=0 DO $( writef("%n L%n  ", l!1, l!2)
                                     l := !l
                                  $)
                 $)
   newline()
$)

AND wrkn(k,n) BE
$( LET s = VALOF SWITCHON k INTO
   $( DEFAULT:       k := n
                     RESULTIS "?"
      CASE k_none:   RESULTIS "-"
      CASE k_numb:   RESULTIS "N"
      CASE k_fnlab:  RESULTIS "F"
      CASE k_lvloc:  RESULTIS "@P"
      CASE k_lvglob: RESULTIS "@G"
      CASE k_lvlab:  RESULTIS "@L"
      CASE k_a:      RESULTIS "A"
      CASE k_b:      RESULTIS "B"
      CASE k_c:      RESULTIS "C"
      CASE k_loc:    RESULTIS "P"
      CASE k_glob:   RESULTIS "G"
      CASE k_lab:    RESULTIS "L"
      CASE k_loc0:   RESULTIS "0P"
      CASE k_loc1:   RESULTIS "1P"
      CASE k_loc2:   RESULTIS "2P"
      CASE k_loc3:   RESULTIS "3P"
      CASE k_loc4:   RESULTIS "4P"
      CASE k_glob0:  RESULTIS "0G"
      CASE k_glob1:  RESULTIS "1G"
      CASE k_glob2:  RESULTIS "2G"
   $)
   writes(s)
   UNLESS k=k_none | k=k_a | k=k_b | k=k_c DO writen(n)
$)


