// $Id: asc2ebc.b, v 1.0 2021/03/19 15:29:27 rn Exp $

//     This is an ASCII <-> EBCDIC translator

GET "LIBHDR"

GLOBAL $(
ops		: 100
ips		: 102
ETOA	: 103
ATOE	: 104
$)

MANIFEST $(
  WORDSIZE=32
  BYTESIZE=8
$)

LET START() BE
$(1
LET ch, num = '*n', 0
AND xlate = ?

ATOE := TABLE
          0,  0,  0,  0,  0,  0,  0,  0,		// ASCII TO EBCDIC
          0,  5, 21,  0, 12,  0,  0,  0,		// '*T' '*N' '*P'
          0,  0,  0,  0,  0,  0,  0,  0,
          0,  0,  0,  0,  0,  0,  0,  0,

         64, 90,127,123, 91,108, 80,125,		// '*S' ! " # $ % & '
         77, 93, 92, 78,107, 96, 75, 97,		//   (  ) * + , - . /
        240,241,242,243,244,245,246,247,		//   0  1 2 3 4 5 6 7
        248,249,122, 94, 76,126,110,111,		//   8  9 : ; < = > ?
        124,193,194,195,196,197,198,199,		//   @  A B C D E F G
        200,201,209,210,211,212,213,214,		//   H  I J K L M N O
        215,216,217,226,227,228,229,230,		//   P  Q R S T U V W
        231,232,233, 66, 98, 67,101,102,		//   X  Y Z [ \ ] ^ _
         64,129,130,131,132,133,134,135,		//      a b c d e f g
        136,137,145,146,147,148,149,150,		//   h  i j k l m n o
        151,152,153,162,163,164,165,166,		//   p  q r s t u v w
        167,168,169, 64, 79, 64, 95,255			//   x  y z   |   ~


ETOA := TABLE
      0,   0,   0,   0,   0, #11,   0,   0,
      0,   0,   0, #13, #14, #15,   0,   0,
      0,   0,   0,   0,   0, #12,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0, #12,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
    #40,   0,#133,#135,   0,   0,   0,   0,
      0,   0,   0, #56, #74, #50, #53,#174,
    #46,   0,   0,   0,   0,   0,   0,   0,
      0,   0, #41, #44, #52, #51, #73,#176,
    #55, #57,#134,   0,   0,#136,#137,   0,
      0,   0,   0, #54, #45,#140, #76, #77,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0, #72, #43,#100, #47, #75, #42,
      0,#141,#142,#143,#144,#145,#146,#147,
   #150,#151,   0,   0,   0,   0,   0,   0,
      0,#152,#153,#154,#155,#156,#157,#160,
   #161,#162,   0,   0,   0,   0,   0,   0,
      0,   0,#163,#164,#165,#166,#167,#170,
   #171,#172,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,#101,#102,#103,#104,#105,#106,#107,
   #110,#111,   0,   0,   0,   0,   0,   0,
      0,#112,#113,#114,#115,#116,#117,#120,
   #121,#122,   0,   0,   0,   0,   0,   0,
      0,   0,#123,#124,#125,#126,#127,#130,
   #131,#132,   0,   0,   0,   0,   0,   0,
    #60, #61, #62, #63, #64, #65, #66, #67,
    #70, #71,   0,   0,   0,   0,   0,   0

IF argc<2 $(
  writes("Insufficient arguments for asc2ebc...*n")
  stop()
$)

xlate := ATOE									//	...ASCII to EBCDIC is the default

IF argc=3 $(
  LET mode = (argv!2)
  FOR i=1 TO mode%0 IF mode%i='e' | mode%i='E' xlate := ETOA			//	EBCDIC to ASCII required
// writef("mode=%c, xlate=%s*n", mode, xlate=ATOE->"ATOE",xlate=ETOA->"ETOA","garbage")
$)

writef("Translating %s to %s...*n", argv!0, argv!1)

ips := findinput(argv!0)
ops := findoutput(argv!1)
/*	
 *	FOR i=0 TO 128 $(
 *	   writef("i=%n, x=%n*n", i, xlate!i)
 *	   ch := xlate!i
 *	   IF ch=0 ch := '-'
 *	   writef("%c ", ch)
 *	$)
 */
SELECTINPUT(ips)
SELECTOUTPUT(ops)

$( ch := rdch()
   IF ch=endstreamch BREAK
   num := num+1
   wrch(xlate!ch)
$) REPEAT

SELECTINPUT(sysin)
SELECTOUTPUT(sysout)

WRITEF("*n%n characters translated*n", num)

$)1


