//////////////////////////////////////////////////////////
// Name: Peter M. Maurer
// Program: Sieve of Eratosthenes
// Due: Never
// Language: BCPL
//////////////////////////////////////////////////////////

GET "libhdr"

MANIFEST {
	range=2048
}

LET start() = VALOF
{
	// define the sieve data structure
	LET candidates = getvec(range)
	LET i,j,k = 0,0,0
	

	FOR z = 0 TO range DO
	{
		// everything is potentially prime until proven otherwise
		candidates!z := 1
	}
	// Neither 1 nor 0 is prime, so flag them off
	candidates!0 := 0
	candidates!1 := 0
	// start the sieve with the integer 0
	i := 0
	WHILE i<=range DO
	{
		// advance to the next un-crossed out number.
		// this number must be a prime
		WHILE i <= range & candidates!i = 0 DO
		{
			i := i + 1
		}
		// insure against running off the end of the data structure
		IF i<=range DO
		{
			// cross out all multiples of the prime, starting with 2*p.
			j := 2
			k := i * j
			WHILE k <= range DO
			{
				candidates!k := 0
				j := j + 1
				k := i * j
			}
			// advance to the next candidate
			i := i + 1
		}
	}
	// all uncrossed-out numbers are prime (and only those numbers)
	// print all primes
	
	writef("*nPrime numbers from 1 to %n by the Sieve of Eratosthenes:*n*n", range)
	{	LET epl = 1
		FOR z = 0 TO range DO
		IF candidates!z DO {
			epl := epl+1
			writef("%n	", z)
			IF epl REM 10 = 0 {
				newline()
				epl := 1
			}
		}
	}
	writes("*n*nEnd of list...*n")
	RESULTIS 0
}
