@echo off

setlocal enabledelayedexpansion
if errorlevel 1 (
  echo Unable to enable delayed expansion - aborting!
  goto eof
)

rem 	Script to create i386pe_mgw.x

set vn=1
set rvn=00
set edt=20-Apr-2020

rem	Vn 1.00	20-Apr-2020	Initial version

if not defined GnuWin (
  echo.
  echo 	'GnuWin' is not defined - please run 'BCPLenv'
  echo .
  goto eof
)

set opf="loader scripts\i386pe_mgw.x"
set GWin=

set pos=0
:loop
set /a pos+=1

for /f "tokens=%pos% delims=\" %%i in ("%GnuWin%") do (
  if '%%i' == '' (
    set flag=done
  ) else (
    set GWin=!GWin!/%%i
    rem echo %%i
  )
)
rem pause
if defined flag goto xloop
if %pos% gtr 10 (
  goto xloop
)
goto loop

:xloop

echo /* Created by BCPLkit's %0 Vn %vn%.%rvn% %edt% on %date% at %time% */>%opf%
echo. >>%opf%
echo /* Default linker script, for normal executables */>>%opf%
echo OUTPUT_FORMAT(pei-i386)>>%opf%
echo SEARCH_DIR("%GWin%/lib/gcc/mingw32/4.7.1"); SEARCH_DIR("%GWin%/lib/gcc"); SEARCH_DIR("%GWin%/mingw32/lib"); SEARCH_DIR("%GWin%/lib");>>%opf%
echo SECTIONS>>%opf%
echo {>>%opf%
echo   /* Make the virtual address and file offset synced if the alignment is>>%opf%
echo      lower than the target page size. */>>%opf%
echo   . = SIZEOF_HEADERS;>>%opf%
echo   . = ALIGN(__section_alignment__);>>%opf%
echo   .text  __image_base__ + ( __section_alignment__ ^< 0x1000 ? . : __section_alignment__ ) :>>%opf%
echo   {>>%opf%
echo      *(.init)>>%opf%
echo     *(.text)>>%opf%
echo     *(SORT(.text$*))>>%opf%
echo     *(.glue_7t)>>%opf%
echo     *(.glue_7)>>%opf%
echo      ___CTOR_LIST__ = .; __CTOR_LIST__ = . ;>>%opf%
echo 			LONG (-1);*(.ctors); *(.ctor); *(SORT(.ctors.*));  LONG (0);>>%opf%
echo      ___DTOR_LIST__ = .; __DTOR_LIST__ = . ;>>%opf%
echo 			LONG (-1); *(.dtors); *(.dtor); *(SORT(.dtors.*));  LONG (0);>>%opf%
echo      *(.fini)>>%opf%
echo     /* ??? Why is .gcc_exc here?  */>>%opf%
echo      *(.gcc_exc)>>%opf%
echo     PROVIDE (etext = .);>>%opf%
echo      *(.gcc_except_table)>>%opf%
echo   }>>%opf%
echo   /* The Cygwin32 library uses a section to avoid copying certain data>>%opf%
echo      on fork.  This used to be named ".data".  The linker used>>%opf%
echo      to include this between __data_start__ and __data_end__, but that>>%opf%
echo      breaks building the cygwin32 dll.  Instead, we name the section>>%opf%
echo      ".data_cygwin_nocopy" and explictly include it after __data_end__. */>>%opf%
echo   .data BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     __data_start__ = . ;>>%opf%
echo     *(.data)>>%opf%
echo     *(.data2)>>%opf%
echo     *(SORT(.data$*))>>%opf%
echo     *(.jcr)>>%opf%
echo     __data_end__ = . ;>>%opf%
echo     *(.data_cygwin_nocopy)>>%opf%
echo   }>>%opf%
echo   .rdata BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     *(.rdata)>>%opf%
echo              *(SORT(.rdata$*))>>%opf%
echo      *(.eh_frame)>>%opf%
echo     ___RUNTIME_PSEUDO_RELOC_LIST__ = .;>>%opf%
echo     __RUNTIME_PSEUDO_RELOC_LIST__ = .;>>%opf%
echo     *(.rdata_runtime_pseudo_reloc)>>%opf%
echo     ___RUNTIME_PSEUDO_RELOC_LIST_END__ = .;>>%opf%
echo     __RUNTIME_PSEUDO_RELOC_LIST_END__ = .;>>%opf%
echo   }>>%opf%
echo   .pdata BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     *(.pdata)>>%opf%
echo   }>>%opf%
echo   .bss BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     __bss_start__ = . ;>>%opf%
echo     *(.bss)>>%opf%
echo     *(COMMON)>>%opf%
echo     __bss_end__ = . ;>>%opf%
echo   }>>%opf%
echo   .edata BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     *(.edata)>>%opf%
echo   }>>%opf%
echo   /DISCARD/ :>>%opf%
echo   {>>%opf%
echo     *(.debug$S)>>%opf%
echo     *(.debug$T)>>%opf%
echo     *(.debug$F)>>%opf%
echo     *(.drectve)>>%opf%
echo   }>>%opf%
echo   .idata BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     /* This cannot currently be handled with grouped sections.>>%opf%
echo 	See pe.em:sort_sections.  */>>%opf%
echo     SORT(*)(.idata$2)>>%opf%
echo     SORT(*)(.idata$3)>>%opf%
echo     /* These zeroes mark the end of the import list.  */>>%opf%
echo     LONG (0); LONG (0); LONG (0); LONG (0); LONG (0);>>%opf%
echo     SORT(*)(.idata$4)>>%opf%
echo     SORT(*)(.idata$5)>>%opf%
echo     SORT(*)(.idata$6)>>%opf%
echo     SORT(*)(.idata$7)>>%opf%
echo   }>>%opf%
echo   .CRT BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     ___crt_xc_start__ = . ;>>%opf%
echo     *(SORT(.CRT$XC*))  /* C initialization */>>%opf%
echo     ___crt_xc_end__ = . ;>>%opf%
echo     ___crt_xi_start__ = . ;>>%opf%
echo     *(SORT(.CRT$XI*))  /* C++ initialization */>>%opf%
echo     ___crt_xi_end__ = . ;>>%opf%
echo     ___crt_xl_start__ = . ;>>%opf%
echo     *(SORT(.CRT$XL*))  /* TLS callbacks */>>%opf%
echo     /* ___crt_xl_end__ is defined in the TLS Directory support code */>>%opf%
echo     ___crt_xp_start__ = . ;>>%opf%
echo     *(SORT(.CRT$XP*))  /* Pre-termination */>>%opf%
echo     ___crt_xp_end__ = . ;>>%opf%
echo     ___crt_xt_start__ = . ;>>%opf%
echo     *(SORT(.CRT$XT*))  /* Termination */>>%opf%
echo     ___crt_xt_end__ = . ;>>%opf%
echo   }>>%opf%
echo   .tls BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     ___tls_start__ = . ;>>%opf%
echo     *(.tls)>>%opf%
echo     *(.tls$)>>%opf%
echo     *(SORT(.tls$*))>>%opf%
echo     ___tls_end__ = . ;>>%opf%
echo   }>>%opf%
echo   .endjunk BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     /* end is deprecated, don't use it */>>%opf%
echo     PROVIDE (end = .);>>%opf%
echo     PROVIDE ( _end = .);>>%opf%
echo      __end__ = .;>>%opf%
echo   }>>%opf%
echo   .rsrc BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     *(.rsrc)>>%opf%
echo     *(SORT(.rsrc$*))>>%opf%
echo   }>>%opf%
echo   .reloc BLOCK(__section_alignment__) :>>%opf%
echo   {>>%opf%
echo     *(.reloc)>>%opf%
echo   }>>%opf%
echo   .stab BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.stab)>>%opf%
echo   }>>%opf%
echo   .stabstr BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.stabstr)>>%opf%
echo   }>>%opf%
echo   /* DWARF debug sections.>>%opf%
echo      Symbols in the DWARF debugging sections are relative to the beginning>>%opf%
echo      of the section.  Unlike other targets that fake this by putting the>>%opf%
echo      section VMA at 0, the PE format will not allow it.  */>>%opf%
echo   /* DWARF 1.1 and DWARF 2.  */>>%opf%
echo   .debug_aranges BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_aranges)>>%opf%
echo   }>>%opf%
echo   .debug_pubnames BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_pubnames)>>%opf%
echo   }>>%opf%
echo   /* DWARF 2.  */>>%opf%
echo   .debug_info BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_info) *(.gnu.linkonce.wi.*)>>%opf%
echo   }>>%opf%
echo   .debug_abbrev BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_abbrev)>>%opf%
echo   }>>%opf%
echo   .debug_line BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_line)>>%opf%
echo   }>>%opf%
echo   .debug_frame BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_frame)>>%opf%
echo   }>>%opf%
echo   .debug_str BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_str)>>%opf%
echo   }>>%opf%
echo   .debug_loc BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_loc)>>%opf%
echo   }>>%opf%
echo   .debug_macinfo BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_macinfo)>>%opf%
echo   }>>%opf%
echo   /* SGI/MIPS DWARF 2 extensions.  */>>%opf%
echo   .debug_weaknames BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_weaknames)>>%opf%
echo   }>>%opf%
echo   .debug_funcnames BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_funcnames)>>%opf%
echo   }>>%opf%
echo   .debug_typenames BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_typenames)>>%opf%
echo   }>>%opf%
echo   .debug_varnames BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_varnames)>>%opf%
echo   }>>%opf%
echo   /* DWARF 3.  */>>%opf%
echo   .debug_ranges BLOCK(__section_alignment__) (NOLOAD) :>>%opf%
echo   {>>%opf%
echo     *(.debug_ranges)>>%opf%
echo   }>>%opf%
echo }>>%opf%


echo.
echo 	%opf% created!
echo.
echo 	Please check, and if correct please copy to...
echo 	'%gnuWin%\mingw32\lib\ldscripts'
echo 	(NB:	You may need administrator's access rights to do this)
echo.

:eof

