// $Id: cg.bcpl,v 1.5 2012/12/13 21:44:47 rn Exp $

//    CG1

GET "CGHDR"

STATIC $( WP=0; STRSIZE=0  $)

LET T(S) = VALOF
      $( FOR I = 0 TO STRSIZE DO UNLESS S!I=WORDV!I RESULTIS FALSE
         RESULTIS TRUE  $)

LET READOP() = VALOF
    $(1 LET S = VEC 20

        IF CH='*N' \/ CH='*S' $( CH := RDCH() $) REPEATWHILE CH='*N' \/ CH='*S'
//		WRITEF("[%C]", CH)
        WP := 0

        WHILE 'A'<=CH<='Z' DO
           $( WP := WP + 1
              S!WP := CH
              CH := RDCH()  $)

        S!0 := WP										// vec S now has the item, one char per word, length in S!0
        STRSIZE := PACKSTRING(S, WORDV)					// WORDV has the item as a BCPL string
//		WRITEF("[%S]*n", WORDV)

        SWITCHON S!1 INTO								// ...first CH of item
     $( DEFAULT: IF CH=ENDSTREAMCH RESULTIS S.END
                 RESULTIS ERROR

        CASE 'A':
		RESULTIS T("ABS") -> S.ABS, ERROR

        CASE 'D':
        RESULTIS T("DATALAB") -> S.DATALAB,
                 T("DIV") -> S.DIV,
                 T("DEBUG") -> S.DEBUG, ERROR

        CASE 'E':
        RESULTIS T("EQ") -> S.EQ,
                 T("ENTRY") -> S.ENTRY,
                 T("EQV") -> S.EQV,
                 T("ENDPROC") -> S.ENDPROC,
                 T("END") -> S.END, ERROR

        CASE 'F':
        RESULTIS T("FNAP") -> S.FNAP,
                 T("FNRN") -> S.FNRN,
                 T("FALSE") -> S.FALSE,
                 T("FINISH") -> S.FINISH, ERROR


        CASE 'G':
        RESULTIS T("GOTO") -> S.GOTO,
                 T("GE") -> S.GE,
                 T("GR") -> S.GR,
				 T("GETBYTE") -> S.GETBYTE,
                 T("GLOBAL") -> S.GLOBAL, ERROR

        CASE 'I':
        RESULTIS T("ITEMN") -> S.ITEMN,
                 T("ITEML") -> S.ITEML,  ERROR

        CASE 'J':
        RESULTIS T("JUMP") -> S.JUMP,
                 T("JF") -> S.JF,
                 T("JT") -> S.JT,  ERROR

        CASE 'L':
        IF WP=2 DO
             SWITCHON S!2 INTO
             $( DEFAULT: RESULTIS ERROR
                CASE 'E': RESULTIS S.LE
				CASE 'F': RESULTIS S.LF
                CASE 'N': RESULTIS S.LN
                CASE 'G': RESULTIS S.LG
                CASE 'P': RESULTIS S.LP
                CASE 'L': RESULTIS S.LL
                CASE 'S': RESULTIS S.LS  $)

        RESULTIS T("LAB") -> S.LAB,
                 T("LLG") -> S.LLG,
                 T("LLL") -> S.LLL,
                 T("LLP") -> S.LLP,
                 T("LOGAND") -> S.LOGAND,
                 T("LOGOR") -> S.LOGOR,
                 T("LSHIFT") -> S.LSHIFT,
                 T("LSTR") -> S.LSTR, ERROR

        CASE 'M':
        RESULTIS T("MINUS") -> S.MINUS,
                 T("MULT") -> S.MULT, ERROR

        CASE 'N':
        RESULTIS  T("NE") -> S.NE,
                  T("NEG") -> S.NEG,
                  T("NEQV") -> S.NEQV,
                  T("NOT") -> S.NOT,  ERROR

        CASE 'P':
        RESULTIS T("PLUS") -> S.PLUS,
				 T("PUTBYTE") -> S.PUTBYTE, ERROR

        CASE 'Q':
        RESULTIS T("QUERY") -> S.QUERY, ERROR

        CASE 'R':
        RESULTIS T("RES") -> S.RES,
                 T("REM") -> S.REM,
                 T("RTAP") -> S.RTAP,
                 T("RTRN") -> S.RTRN,
                 T("RSHIFT") -> S.RSHIFT,
                 T("RSTACK") -> S.RSTACK,
                 T("RV") -> S.RV, ERROR

        CASE 'S':
        RESULTIS T("SG") -> S.SG,
                 T("SP") -> S.SP,
                 T("SL") -> S.SL,
                 T("STIND") -> S.STIND,
                 T("STACK") -> S.STACK,
                 T("SAVE") -> S.SAVE,
                 T("SWITCHON") -> S.SWITCHON,
                 T("STORE") -> S.STORE,
				 T("SECTION") -> S.SECTION, ERROR

        CASE 'T':
        RESULTIS T("TRUE") -> S.TRUE, ERROR              $)1


AND RDN() = VALOF
    $(1 LET A, NEG = 0, FALSE

        CH := RDCH() REPEATWHILE CH='*N' \/ CH='*S'
		
		TEST CH='*'' THEN
				  $( A := RDCH()						// 'number' is offered as a quoted single character, ie 'g'
					 WHILE CH \= '*S' & CH \= '*N' DO CH := RDCH()	// Throw away everything following...
				  $) ELSE $(
        IF CH='-' DO $( NEG := TRUE; CH := RDCH()  $)

        WHILE '0' LE CH LE '9' DO
                  $( A := A*10 - (CH-'0')
                     CH := RDCH()  $)
				  $)
				  
        RESULTIS NEG -> A, -A  $)1


AND RDL() = VALOF
    $(1 LET A = 0

        CH := RDCH() REPEATWHILE CH='*N' \/ CH='*S'

        IF CH='L' DO CH := RDCH()

        WHILE '0' LE CH LE '9' DO
                  $( A := A*10 + CH - '0'
                     CH := RDCH()  $)

        RESULTIS A   $)1


.

//    CG2


GET "CGHDR"

MANIFEST $( CONST_SIZE = 9500 $)			// Was originally 4000.  DC: 28-Nov-2012

LET START(PARM) BE
    $(1 LET V = VEC CONST_SIZE
        DATAV, DATAT := V, CONST_SIZE
     $( LET X = VEC 50
        WORDV := X

        SYSIN := INPUT()
        SYSPRINT := OUTPUT()
        INTCODE := FINDOUTPUT("INTCODE")
        IF INTCODE=0 DO INTCODE := SYSPRINT

        PROGLENGTH := 0

        SELECTINPUT(SYSIN)
        SELECTOUTPUT(INTCODE)

     $( SSP, STATE := 2, NIL
        DATAP, LINEP,  PARAM := 0, 0, 750						// Was originally 500.	DC 9-Feb-2013
        GENCODE() $) REPEATWHILE OP=S.GLOBAL

        SELECTOUTPUT(SYSPRINT)
        WRITEF("*NPROGRAM LENGTH = %N*N", PROGLENGTH)
        FINISH            $)1

.

//    CG3


GET "CGHDR"

LET GENCODE() BE
    $(1

	  CH := '*S'							// Prime CH for READOP()
NEXT: OP := READOP()

      SWITCHON OP INTO

   $( DEFAULT:		SELECTOUTPUT(SYSPRINT)
					WRITEF("*NUNKNOWN KEY WORD:	'%S'*N", WORDV)
					SELECTOUTPUT(INTCODE)
					GOTO NEXT

      CASE S.END:	RETURN

      CASE S.DEBUG:	SELECTOUTPUT(SYSPRINT)
					WRITEF("*NSTATE=%N, SSP=%N, AD.A=%N, AD.K=%N*N",
							STATE,    SSP,    AD.A,    AD.K)
					SELECTOUTPUT(INTCODE)
					GOTO NEXT

	  CASE S.SECTION:
				$(	MANIFEST $( UPB=11 $)		// Max length of entry name
					LET N = RDN()
					
					WR('N'); WRN(UPB); WR('*S')
						// Output up to 11 character of the name including the first and last five.
					TEST N<=UPB
					THEN $( FOR I = 1 TO N DO $( WR('C'); WRN(RDN()); WR('*S') $)
							FOR I = N+1 TO UPB DO $( WR('C'); WRN('*S'); WR('*S') $)
						$)
					ELSE $( FOR I = 1 TO 5   DO $( WR('C'); WRN(RDN()); WR('*S') $)
							FOR I = 6 TO N-6 DO RDN() // Ignore the middle characters
							FOR I = 6 TO UPB  DO $( WR('C'); WRN(RDN()); WR('*S') $)
						$)
//					OP := RDN()
					GOTO NEXT
				$)

      CASE S.LP:	LOAD(RDN(), M.IP);	GOTO NEXT
      CASE S.LG:	LOAD(RDN(), M.IG);	GOTO NEXT
      CASE S.LL:	LOAD(RDL(), M.IL);	GOTO NEXT
      CASE S.LN:	LOAD(RDN(), M.N);	GOTO NEXT
	  CASE S.LF:	LOAD(RDL(), M.IL);	GOTO NEXT

      CASE S.LSTR:	CGSTRING(RDN()); GOTO NEXT

      CASE S.TRUE:	LOAD(-1, M.N); GOTO NEXT
      CASE S.FALSE:	LOAD(0, M.N); GOTO NEXT


      CASE S.LLP:	LOAD(RDN(), M.P); GOTO NEXT
      CASE S.LLG:	LOAD(RDN(), M.G); GOTO NEXT
      CASE S.LLL:	LOAD(RDL(), M.L); GOTO NEXT

      CASE S.SP:	STOREIN(RDN(), M.P); GOTO NEXT
      CASE S.SG:	STOREIN(RDN(), M.G); GOTO NEXT
      CASE S.SL:	STOREIN(RDL(), M.L); GOTO NEXT

      CASE S.STIND:	FORCE.ACAD()
					CODE(F.S, AD.A, AD.K)
					SSP, STATE := SSP-2, NIL
					GOTO NEXT

	  CASE S.PUTBYTE: $(
			// args on the stack are as follows:
			//         top of stack  ->  arg1
			//                           arg2
			//                           arg3
			// where the operation is  arg2%arg1 := arg3
					FORCE.NIL()
					CODE(F.L, SSP-3, M.P)
					CODE(F.X, OPCODE(S.PUTBYTE), M.N)
					STATE, SSP := NIL, SSP-3
					GOTO NEXT	$)

      CASE S.MULT:CASE S.DIV:CASE S.REM:
      CASE S.MINUS:CASE S.EQ:CASE S.NE:
      CASE S.LS:CASE S.GR:CASE S.LE:CASE S.GE:
      CASE S.LSHIFT:CASE S.RSHIFT:
      CASE S.LOGAND:CASE S.LOGOR:CASE S.NEQV:CASE S.EQV:
	  CASE S.GETBYTE: 
					FORCE.ACAD()
					CODE(F.L, AD.A, AD.K)
					CODE(F.X, OPCODE(OP), M.N)
					STATE, SSP := AC, SSP-1
					GOTO NEXT

      CASE S.RV:CASE S.NEG:CASE S.NOT:CASE S.ABS:
					FORCE.AC()
					CODE(F.X, OPCODE(OP), M.N)
					GOTO NEXT

      CASE S.PLUS:	FORCE.ACAD()
					CODE(F.A, AD.A, AD.K)
					STATE, SSP := AC, SSP-1
					GOTO NEXT

      CASE S.JUMP:	FORCE.NIL()
					CODE(F.J, RDL(), M.L)
					GOTO NEXT

      CASE S.JT:CASE S.JF:
					FORCE.AC()
					CODE(OP=S.JT->F.T,F.F, RDL(), M.L)
					SSP, STATE := SSP-1, NIL
					GOTO NEXT

      CASE S.GOTO:	FORCE.AD()
					CODE(F.J, AD.A, AD.K)
					SSP, STATE := SSP-1, NIL
					GOTO NEXT

      CASE S.LAB:	FORCE.NIL()
					COMPLAB(RDL())
					GOTO NEXT

      CASE S.QUERY:	FORCE.NIL(); SSP := SSP + 1; GOTO NEXT

      CASE S.STACK:	FORCE.NIL(); SSP := RDN(); GOTO NEXT

      CASE S.STORE:	FORCE.NIL(); GOTO NEXT

      CASE S.ENTRY: $(
					LET N = RDN()
					LET L = RDL()
					WR('*N'); WR('$'); WR('*S'); WR('/')
						FOR I = 1 TO N DO WR(RDN()) // Write the function name
						WR('*N'); WR(' ')
					COMPLAB(L)
					STATE, AD.A, AD.K := NIL, 0, M.N
					GOTO NEXT	$)

	  CASE S.SAVE:	SSP := RDN(); GOTO NEXT

      CASE S.ENDPROC: RDN(); GOTO NEXT
      CASE S.RTAP:
      CASE S.FNAP: $(
					LET K = RDN()
					FORCE.AC()
					CODE(F.K, K, M.N)
					TEST OP=S.FNAP
						THEN SSP, STATE := K+1, AC
						OR SSP, STATE := K, NIL
					GOTO NEXT   $)

      CASE S.FNRN:	FORCE.AC()
					SSP := SSP - 1
      CASE S.RTRN:	CODE(F.X, OPCODE(S.RTRN), M.N)
					STATE := NIL
					GOTO NEXT

      CASE S.RES:	FORCE.AC()
					CODE(F.J, RDL(), M.L)
					SSP, STATE := SSP-1, NIL
					GOTO NEXT

      CASE S.RSTACK: FORCE.NIL()
					SSP, STATE := RDN()+1, AC
					GOTO NEXT

      CASE S.FINISH: CODE(F.X, OPCODE(OP), M.N); GOTO NEXT

      CASE S.SWITCHON: $(
					LET N = RDN()
					LET D = RDL()
					FORCE.AC()
					CODE(F.X, OPCODE(OP), M.N)
					CODE(F.D, N, M.N)
					CODE(F.D, D, M.L)
					SSP, STATE := SSP-1, NIL
					FOR I = 1 TO N DO $(
						CODE(F.D, RDN(), M.N)
						CODE(F.D, RDL(), M.L)  $)
					GOTO NEXT  $)

      CASE S.GLOBAL:
					WR('*N')
					FOR I = 0 TO DATAP-2 BY 2 DO WRDATA(DATAV!I, DATAV!(I+1))
					WR('*N')
					FOR I = 1 TO RDN() DO $(
						WR('G'); WRN(RDN())
						WR('L'); WRN(RDL()); WR('*S')	$)
					WR('*N'); WR('Z'); WR('*N')
					RETURN

      CASE S.DATALAB:
      CASE S.ITEML: DATA(OP, RDL())
					GOTO NEXT

      CASE S.ITEMN: DATA(OP, RDN())
					GOTO NEXT                   $)1

.

//    CG4


GET "CGHDR"

//
//  This code deals with the generation of INTCODE for loads and stores.
//


//  The INTCODE stack may be in one of four states (kept in STATE):
//
//     STATE = NIL
//          top of stack - (offset SSP-1) - in stack frame
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//          No pending load
//
//     STATE = AC
//          top of stack - (offset SSP-1) - in INTCODE register A
//          second of stack - (offset SSP-2) - in stack frame
//          No pending load
//
//     STATE = AD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in stack frame
//          INTCODE accumulator A is empty
//
//     STATE = ACAD
//          top of stack - (offset SSP-1) - in pending load variables
//          second of stack - (offset SSP-2) - in INTCODE register A
//
//  The two variables AD_A and AD_K hold the address and address modifier
//  of a pending load.  This load will be performed when next necessary.

// LOADS are made into variables on the stack - and hence use M_IP
// STORES are made from addresses on the stack - and hence use M_P

LET FORCE.NIL() BE
// Forces NIL state - so that INTCODE register A is empty and there are
// no pending loads.
      SWITCHON STATE INTO
      $( CASE ACAD: CODE(F.S, SSP-2, M.P)

         CASE AD:   CODE(F.L, AD.A, AD.K)

         CASE AC:   CODE(F.S, SSP-1, M.P)
                    STATE := NIL

         CASE NIL:  $)

AND FORCE.AD() BE
// Forces AD state in which the variables AD_A and AD_K hold details of a
// pending load and INTCODE register A is empty.
      SWITCHON STATE INTO
      $( CASE ACAD: CODE(F.S, SSP-2, M.P)
                    GOTO L

         CASE AC:   CODE(F.S, SSP-1, M.P)

         CASE NIL: AD.A, AD.K := SSP-1, M.IP
         L:        STATE := AD

         CASE AD:    $)

AND FORCE.AC() BE
// Forces AC state in which the INTCODE register A holds the top of stack
// and there are no pending loads.
      SWITCHON STATE INTO
      $( CASE NIL:  CODE(F.L, SSP-1, M.IP)
                    GOTO L

         CASE ACAD: CODE(F.S, SSP-2, M.P)

         CASE AD:   CODE(F.L, AD.A, AD.K)
         L:         STATE := AC

         CASE AC:   $)

AND FORCE.ACAD() BE
// Forces state ACAD in which AD_A and AD_K hold details of the pending
// load of the top of stack and INTCODE register A holds the next of stack.
      SWITCHON STATE INTO
      $( CASE AD:   CODE(F.L, SSP-2, M.IP)
                    GOTO L

         CASE AC:   CODE(F.S, SSP-1, M.P)

         CASE NIL:  CODE(F.L, SSP-2, M.IP)
                    AD.A, AD.K := SSP-1, M.IP
         L:         STATE := ACAD

         CASE ACAD:  $)

AND LOAD(A, K) BE
// A - the new contents of the accumulator A
// K - the kind (mode) in which the operand is to be fetched
//     (an M_<flags> constant typically)
// This procedure frees the pending load given in AD_A and AD_K (if there
// is one) and then loads A and K into them.
      SWITCHON STATE INTO
      $( CASE NIL: STATE := AD
                   GOTO M

         CASE ACAD:
         CASE AD:  FORCE.AC()
         CASE AC:  STATE := ACAD
         M:        AD.A, AD.K := A, K
                   SSP := SSP + 1  $)


AND STOREIN(A, K) BE
    $( FORCE.AC()
       CODE(F.S, A, K)
       SSP, STATE := SSP-1, NIL  $)

AND CGSTRING(N) BE
    $(1 LET L = NEXTPARAM()
        DATA(S.DATALAB, L)
        DATA(S.CHAR, N)
        FOR I = 1 TO N DO DATA(S.CHAR, RDN())
        LOAD(L, M.L)
        RETURN  $)1

AND DATA(K, V) BE
    $( LET P = DATAP
       DATAV!P, DATAV!(P+1) := K, V
       DATAP := DATAP + 2
       IF DATAP>DATAT DO
              $( SELECTOUTPUT(SYSPRINT)
                 WRITES("*NTOO MANY CONSTANTS*N")
                 SELECTOUTPUT(INTCODE)
                 DATAP := 0  $)  $)

AND NEXTPARAM() = VALOF $( PARAM := PARAM - 1
						   IF PARAM=0 $(
								SELECTOUTPUT(SYSPRINT)
								WRITES("*NTOO MANY LABELS*N")
								SELECTOUTPUT(INTCODE)
								DATAP := 0	$)
                           RESULTIS PARAM  $)

.

//    CG5


GET "CGHDR"

LET CODE(F, A, K) BE
// F - function = F_L  F_S  F_A  F_J  F_T  F_F  F_K  or  F_X
// A - data (D field in INTCODE)
// K - mode in which data is to be fetched, one of:
//        M_N    -  normal
//        M_I    -  indirect
//        M_IG   -  indirect global
//        M_P    -  local variable (relative to stack frame)
//        M_IP   -  indirect local
//        M_L    -  label
//        M_IL   -  indirect label
//        M_F    -  function
//        M_IF   -  indirect function
    $( WR(F)
       SWITCHON K INTO
       $( CASE M.I: WR('I')
          CASE M.N: ENDCASE

          CASE M.IG: WR('I')
          CASE M.G:  WR('G')
                     ENDCASE

          CASE M.IP: WR('I')
          CASE M.P:  WR('P'); ENDCASE

          CASE M.IL: WR('I')
          CASE M.L:  WR('L'); ENDCASE  $)

       WRN(A)
       WR(' ')
       PROGLENGTH := PROGLENGTH + 1  $)

AND COMPLAB(N) BE $( WRN(N); WR(' ')  $)

AND WRDATA(K, N) BE SWITCHON K INTO
      $( CASE S.DATALAB: COMPLAB(N); RETURN

         CASE S.ITEMN: CODE(F.D, N, M.N); RETURN

         CASE S.ITEML: CODE(F.D, N, M.L); RETURN

         CASE S.CHAR:  CODE(F.C, N, M.N); RETURN  $)


AND OPCODE(OP) = VALOF SWITCHON OP INTO
     $( CASE S.RV:		RESULTIS 1				// 1)	A := Location (A)
        CASE S.NEG:		RESULTIS 2				// 2)	A := -A
        CASE S.NOT:		RESULTIS 3				// 3)	A := NOT A
        CASE S.RTRN:	RESULTIS 4				// 4)	This causes a return from the current function or routine;
												//		by convention the result of a function is left in A.
												//		C := Location(P + 1)
												//		P := Location(P)
        CASE S.MULT:	RESULTIS 5				// 5)	A := B * A
        CASE S.DIV:		RESULTIS 6				// 6)	A := B / A
        CASE S.REM:		RESULTIS 7				// 7)	A := B REM A
        CASE S.PLUS:	RESULTIS 8				// 8)	A := B + A
        CASE S.MINUS:	RESULTIS 9				// 9)	A := B - A
		CASE S.EQ:		RESULTIS 10				// 10)	A := B = A
        CASE S.NE:		RESULTIS 11				// 11)	A := B ~= A
        CASE S.LS:		RESULTIS 12				// 12)	A := B < A
        CASE S.GE:		RESULTIS 13				// 13)	A := B >= A
        CASE S.GR:		RESULTIS 14				// 14)	A := B > A
        CASE S.LE:		RESULTIS 15				// 15)	A := B <= A
        CASE S.LSHIFT:	RESULTIS 16				// 16)	A := B LSHIFT A
        CASE S.RSHIFT:	RESULTIS 17				// 17)	A := B RSHIFT A
        CASE S.LOGAND:	RESULTIS 18				// 18)	A := B LOGAND A
        CASE S.LOGOR:	RESULTIS 19				// 19)	A := B LOGOR A
        CASE S.NEQV:	RESULTIS 20				// 20)	A := B NEQV A
        CASE S.EQV:		RESULTIS 21				// 21)	A := B EQV A
        CASE S.FINISH:	RESULTIS 22				// 22)	FINISH
        CASE S.SWITCHON:RESULTIS 23				// 23)	Switch on the value of A using data in the location
												//		addressed by C, C+1 etc.
												//		B, D := Location(C), Location(C + 1)
												//		UNTIL B = 0 DO
												//			$(	B, C := B - 1, C + 2
												//				IF A=Location(C) DO
												//					$(	D := Location(C + 1)
												//						BREAK $)       $)
												//		C := D
												// (24) - 35) are implementation dependent)
		CASE S.GETBYTE:	RESULTIS 36				// 36)	GETBYTE()
		CASE S.PUTBYTE:	RESULTIS 37				// 37)	PUTBYTE()
												// (38) - 43) are implementation dependent)
		CASE S.ABS:		RESULTIS 44				// 44)	A := ABS A

        DEFAULT: SELECTOUTPUT(SYSPRINT)
                 WRITEF("*NUNKNOWN OP %N*N", OP)
                 SELECTOUTPUT(INTCODE)
                 RESULTIS 0  $)


AND WR(CH) BE
    $( IF CH='*N' DO $( WRCH('*N')
                        LINEP := 0
                        RETURN  $)

       IF LINEP=71 DO
              $( WRCH('/')
                 WRCH('*N')
                 LINEP := 0  $)
       LINEP := LINEP + 1
       WRCH(CH)  $)

AND WRN(N) BE
    $( TEST N<0 DO WR('-') OR N := -N
       IF N<-9 DO WRN(-N/10)
       WR('0' - N REM 10)  $)


