// Copyright (c) 2016 Dave Cannon.  All rights reserved.

// $Id: rtc.s, v 1.15 13-February-2016 15:28:38 GMT rn Exp $

	.file	"rtc.s"

# Compilation/debugging switches:
				.set C_STACK,1					# enable/disable _stacktrace() for the c stack rather than the BCPL stack

#				.set DEBUG_ALL,1				# enable/disable comprehensive diagnostics output
#				.set CLASSIC,1					# assemble code for original 'Classic BCPL' compiler - commented out for 'Extended' compiler

.ifdef DEBUG_ALL
				.set DEBUG_8,1					# comprehensive diagnostics
.endif
.ifdef DEBUG_8
				.set DEBUG_4,1					# extensive diagnostics...
.endif
.ifdef DEBUG_4
				.set DEBUG_2,1					# interesting diagnostics...
.endif
.ifdef DEBUG_2
				.set DEBUG,1					# minimal diagnostics...
.endif

# BCPL Manifest constants:
				.set STRSIZ,256
				.set FTsize,168					# 21 words for _ft, a further 21 for filename pointers

				.set FD.STDIN,0
				.set FD.STDOUT,1

				.set ENDSTREAMCH,-1

# BCPL Globals:
				.set START,1
				.set FILETABLE,48
.ifndef CLASSIC									# Globals for the 'Extended BCPL' compiler
				.set STACKBASE,95
				.set STACKEND,96
	.else										# Globals for the 'Classic BCPL' compiler
				.set STACKBASE,54
				.set STACKEND,55
.endif
				.set ARGC,97
				.set ARGV,98
				.set PARAM,99

# BCPL stacksize (bytes):
				.set STKSIZ,0x400000

# BCPL File table:
				.lcomm _ft,FTsize,32
				.lcomm _fi,4,4
				.lcomm _fo,4,4
				.lcomm _ch,4,4

# c stack address:
				.lcomm	c_stackbase,4

				
	.def	___main;	.scl	2;	.type	32;	.endef

# Run-time module macros:
# Recover the BCPL environment after a call to the c library:
   .macro c_call c_func
		call	\c_func					# call the requested c library function
		mov		$G, %rdi				# restore address of BCPL GLOBAL vector area
   .endm
	
	
	.section .rdata,"dr"
	.align 4
LCa:
	.ascii "\11START called, address of GLOBAL vector is %d\12\0"
LCb:
	.ascii "\11\11G:%d = %d\12\0"
	.text
#	_main is the first piece of user code called by the c start-up code.
#	It establishes %rsp and its relationship with %rbp...
.globl _main
	.def	_main;	.scl	2;	.type	32;	.endef
_main:
	push	%rbp
	mov		%rbp, %rax					# get address of current stackframe to establish base of c stack
	mov		%rsp, %rbp
	mov		%rbp, c_stackbase
	and		$-16, %rsp
#	sub		$40, %rsp					# protect stackframe variables
	sub		$48, %rsp					# protect stackframe variables
#
	mov		8(%rbp), %rax				# collect argc...
	mov		%rax, 20(%rsp)				# ...and save locally
	mov		12(%rbp), %rax				# collect address of argv[]...
	mov		%rax, 24(%rsp)				# ...and save
	push	$STKSIZ
	c_call	_malloc						# request space for BCPL stack
	pop		%rcx
#
	mov		$G, %rdi					# get address of BCPL GLOBAL vector area
	mov		%rdi, %rdx
	shr		$2,%rdx						# convert to BCPL word address
	mov		%rdx, (%rdi)				# ...Global 0 now holds the address of the Global vector
#
	shr		$2,%rax						# convert byte address to BCPL word
	mov		%rax,STACKBASE*4(%rdi)		# save in GLOBAL vector 95 (STACKBASE)
	add		$STKSIZ>>2,%rax				# derive address of end of stack
	mov		%rax,STACKEND*4(%rdi)		# Save in GLOBAL vector 96 (STACKEND)
#
	c_call	___main
#  (c_call	___main:
#	call ___main
#		push		%rip
#			%rsp := %rsp - 4
#			%ss:%rsp := SOURCE			# dword assignment
#		%rip := %rip + rel32
#	mov			$G, %rdi)					# restore address of BCPL GLOBAL vector area

.ifdef DEBUG_ALL	# List out the GLOBAL vector table...
#				start diagnostics...
	mov		$G, 4(%rsp)
	mov		$LCa, (%rsp)
	c_call	_printf
	mov		$0, 28(%rsp)
	jmp		L2
L3:
	mov		$G, %rax
	mov		28(%rsp), %rdx
	sal		$2, %rdx
	add		%rdx, %rax
	mov		(%rax), %rax
	mov		%rax, 8(%rsp)
	mov		28(%rsp), %rax
	mov		%rax, 4(%rsp)
	mov		$LCb, (%rsp)
	c_call	_printf
	inc		28(%rsp)
L2:
	cmp		$100, 28(%rsp)
	jle		L3
#				end diagnostics...		
.endif
#				convert c's argv and argc to something BCPL can cope with:
	mov		8(%rbp), %rax				# collect argc
	test	%rax, %rax
	jne		A9
	inc		%rax						# need at least one slot for empty param string
A9:
	sal		$2, %rax
	mov		%rax, (%rsp)
	c_call	_malloc						# get a vector large enough for argc pointers...
	mov		%rax, 40(%rsp)				# new home for BCPL_argv
	mov		$1, 28(%rsp)				# i=1
	jmp		A4
A7:
	mov		28(%rsp), %rax
	sal		$2, %rax
	add		12(%rbp), %rax				# collect argv[i]
	mov		(%rax), %rax
	mov		%rax, (%rsp)
	call	_strlen						# get argv[i]'s string length...
	mov		%rax, 36(%rsp)				# ...s = strlen(argv[i])
	mov		36(%rsp), %rax
	add		$5, %rax					# s=s+5
	and		$-4, %rax					# length, modulo four
	mov		%rax, (%rsp)
	c_call	_malloc						# get nxarg, new home for argv[i]
	add		$3, %rax
	and		$-4, %rax					# address, modulo four, to align on word boundary, for...
	mov		%rax, 44(%rsp)				# ...nxarg = malloc(s+1)
	mov		$0, 32(%rsp)				# j = 0
	jmp		A5
A6:
	inc		32(%rsp)					# j++
A5:
	mov		32(%rsp), %rax
	inc		%rax
	add		44(%rsp), %rax				# nxarg[j+1]
	mov		28(%rsp), %rdx
	sal		$2, %rdx
	add		12(%rbp), %rdx
	mov		(%rdx), %rcx
	mov		32(%rsp), %rdx
	lea		(%rcx,%rdx), %rdx			# argv[i][j]
	movb	(%rdx), %dl
	movb	%dl, (%rax)					# nxarg[j+1] = argv[i][j]
	movb	(%rax), %al
	testb	%al, %al
	jne		A6							# != '\0' ?
	mov		36(%rsp), %rax
	movb	%al, %dl
	mov		44(%rsp), %rax
	movb	%dl, (%rax)					# nxarg[0] = s
	mov		28(%rsp), %rax
	dec		%rax
	sal		$2, %rax
	add		40(%rsp), %rax
	mov		44(%rsp), %rdx
	shr		$2, %rdx					# convert byte address to BCPL word
	mov		%rdx, (%rax)				# BCPL_argv[i-1] = nxarg
	inc		28(%rsp)					# i=i+1
A4:
	mov		28(%rsp), %rax
	cmp		8(%rbp), %rax				# collect argc
	jl		A7							# i<argc ?
	mov		8(%rbp), %rax
	cmp		$1, %rax					# any parameters at all?
	jne	A10								# yes
	mov		$4, (%rsp)
	c_call	_malloc						# get vector for null string
	add		$3, %rax
	and		$-4, %rax					# address, modulo four, to align on word boundary, for...
	mov		%rax, %rdx					# ...nxarg = malloc(4)
	movb	$0, (%rdx)
	shr		$2, %rdx					# convert byte address to BCPL word
	mov		40(%rsp), %rax
	mov		%rdx, (%rax)				# BCPL_argv[0] = ""
	mov		$1, %rax					# argc=1
A10:
#
		#	This is the BCPL environment - set up the BCPL stack
	dec		%rax						# argc=argc-1
	mov		%rax, (%rsp)				# pass argc...
	mov		%rax, ARGC*4(%rdi)			# Define Global ARGC
	mov		40(%rsp), %rax				# get address of BCPL_argv[]
	shr		$2,%rax						# convert byte address to BCPL word
	mov		%rax, 4(%rsp)				# ...and address of BCPL_argv[] to initbcpl()...
	mov		%rax, ARGV*4(%rdi)			# Define Global ARGV
	cmp		$1, %rax					# argv=0 ?
	jl		A8
	mov		(,%rax,4),%rcx
	jecxz	A8
	mov		%rcx, %rax
A8:
	mov		%rax, PARAM*4(%rdi)			# Global PARAM points to argv[0]
	mov		20(%rsp), %rax
	c_call	_initbcpl					# Switch to BCPL stack, jump to BCPL START() function
	leave								# ...this will never be executed - finish is called from BCPL
#  (leave:
#		mov		%rbp, %rsp				# then...
#		pop			%rbp
#			mov		(%rsp), %rbp
#			add		$4, %rsp
	ret
#		pop			%rip					# effectively...
#			mov		(%rsp), %rip		# ...as...
#			add		$4, %rsp			# ...and
	
	
	.section .rdata,"dr"
	.align 4
LC1:
	.ascii "\12\11_rtinit() called...\0"
LC2:
	.ascii "\11\11ft[%d] = %d\12\0"
	.text
.globl _rtinit
	.def	_rtinit;	.scl	2;	.type	32;	.endef
_rtinit:
	push	%rbp
	mov		%rsp, %rbp
	sub		$40, %rsp
.ifdef DEBUG_ALL
#				start diagnostics...		
	mov		$LC1, (%rsp)
	c_call	_puts
#				end diagnostics...		
.endif
	mov		__imp___iob, %rax
	mov		%rax, _ft					# set _ft!0 to STDIN
	mov		$0, _fi
	mov		__imp___iob, %rax
	add		$32, %rax
	mov		%rax, _ft+4					# set _ft!1 to STDOUT
	mov		$1, _fo
	mov		__imp___iob, %rax
	add		$64, %rax
	mov		%rax, _ft+8					# set _ft!2 to STDERR
	mov		$3, -12(%rbp)
	jmp	L4
L5:
	mov		-12(%rbp), %rax
	mov		$0, _ft(,%rax,4)
	inc		-12(%rbp)
L4:
	cmp		$20, -12(%rbp)
	jle	L5
	mov		$_ft, %rax					# get address of the File Table
	shr		$2, %rax					# convert byte address to BCPL word address
	mov			$G, %rdi					# get address of BCPL GLOBAL vector area
	mov		%rax, FILETABLE*4(%rdi)		# Save in GLOBAL vector 48 (FILETABLE)
.ifdef DEBUG	# List out the file definition table...
#				start diagnostics...		
	mov		$0, -12(%rbp)
	jmp		L6
L7:
	mov		-12(%rbp), %rax
	mov		_ft(,%rax,4), %rax
	mov		%rax, 8(%rsp)
	mov		-12(%rbp), %rax
	mov		%rax, 4(%rsp)
	mov		$LC2, (%rsp)
	c_call	_printf
	inc		-12(%rbp)
L6:
	cmp		$20, -12(%rbp)
	jle		L7
#				end diagnostics...		
.endif
	mov		_ft+4, %rax
	mov		16(%rax), %rax
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC3:
	.ascii "\11_rtexit() called...\0"
	.text
.globl _rtexit
	.def	_rtexit;	.scl	2;	.type	32;	.endef
_rtexit:
	push	%rbp
	mov		%rsp, %rbp
	sub		$40, %rsp
.ifdef DEBUG
#				start diagnostics...		
	mov		$LC3, (%rsp)
	c_call	_puts
#				end diagnostics...		
.endif
	mov		$3, -12(%rbp)
	jmp		L10
L12:
	mov		-12(%rbp), %rax
	mov		_ft(,%rax,4), %rax
	test	%rax, %rax
	je		L11
	mov		-12(%rbp), %rax
	mov		_ft(,%rax,4), %rax
	mov		%rax, (%rsp)
	c_call	_fclose
	mov		-12(%rbp), %rax
	mov		$0, _ft(,%rax,4)
L11:
	inc		-12(%rbp)
L10:
	cmp		$20, -12(%rbp)
	jle		L12
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC4:
	.ascii "\11_sbrk(%d) called...\12\0"
	.text
.globl _sbrk
	.def	_sbrk;	.scl	2;	.type	32;	.endef
_sbrk:
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
#	mov		8(%rbp), %rax
.ifdef DEBUG
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LC4, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
#	mov		8(%rbp), %rax
	mov		%rax, (%rsp)
	c_call	_malloc
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC5:
	.ascii "\11_cstr() called...\12\0"
LC6:
	.ascii "\11\11...returning: %s\12\0"
	.text
	.def	_cstr;	.scl	3;	.type	32;	.endef
_cstr:
	push	%rbp
	mov		%rsp, %rbp
	sub		$40, %rsp
.ifdef DEBUG_ALL
#				start diagnostics...		
	mov		$LC5, (%rsp)
	c_call	_puts
#				end diagnostics...		
.endif
	mov		8(%rbp), %rax
	mov		%rax, -20(%rbp)
	mov		-20(%rbp), %rax
	movb	(%rax), %al
	movsb	%al,%rax
	mov		%rax, -16(%rbp)
	mov		-16(%rbp), %rax
	inc		%rax
	mov		%rax, (%rsp)
	c_call	_malloc
	mov		%rax, -24(%rbp)
	mov		$1, -12(%rbp)
	jmp	L17
L18:
	mov		-12(%rbp), %rax
	dec		%rax
	add		-24(%rbp), %rax
	mov		-12(%rbp), %rdx
	add		-20(%rbp), %rdx
	movb	(%rdx), %dl
	cmpb	$47, %dl					# on-the-fly UNIX to Windows pathname correction:  if this character is a '/'...
	jne		1f
	movb	$92, %dl					# ...substitute a '\'
1:
	movb	%dl, (%rax)
	inc		-12(%rbp)
L17:
	mov		-12(%rbp), %rax
	cmp		-16(%rbp), %rax
	jle		L18
	mov		-16(%rbp), %rax
	add		-24(%rbp), %rax
	movb	$0, (%rax)
.ifdef DEBUG_ALL
#				start diagnostics...		
	mov		-24(%rbp), %rax
	mov		%rax, 4(%rsp)
	mov		$LC6, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		-24(%rbp), %rax
	leave
	ret
	
	
	.section .rdata,"dr"
	.align 4
LC7:
	.ascii "\11_ftslot() called...\12\0"
LC8:
	.ascii "\11\11...returning: %d\12\0"
	.text
	.def	_ftslot;	.scl	3;	.type	32;	.endef
_ftslot:
	push	%rbp
	mov		%rsp, %rbp
	sub		$40, %rsp
#	mov		-12(%rbp), %rax
.ifdef DEBUG_ALL
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LC7, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		$2, -12(%rbp)
	jmp		L21
L24:
	mov		-12(%rbp), %rax
	mov		_ft(,%rax,4), %rax
	test		%rax, %rax
	jne		L22
	mov		-12(%rbp), %rax
.ifdef DEBUG_ALL
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LC8, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		-12(%rbp), %rax
	jmp		L23
L22:
	inc		-12(%rbp)
L21:
	cmp		$20, -12(%rbp)
	jle		L24
	mov		$0, %rax
L23:
	leave
	ret


// _CODETRACE()

	.section .rdata,"dr"
	.align 4
LLC24:
	.ascii "\11_codetrace() called...\0"
LLC25:
	.ascii "\11\11STACKBASE (G:%d)=%d\11STACKEND (G:%d)=%d\12\11\11%%rbp=%d\11%%rsp=%d\11c_stack=%d\12\12\0"
LLCd:
	.ascii "\11\11Code | %d = %02x\12\0"
	.text
# .globl _codetrace
	.def	_codetrace;	.scl	2;	.type	32;	.endef
_codetrace:
	push	%rbp
#		push		%rbp
#			%rsp := %rsp - 4
#			%ss:%rsp := %rbp
	mov		%rsp, %rbp
	sub		$40, %rsp
	mov		$LLC24, (%rsp)
	c_call	_puts
	mov		c_stackbase, %rax
	mov		%rax, 28(%rsp)				# address of c stackbase
	mov		%rsp, %rcx
	shr		$2,%rcx
	mov		%rcx, 24(%rsp)				# %rsp
	mov		(%rbp), %rcx				# should be where previous %rbp was stored at entry...
	mov		(%rcx), %rcx				# ...and then previous c stackframe should hold BCPL stackframe address  (?)
	shr		$2,%rcx
	mov		%rcx, 20(%rsp)				# %rbp
	mov		$G, %rax
	add		$STACKEND*4, %rax			# pick up...
	mov		(%rax), %rax				# ...address of STACKEND
	mov		%rax, 16(%rsp)
	mov		$STACKEND, 12(%rsp)			# Global # STACKEND
	mov		$G, %rax
	add		$STACKBASE*4, %rax			# pick up...
	mov		(%rax), %rax				#  ...address of STACKBASE
	mov		%rax, 8(%rsp)
	mov		$STACKBASE, 4(%rsp)			# Global # STACKBASE
	mov		$LLC25, (%rsp)				# @ "\11\11STACKBASE (G:%d)=%d\11STACKEND (G:%d)=%d\12\11\11%%rbp=%d\11%%rsp=%d\11c_stack=%d\12\12\0
	c_call	_printf
#
	mov		(%rbp), %rcx				# should be where previous %rbp was stored at entry...
	mov		(%rcx), %rcx				# ...and then previous c stackframe should hold BCPL stackframe address  (?)
	mov		4(%rcx), %rax				# ...collect return address into calling code
	sub		$8, %rax					# allow 8 bytes before return address
	mov		%rax, 28(%rsp)
	jmp	LCL2
LCL3:
	mov		28(%rsp), %rdx
	mov		%rdx, %rax
	movzb	(%rax), %rax
	mov		%rax, 8(%rsp)				#  ...contents of code location
	mov		%rdx, 4(%rsp)				#  ...byte address of code location
	mov		$LLCd, (%rsp)				# @"\11\11Code | %d = %02x\12\0"
	c_call	_printf
	inc		28(%rsp)					# list the calling code
LCL2:
	mov		28(%rsp), %rdx
	mov		(%rbp), %rcx				# should be where previous %rbp was stored at entry...
	mov		(%rcx), %rcx				# ...and then previous c stackframe should hold BCPL stackframe address  (?)
	mov		4(%rcx), %rax				# ...collect return address into calling code
	add		$40, %rax					# allow for 40 bytes of code listing
	cmp		%rax, %rdx
	jle	LCL3
#
	leave
#  (leave:
#		mov		%rbp, %rsp				# then...
#		pop			%rbp
#			mov		(%rsp), %rbp
#			add		$4, %rsp
	ret


// BCPL library routines:

// On entry, ebp addresses the stack frame.  A result is returned in eax.
//
// ebp, edi must be preserved:
// ebp addresses the caller's stack frame and edi the global vector.
//
// ebx and esi are also preserved although they are not currently used by
// Robert Nordier's code generator.  eax, ecx, edx need not be preserved.

	
// _STACKTRACE()

	.section .rdata,"dr"
	.align 4
LC24:
	.ascii "\11_stacktrace() called...\0"
LC25:
	.ascii "\11\11STACKBASE (G:%d)=%d\11STACKEND (G:%d)=%d\12\11\11%%rbp=%d\11%%rsp=%d\11c_stack=%d\12\12\0"
#
	.data
c_stk:
	.long	0							# zero to trace the c stack, else trace the BCPL stack
LCd:
	.ascii "\11\11C_stk | %d = %d\12\0"
#
	.text
	.globl _stacktrace
	.def	_stacktrace;	.scl	2;	.type	32;	.endef
_stacktrace:
	push	%rbp
#		push		%rbp
#			%rsp := %rsp - 4
#			%ss:%rsp := %rbp
	mov		%rsp, %rbp
	sub		$40, %rsp
	mov		$0, c_stk					# trace the c stack
	mov		$'C, %al					# '
	mov		$LCd, %rcx
	movb	%al, 2(%rcx)				# ...modify diagnostic text
CS0:
	mov		$LC24, (%rsp)
	c_call	_puts
	mov		c_stackbase, %rax
	mov		%rax, 28(%rsp)				# address of c stackbase
	mov		%rsp, %rcx
	shr			$2,%rcx
	mov		%rcx, 24(%rsp)				# %rsp
#
	cmp		$0, c_stk					# are we tracing the c stack?
	jne		CS1								# no...
	mov		%rbp, %rcx					# collect c's current %rbp
	jmp		CS2
CS1:
	mov		(%rbp), %rcx				# should be where previous %rbp was stored at entry...
	mov		(%rcx), %rcx				# ...and then previous c stackframe should hold BCPL stackframe address  (?)
CS2:
#
	shr		$2,%rcx
	mov		%rcx, 20(%rsp)				# %rbp
	mov		$G, %rax
	add		$STACKEND*4, %rax			# pick up...
	mov		(%rax), %rax				# ...address of STACKEND
	mov		%rax, 16(%rsp)
	mov		$STACKEND, 12(%rsp)			# Global # STACKEND
	mov		$G, %rax
	add		$STACKBASE*4, %rax			# pick up...
	mov		(%rax), %rax				#  ...address of STACKBASE
	mov		%rax, 8(%rsp)
	mov		$STACKBASE, 4(%rsp)			# Global # STACKBASE
	mov		$LC25, (%rsp)				# @ "\11\11STACKBASE (G:%d)=%d\11STACKEND (G:%d)=%d\12\11\11%%rbp=%d\11%%rsp=%d\11c_stack=%d\12\12\0
	c_call	_printf
#
	cmp		$0, c_stk					# are we tracing the c stack?
	jne		CS3							# no...
	mov		c_stackbase, %rax			# trace the c stack...
	add		$16, %rax					# ...look 4 words above c_stackbase
	shr		$2, %rax
	jmp		CS4
CS3:
	mov		$G, %rax					# trace the BCPL stack...
	add		$STACKBASE*4, %rax			# pick up...
	mov		(%rax), %rax				#  ...address of STACKBASE
	sub		$4, %rax					# ...look 4 words below STACKBASE
CS4:
#
	mov		%rax, 28(%rsp)
	jmp		LL2
LL3:
	mov		28(%rsp), %rdx
	shll	$2, %rdx
	mov		%rdx, %rax
	mov		(%rax), %rax
	mov		%rax, 8(%rsp)				#  ...contents of stack location
	shr		$2, %rdx
	mov		%rdx, 4(%rsp)				#  ...address of stack location
	mov		$LCd, (%rsp)				# @"\11\11B/C_stk | %d = %d\12\0"
	c_call	_printf
#
	cmp		$0, c_stk					# are we tracing the c stack?
	jne		CS5							# no...
	dec		28(%rsp)					# trace the c stack
	jmp		CS6
CS5:
	inc		28(%rsp)					# trace the BCPL stack
CS6:
#
LL2:
	mov		28(%rsp), %rdx
	shll	$2, %rdx
#
	cmp		$0, c_stk					# are we tracing the c stack?
	jne		CS7							# no...
	mov		%rsp, %rcx
	sub		$32, %rcx					# allow for 8 words below current %rsp
	cmp		%rcx, %rdx					# trace the c stack
	jge		LL3
	mov		$-1, c_stk					# now trace the BCPL stack
	mov		$'B, %al					# '
	mov		$LCd, %rcx
	movb	%al, 2(%rcx)				# ...modify diagnostic text
	jmp		CS0
CS7:
	mov		(%rbp), %rcx				# should be where previous %rbp was stored at entry...
	mov		(%rcx), %rcx				# ...previous c stackframe should hold BCPL stackframe address  (?)
	add		$64, %rcx					# allow for 16 words of args to latest BCPL routine
	cmp		%rcx, %rdx
	jle		LL3
#
CS8:
	leave
#  (leave:
#		mov		%rbp, %rsp				# then...
#		pop			%rbp
#			mov		(%rsp), %rbp
#			add		$4, %rsp
	ret
#		pop			%rip					# effectively...
#			mov		(%rsp), %rip		# ...as...
#			add		$4, %rsp			# ...and


// SELECTINPUT(N)

	.section .rdata,"dr"
	.align 4
LC16:
	.ascii "\11selectinput(%d) called\12\0"
	.text
.globl selectinput
	.def	selectinput;	.scl	2;	.type	32;	.endef
selectinput:
	mov		8(%rbp), %rax				# recover calling argument
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
#	mov		8(%rbp), %rax
	mov		%rax, _fi
#	mov		8(%rbp), %rax
.ifdef DEBUG
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LC16, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	leave
	ret
	
	
// SELECTOUTPUT(N)

	.section .rdata,"dr"
	.align 4
LC17:
	.ascii "\11selectoutput(%d) called\12\0"
	.text
.globl selectoutput
	.def	selectoutput;	.scl	2;	.type	32;	.endef
selectoutput:
	mov		8(%rbp), %rax				# recover calling argument
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
#	mov		8(%rbp), %rax
	mov		%rax, _fo
#	mov		8(%rbp), %rax
.ifdef DEBUG
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LC17, (%rsp)
	c_call	_printf
	mov		_fo, %rax
#				end diagnostics...		
.endif
	leave
	ret
	
	
// CH := RDCH()

	.section .rdata,"dr"
	.align 4
LC14:
	.ascii "\11rdch() called, returning '%c'\12\0"
LD14:
	.ascii "\11rdch() %%rsp: '%d'\12\0"
	.text
.globl rdch
	.def	rdch;	.scl	2;	.type	32;	.endef
rdch:
	push	%rbp
	mov		%rsp, %rbp
	sub		$40, %rsp
	mov		_fi, %rax
	mov		_ft(,%rax,4), %rax
	mov		%rax, (%rsp)
	c_call	_fgetc
	mov		%rax, _ch
.ifdef DEBUG_ALL
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LC14, (%rsp)
	c_call	_printf
#	c_call	_stacktrace
	mov		4(%rsp), %rax
#				end diagnostics...		
.endif
	cmp		$-1, %rax
	jne		L37
	mov		$ENDSTREAMCH, 4(%rsp)
L37:
#	mov		4(%rsp), %rax
	leave
	ret
	
	
// WRCH(CH)

	.section .rdata,"dr"
	.align 4
LC13:
	.ascii "\11wrch(%c) called\12\0"
	.text
.globl wrch
	.def	wrch;	.scl	2;	.type	32;	.endef
wrch:
	mov		8(%rbp), %rax				# recover calling argument
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
#	mov		8(%rbp), %rax
.ifdef DEBUG_ALL
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LC13, (%rsp)
	c_call	_printf
	c_call	_stacktrace
	mov		4(%rsp), %rax
#				end diagnostics...		
.endif
	mov		_fo, %rcx
	mov		_ft(,%rcx,4), %rcx
	mov		%rcx, 4(%rsp)
#	mov		8(%rbp), %rax
	mov		%rax, (%rsp)
	c_call	_fputc
	leave
	ret
	
	
// UNRDCH()

	.section .rdata,"dr"
	.align 4
LC15:
	.ascii "\11unrdch(%c) called\12\0"
	.text
.globl unrdch
	.def	unrdch;	.scl	2;	.type	32;	.endef
unrdch:
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
.ifdef DEBUG_4
#				start diagnostics...		
	mov		$LC15, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		_fi, %rax
	mov		_ft(,%rax,4), %rdx
#	mov		_fi, %rax
#	mov		_ft(,%rax,4), %rax
#	mov		20(%rax), %rax
	mov		_ch, %rax
	mov		%rdx, 4(%rsp)
	mov		%rax, (%rsp)
	c_call	_ungetc
	leave
	ret
	
	
// STREAM := INPUT()

	.section .rdata,"dr"
	.align 4
LC18:
	.ascii "\11input() called, returning: %d\12\0"
	.text
.globl input
	.def	input;	.scl	2;	.type	32;	.endef
input:
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
.ifdef DEBUG
#				start diagnostics...		
	mov		_fi, %rax
	mov		%rax, 4(%rsp)
	mov		$LC18, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		_fi, %rax
	leave
	ret
	
	
// STREAM := OUTPUT()

	.section .rdata,"dr"
	.align 4
LC19:
	.ascii "\11output() called, returning: %d\12\0"
	.text
.globl output
	.def	output;	.scl	2;	.type	32;	.endef
output:
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
.ifdef DEBUG
#				start diagnostics...		
	mov		_fo, %rax
	mov		%rax, 4(%rsp)
	mov		$LC19, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		_fo, %rax
	leave
	ret
	
	
// PTR := TIME()

	.section .rdata,"dr"
	.align 4
LT19:
	.ascii "\11time() called, returning: %d\12\0"
	.text
.globl time
	.def	time;	.scl	2;	.type	32;	.endef
time:
	push	%rbp
	mov		%rsp, %rbp
	sub		$32, %rsp
	lea		24(%rsp), %rax
	mov		%rax, (%rsp)
	c_call	_time						# get time (seconds) since epoch
	lea		24(%rsp), %rax
	mov		%rax, (%rsp)
	c_call	_localtime					# convert to array of years, months, days, hours, minutes and seconds...
	mov		%rax, 28(%rsp)
.ifdef DEBUG
#				start diagnostics...		
	mov		24(%rsp), %rax
	mov		%rax, 4(%rsp)
	mov		$LT19, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		28(%rsp), %rax
	shr		$2, %rax					# ...and return (BCPL) pointer to array
	leave
	ret
	
	
// REWIND()

	.section .rdata,"dr"
	.align 4
LC22:
	.ascii "\11rewind() called on stream '%d'...\12\0"
	.text
.globl rewind
	.def	rewind;	.scl	2;	.type	32;	.endef
rewind:
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
.ifdef DEBUG
#				start diagnostics...
	mov		_fi, %rax
	mov		%rax, 4(%rsp)
	mov		$LC22, (%rsp)
	c_call	_printf
#				end diagnostics...
.endif
#	mov		8(%rbp), %rax
	mov		_fi, %rax
	mov		_ft(,%rax,4), %rax
	mov		%rax, (%rsp)
	c_call	_rewind
	leave
	ret


// STREAM := FINDFILE(S, M)

	.section .rdata,"dr"
	.align 4
LF11:
	.ascii "\11findfile(\"%s\", \"%s\") called\12\0"
	.text
.globl findfile
	.def	findfile;	.scl	2;	.type	32;	.endef
findfile:
	mov		8(%rbp), %rax				# recover calling filename argument...
	mov		12(%rbp), %rcx				# ...and access mode
findf:
	push	%rbp
	mov		%rsp, %rbp
	push	%rbx
	sub		$40, %rsp
	mov		%rax, -20(%rbp)				# save (word) address of BCPL filename string...
	mov		%rcx, -24(%rbp)				# ...and (word) address of BCPL access mode string
#										# copy BCPL filename...
	shl		$2,%rax						# convert BCPL pointer to real address
	mov		%rax, (%rsp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	mov		%rax, -16(%rbp)				# save address of c filename string
#										# copy BCPL access mode...
	mov		-24(%rbp),%rax
	shl		$2,%rax						# convert BCPL pointer to real address
	mov		%rax, (%rsp)				# pass (real) address of BCPL access mode string
	c_call	_cstr
	mov		%rax, -28(%rbp)				# save address of c access mode string
.ifdef DEBUG
#				start diagnostics...
	mov		%rax, 8(%rsp)
	mov		-16(%rbp), %rax
	mov		%rax, 4(%rsp)
	mov		$LF11, (%rsp)
	c_call	_printf
#				end diagnostics...
.endif
	c_call	_ftslot
	mov		%rax, -12(%rbp)
	cmp		$0, -12(%rbp)				# any _ft slot available?
	je		1f							# no...
	mov		-28(%rbp), %rax				# collect access mode string...
	mov		%rax, 4(%rsp)
	mov		-16(%rbp), %rax				# ...and filename arguments
	mov		%rax, (%rsp)
	c_call	_fopen
	mov		-12(%rbp), %rbx
	mov		%rax, _ft(,%rbx,4)			# save file descriptor in _ft location
	mov		-12(%rbp), %rax
	mov		_ft(,%rax,4), %rax
	test	%rax, %rax					# is there a file descriptor?
	je		2f							# no, file failed to open
	add		$21, %rbx					# point %rbx to filename location in _ft
	mov		-20(%rbp), %rax				# recover (word) address of BCPL filename string
	mov		%rax, _ft(,%rbx,4)			# set _ft location to point to BCPL filename
	jmp		1f
2:
	mov		$0, -12(%rbp)
1:
	mov		-16(%rbp), %rax				# address of c filename string
	mov		%rax, (%rsp)
	c_call	_free						# release spaces...
	mov		-28(%rbp), %rax				# address of c access mode string
	mov		%rax, (%rsp)
	c_call	_free						# ...occupied by c strings
	mov		-12(%rbp), %rax
#	inc		%rax
	add		$40, %rsp
	popl	%rbx
	leave
	ret
	
	
// STREAM := FINDOUTPUT(S)

	.section .rdata,"dr"
	.align 4							# this is crucial - following BCPL string MUST be word aligned!
LW10:
	.ascii "\1w"						# access mode = write
	.text
.globl findoutput
	.def	findoutput;	.scl	2;	.type	32;	.endef
findoutput:
	mov		8(%rbp), %rax				# recover calling filename argument...
	mov		$LW10, %rcx
	shr		$2, %rcx					# (BCPL word) pointer to access mode
	jmp 	findf						# arguments are now set for findfile(filename, access_mode)
	
	
// STREAM := FINDINPUT(S)

	.section .rdata,"dr"
	.align 4							# this is crucial - following BCPL string MUST be word aligned!
LR10:
	.ascii "\1r"						# access mode = read
	.text
.globl findinput
	.def	findinput;	.scl	2;	.type	32;	.endef
findinput:
	mov		8(%rbp), %rax				# recover calling filename argument...
	mov		$LR10, %rcx
	shr		$2, %rcx					# (BCPL word) pointer to access mode
	jmp 	findf						# arguments are now set for findfile(filename, access_mode)
	
	
// STREAM := FINDAPPEND(S)

	.section .rdata,"dr"
	.align 4							# this is crucial - following BCPL string MUST be word aligned!
LA10:
	.ascii "\1a"						# access mode = append
	.text
.globl findappend
	.def	findappend;	.scl	2;	.type	32;	.endef
findappend:
	mov		8(%rbp), %rax				# recover calling filename argument...
	mov		$LA10, %rcx
	shr		$2, %rcx					# (BCPL word) pointer to access mode
	jmp 	findf						# arguments are now set for findfile(filename, access_mode)


// FPOS(N, P)

	.set SEEK_SET,0						# call c's fseek() with offsets from BoF

	.section .rdata,"dr"
	.align 4
LS11:
	.ascii "\11fpos(%d, %d, %d) called\12\0"
LS12:
	.ascii "\11fpos() returns %d\12\0"
	.text
.globl fpos
	.def	fpos;	.scl	2;	.type	32;	.endef
fpos:
	mov		8(%rbp), %rax				# recover calling stream argument...
	mov		12(%rbp), %rcx				# ...and seek offset
	push	%rbp
	mov		%rsp, %rbp
	push	%rbx
	sub		$40, %rsp
	mov		%rax, -20(%rbp)				# save stream number
	mov		%rcx, -24(%rbp)				# ...and seek offset
.ifdef DEBUG
#				start diagnostics...		
	mov		$SEEK_SET, 12(%rsp)
	mov		%rcx, 8(%rsp)
	mov		%rax, 4(%rsp)
	mov		$LS11, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		-20(%rbp), %rax				# recover stream number
	mov		-24(%rbp), %rcx				# ...and seek offset
	mov		$SEEK_SET, 8(%rsp)			# assert 'seek from BoF'
	mov		%rcx, 4(%rsp)
	mov		_ft(,%rax,4), %rax			# collect address of c file descriptor
	mov		%rax, (%rsp)
	c_call	_fseek						# _fseek returns -1 (fail) or 0 (success)...
	inc		%rax						# ...so we change this to 0 (fail) or 1 (success)
.ifdef DEBUG
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LS12, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	add		$40, %rsp
	popl	%rbx
	leave
	ret


// ENDSTREAM(N)

	.section .rdata,"dr"
	.align 4
LE20:
	.ascii "\11endstream(%d) called...\12\0"
	.text
.globl endstream
	.def	endstream;	.scl	2;	.type	32;	.endef
endstream:
	mov		8(%rbp), %rax				# recover calling stream id...
ends:
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
	mov		%rax, -16(%rbp)				# record stream id...
.ifdef DEBUG
#				start diagnostics...		
#	mov		_fi, %rax
	mov		%rax, 4(%rsp)
	mov		$LE20, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		-16(%rbp), %rax				# collect stream id...
	cmp		$2, %rax					# SYSIN, SYSOUT or SYSERR?
	jle		1f							# ...if so, don't close
#	mov		_fi, %rax
	mov		_ft(,%rax,4), %rax			# collect address of file descriptor
	mov		%rax, (%rsp)
	c_call	_fclose
	mov		-16(%rbp), %rax				# collect stream id...
	mov		$0, _ft(,%rax,4)
1:
	cmp		$2, %rax					# were we closing a SYS... stream?
	jg		2f							# no
	cmp		_fo, %rax					# closing SYSOUT or SYSERR?
	jne 	2f							# no - no need to flush
#	mov		_fo, %rax
	mov		_ft(,%rax,4), %rax
	mov		%rax, (%rsp)
	c_call	_fflush
2:
	mov		-16(%rbp), %rax				# collect stream id...
	cmp		_fi, %rax
	jne		1f							# if closing current input...
	mov		$0, _fi						# select SYSIN
	jmp		2f
1:	
	mov		$1, _fo						# otherwise select SYSOUT as current output
2:
	leave
	ret
	
	
// ENDREAD()

	.section .rdata,"dr"
	.align 4
LC20:
	.ascii "\11endread(%d) called...\12\0"
	.text
.globl endread
	.def	endread;	.scl	2;	.type	32;	.endef
endread:
	mov		_fi, %rax
	jmp	ends
	
	
// ENDWRITE()

	.section .rdata,"dr"
	.align 4
LC21:
	.ascii "\11endwrite(%d) called...\12\0"
	.text
.globl endwrite
	.def	endwrite;	.scl	2;	.type	32;	.endef
endwrite:
	mov		_fo, %rax
	jmp ends
	
	
// R := RENAME(S1, S2)

	.section .rdata,"dr"
	.align 4
LR11:
	.ascii "\11rename(\"%s, %s\") called\12\0"
	.text
.globl rename
	.def	rename;	.scl	2;	.type	32;	.endef
rename:
	mov		8(%rbp), %rax				# recover old filename argument
	mov		12(%rbp), %rcx				# recover new filename argument
	push	%rbp
	mov		%rsp, %rbp
	push	%rbx
	sub		$40, %rsp
	mov		%rax, -20(%rbp)				# save BCPL address of old filename string
	mov		%rcx, -24(%rbp)				# save BCPL address of new filename string
#										# copy BCPL old filename...
	shl		$2,%rax						# convert BCPL pointer to real address
	mov		%rax, (%rsp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	mov		%rax, -16(%rbp)				# save address of old c filename string
#										# copy BCPL new filename...
	mov		-24(%rbp), %rax				# recover BCPL address of new filename string
	shl		$2,%rax						# convert BCPL pointer to real address
	mov		%rax, (%rsp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	mov		%rax, -28(%rbp)				# save address of new c filename string
.ifdef DEBUG
#				start diagnostics...		
	mov		%rax, 8(%rsp)				# ...address of new c filename string
	mov		-16(%rbp), %rcx				# recover address of old c filename string
	mov		%rcx, 4(%rsp)
	mov		$LR11, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		-28(%rbp), %rax				# recover address of new c filename string
	mov		%rax, 4(%rsp)
	mov		-16(%rbp), %rax				# recover address of old c filename string
	mov		%rax, (%rsp)
	c_call	_rename						# _rename appears to return -1 (fail) or 0 (success)...
	inc		%rax						# ...so we change this to 0 (fail) or 1 (success)
	mov		%rax, -12(%rbp)
	mov		-16(%rbp), %rax
	mov		%rax, (%rsp)
	c_call	_free						# release space occupied by c strings...
	mov		-28(%rbp), %rax
	mov		%rax, (%rsp)
	c_call	_free
	mov		-12(%rbp), %rax
#	inc		%rax
	add		$40, %rsp
	popl	%rbx
	leave
	ret
	
	
// R := DELETE(S)

	.section .rdata,"dr"
	.align 4
LD11:
	.ascii "\11delete(\"%s\") called\12\0"
	.text
.globl delete
	.def	delete;	.scl	2;	.type	32;	.endef
delete:
	mov		8(%rbp), %rax				# recover old filename argument
	push	%rbp
	mov		%rsp, %rbp
	push	%rbx
	sub		$36, %rsp
	mov		%rax, -20(%rbp)				# save BCPL address of filename string
#										# copy BCPL filename...
	shl		$2,%rax						# convert BCPL pointer to real address
	mov		%rax, (%rsp)				# pass (real) address of BCPL filename string
	c_call	_cstr
	mov		%rax, -16(%rbp)				# save address of c filename string
.ifdef DEBUG
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LD11, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		-16(%rbp), %rax				# recover address of c filename string
	mov		%rax, (%rsp)
	c_call	_unlink						# _unlink appears to return -1 (fail) or 0 (success)...
	inc		%rax						# ...so we change this to 0 (fail) or 1 (success)
	mov		%rax, -12(%rbp)
	mov		-16(%rbp), %rax
	mov		%rax, (%rsp)
	c_call	_free						# release space occupied by c strings...
	mov		-12(%rbp), %rax
#	inc		%rax
	add		$36, %rsp
	popl	%rbx
	leave
	ret
	
	
// S := GETENV(ENVVAR)

	.section .rdata,"dr"
	.align 4
LG11:
	.ascii "\11getenv(\"%s\") called\12\0"
	.text
.globl getenv
	.def	getenv;	.scl	2;	.type	32;	.endef
getenv:
	mov		8(%rbp), %rax				# recover calling argument
	push	%rbp
	mov		%rsp, %rbp
	push	%rbx
	sub		$40, %rsp
	mov		%rax, -20(%rbp)				# save (word) address of BCPL environment variable string
#										# copy BCPL environment variable...
	shl		$2,%rax						# convert BCPL pointer to real address
	mov		%rax, (%rsp)				# pass (real) address of BCPL environment variable string
	c_call	_cstr
	mov		%rax, -16(%rbp)				# save address of c environment variable name
.ifdef DEBUG
#				start diagnostics...		
	mov		%rax, 4(%rsp)
	mov		$LG11, (%rsp)
	c_call	_printf
#				end diagnostics...		
.endif
	mov		-16(%rbp), %rax				# collect c ev name
	mov		%rax, (%rsp)
	c_call	_getenv
	test		%rax, %rax					# is there a matching environment variable?
	je	LF32							# no
	mov		%rax, -12(%rbp)				# save Cev, address of the environment variable
	mov		%rax, (%rsp)
	call	_strlen						# get ev's string length...
	mov		%rax, -24(%rbp)				# ...s = strlen(ev)
	mov		-24(%rbp), %rax
	add		$2, %rax					# s=s+2
	add		$3, %rax
	and		$-4, %rax					# length, modulo four
	mov		%rax, (%rsp)
	c_call	_malloc						# get vector for BCPL copy of string: Bev
	add		$3, %rax
	and		$-4, %rax					# address, modulo four, to align on word boundary...
	mov		%rax, -28(%rbp)				# ...save address of Bev
	mov		$0, -32(%rbp)				# i = 0
	jmp	G5
G6:
	inc		-32(%rbp)					# i++
G5:
	mov		-32(%rbp), %rax
	inc		%rax
	add		-28(%rbp), %rax				# Bev[i+1]
	mov		-12(%rbp), %rdx				# Cev
	add		-32(%rbp), %rdx				# Cev[i]
	movb	(%rdx), %dl
	movb	%dl, (%rax)					# Bev[i+1] = Cev[i]
	movb	(%rax), %al
	testb	%al, %al
	jne	G6								# != '\0' ?
	mov		-32(%rbp), %rax				
	movb	%al, %dl
	mov		-28(%rbp), %rax
	movb	%dl, (%rax)					# Bev[0] = i
	shr		$2, %rax					# convert byte address to BCPL word
	mov		%rax, -28(%rbp)				# ...save word address of Bev
	jmp	L32
LF32:
	mov		$0, -28(%rbp)				# set 'no env variable found'
L32:
	mov		-16(%rbp), %rax
	mov		%rax, (%rsp)
	c_call	_free						# release space occupied by c string
	mov		-28(%rbp), %rax				# load result
#	inc		%rax
	add		$40, %rsp
	popl	%rbx
	leave
	ret
	
	
// V := GETVEC(SIZE)

	.section .rdata,"dr"
LC26:
	.ascii "\11getvec(%c) called\12\0"
	.text
.globl getvec
	.def	getvec;	.scl	2;	.type	32;	.endef
getvec:
	mov		8(%rbp), %rax				# recover calling argument
	inc		%rax						# ...to allow for 0 -> vecsize
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
.ifdef DEBUG
#				start diagnostics...
	mov		%rax, 4(%rsp)
	mov		$LC26, (%rsp)
	c_call	_printf
	mov		4(%rsp), %rax
#				end diagnostics...
.endif
	shll	$2,%rax						# convert requested BCPL memory size (words) to bytes
	mov		%rax, (%rsp)
	c_call	_malloc
	shr		$2,%rax						# convert byte address to BCPL word
	leave
	ret
	
	
// FREEVEC(V)

	.section .rdata,"dr"
LC27:
	.ascii "\11freevec(%c) called\12\0"
	.text
.globl freevec
	.def	freevec;	.scl	2;	.type	32;	.endef
freevec:
	mov		8(%rbp), %rax				# recover calling argument
	push	%rbp
	mov		%rsp, %rbp
	sub		$24, %rsp
.ifdef DEBUG
#				start diagnostics...
	mov		%rax, 4(%rsp)
	mov		$LC27, (%rsp)
	c_call	_printf
	mov		4(%rsp), %rax
#				end diagnostics...
.endif
	shll	$2,%rax						# convert BCPL word address to byte
	mov		%rax, (%rsp)
	c_call	_free
	leave
	ret


	.def	_start;		.scl	2;	.type	32;	.endef
	.def	_puts;		.scl	2;	.type	32;	.endef
	.def	_malloc;	.scl	2;	.type	32;	.endef
	.def	_fopen;		.scl	2;	.type	32;	.endef
	.def	_getenv;	.scl	2;	.type	32;	.endef
	.def	_rename;	.scl	2;	.type	32;	.endef
	.def	_unlink;	.scl	2;	.type	32;	.endef
	.def	_free;		.scl	2;	.type	32;	.endef
	.def	_fputc;		.scl	2;	.type	32;	.endef
	.def	_fgetc;		.scl	2;	.type	32;	.endef
	.def	_ungetc;	.scl	2;	.type	32;	.endef
	.def	_printf;	.scl	2;	.type	32;	.endef
	.def	_fclose;	.scl	2;	.type	32;	.endef
	.def	_fflush;	.scl	2;	.type	32;	.endef
	.def	_fseek;		.scl	2;	.type	32;	.endef
	.def	_rewind;	.scl	2;	.type	32;	.endef
	.def	_time;		.scl	2;	.type	32;	.endef
	.def	_localtime;	.scl	2;	.type	32;	.endef
