/* Copyright (c) 2013 Dave Cannon.  All rights reserved. */

/* $Id: t.c,v 1.0 2013/12/22 14:11:01 */

#include <time.h>
#include <stdio.h>

/* struct tm is a structure used to hold the time and date. Its members are as follows:

         int tm_sec;    // seconds after the minute (0 to 61)
         int tm_min;    // minutes after the hour (0 to 59)
         int tm_hour;   // hours since midnight (0 to 23)
         int tm_mday;   // day of the month (1 to 31)
         int tm_mon;    // months since January (0 to 11)
         int tm_year;   // years since 1900
         int tm_wday;   // days since Sunday (0 to 6 Sunday=0)
         int tm_yday;   // days since January 1 (0 to 365)
         int tm_isdst;  // Daylight Savings Time

If tm_isdst is zero, then Daylight Savings Time is not in effect. If it is a positive
value, then Daylight Savings Time is in effect. If it is negative, then the function
using it is requested to attempt to calculate whether or not Daylight Savings Time is
in effect for the given time.

Note that tm_sec may go as high as 61 to allow for up to two leap seconds.
*/

int main(void)
{
  time_t timer;
  struct tm *dt;

  time(&timer);
  dt = localtime(&timer);
  printf ("sizeof time_t is: %d\n", sizeof(time_t));
  printf("The current time is: %s\n", asctime(dt));
  return 0;
}