// $Id: LIBHDR,v 1.7 2013/01/29 17:31:40 rn Exp $

//  libhdr
GLOBAL $(
START			: 1		// START(argv, argc)
SYS				: 2
ABORT			: 3		// ABORT(error_code)	- Calls BACKTRACE() and MAPSTORE()
BACKTRACE		: 4
STACKTRACE		: 4		// STACKTRACE()			- Summarise the run-time stack
TRAP			: 5		// TRAP(n)				- Run diagnostics on call of first n undefined GLOBALs

SELECTINPUT		: 11	// SELECTINPUT(stream_id)
SELECTOUTPUT	: 12	// SELECTOUTPUT(stream_id)
RDCH			: 13	// ch := RDCH()
WRCH			: 14	// WRCH(ch)
UNRDCH			: 15	// UNRDCH()
INPUT			: 16	// stream_id := INPUT()
OUTPUT			: 17	// stream_id := OUTPUT()

TIMEOFDAY		: 27	// str := TIMEOFDAY()
TIME			: 28	// str := TIME()
DATE			: 29	// str := DATE()
STOP			: 30	// STOP(exit_code)
LEVEL			: 31	// stack_pointer := LEVEL()
LONGJUMP		: 32	// LONGJUMP(stack_pointer, label)
REWIND			: 35	// REWIND()

APTOVEC			: 40	// result := APTOVEC(function, vec_size)
FINDOUTPUT		: 41	// stream_id := FINDOUTPUT(filename)
FINDINPUT		: 42	// stream_id := FINDINPUT(filename)
FINDAPPEND		: 43	// stream_id := FINDAPPEND(filename)
ENDSTREAM		: 45	// ENDSTREAM(stream_id)
ENDREAD			: 46	// ENDREAD()
ENDWRITE		: 47	// ENDWRITE()
FILETABLE		: 48	// address of FILETABLE - for diagnostics: 24-Oct-2012
RENAME			: 49	// result := RENAME(filename1, filename2)
DELETE			: 50	// result := DELETE(filename)
ENDTOINPUT		: 51	// ENDTOINPUT()
GETENV			: 52	// str := GETENV(envvar_name)
PATHFINDINPUT	: 53	// stream := PATHFINDINPUT(filename)
FINDFILE		: 54	// stream := FINDFILE(filename, mode)
FSEEK			: 55	// result = fseek(stream_id, character_posn)

WRITES			: 60	// WRITES(string)
WRITEN			: 62	// WRITEN(number)
NEWLINE			: 63	// NEWLINE()
NEWPAGE			: 64	// NEWPAGE()
PACKSTRING		: 66	// char_length := PACKSTRING(vector, string)
UNPACKSTRING	: 67	// UNPACKSTRING(string, vector)
WRITED			: 68	// WRITED(number, width)
READN			: 70	// number := READN()
TERMINATOR		: 71	// last byte read by READN()

CAPITALCH		: 74	// ch := CAPITALCH(ch)
WRITEHEX		: 75	// WRITEHEX(number, width)
WRITEF			: 76	// WRITEF(format_string, arg1, arg2, ..., arg11)
WRITEOCT		: 77	// WRITEOCT(number, width)
MAPSTORE		: 78	// MAPSTORE()
SWRITEF			: 79	// WRITEF(stream_id, format_string, arg1, arg2, ..., arg11)

GETBYTE			: 85	// ch := GETBYTE(string, character_offset)
PUTBYTE			: 86	// PUTBYTE(string, character_offset, ch)
GETVEC			: 87	// vec_address := GETVEC(word_size)
FREEVEC			: 88	// FREEVEC(vec_address)

RDARGS			: 90	// RDARGS(ignored, V, N)
RESULT2			: 91	// various secondary results
STRCAT			: 92	// string := STRCAT(dest_string, srce_string)
STR2NO			: 93	// number := STR2NO(string)
STR2NUMB		: 94	// STR2NUMB(string, number)
STACKBASE		: 95	// base of runtime stack
STACKEND		: 96	// end of runtime stack
ARGC			: 97	// argument (parameter) count
ARGV			: 98	// argument (parameter) vectors
PARAM			: 99	// ARGV!1 or ""

start			: 1
sys				: 2
abort			: 3					// Calls BACKTRACE and MAPSTORE
backtrace		: 4
stacktrace		: 4					// Summarise the run-time stack
trap			: 5

selectinput		: 11
selectoutput	: 12
rdch			: 13
wrch			: 14
unrdch			: 15
input			: 16
output			: 17

timeofday		: 27
time			: 28
date			: 29
stop			: 30
level			: 31
longjump		: 32
rewind			: 35

aptovec			: 40
findoutput		: 41
findinput		: 42
findappend		: 43
endstream		: 45
endread			: 46
endwrite		: 47
filetable		: 48							// for diagnostics: 24-oct-2012
rename			: 49
delete			: 50
endtoinput		: 51
getenv			: 52
pathfindinput	: 53
findfile		: 54
fseek			: 55

writes			: 60
writen			: 62
newline			: 63
newpage			: 64
packstring		: 66
unpackstring	: 67
writed			: 68
readn			: 70
terminator		: 71

capitalch		: 74
writehex		: 75
writef			: 76
writeoct		: 77
mapstore		: 78
swritef			: 79

getbyte			: 85
putbyte			: 86
getvec			: 87
freevec			: 88

rdargs			: 90
result2			: 91
strcat			: 92
str2no			: 93
str2numb		: 94
stackbase		: 95
stackend		: 96
argc			: 97
argv			: 98
param			: 99
$)


MANIFEST $(
SYSIN		= 0
SYSOUT		= 1
SYSERR		= 2				// Standard input, output and error streams (preopened, set to console)

ENDSTREAMCH	= -1
BYTESPERWORD= 4
BITSPERWORD	= 32
MAXSTRLENGTH= 255
MAXINT		= #X7FFFFFFF
MININT		= #X80000000

NEGGSZ		= 32			// limit of negative GLOBAL numbers
MAXGLOBAL	= 1000			// limit of positive GLOBAL numbers
FIRSTFREEGLOBAL	= 100
UG = FIRSTFREEGLOBAL

sysin		= 0
sysout		= 1
syserr		= 2				// Standard input, output and error streams (preopened, set to console)

endstreamch	= -1
bytesperword= 4
bitsperword	= 32
maxstrlength= 255
maxint		= #X7FFFFFFF
minint		= #X80000000

neggsz		= 32			// limit of negative GLOBAL numbers
maxglobal	= 1000			// limit of positive GLOBAL numbers
firstfreeglobal	= 100
ug = firstfreeglobal
$)
