// $Id: LIBHDR,v 1.7 2013/01/29 17:31:40 rn Exp $

external $(
	Fwritef
$)

//  libhdr
global $(
Start			: 1		// start(argv, argc)
Sys				: 2
Abort			: 3		// abort(error_code)	- calls backtrace() and mapstore()
Backtrace		: 4
Stacktrace		: 4		// stacktrace()			- summarise the run-time stack
Trap			: 5		// trap(n)				- run diagnostics on call of first n undefined globals

Selectinput		: 11	// selectinput(stream_id)
Selectoutput	: 12	// selectoutput(stream_id)
Rdch			: 13	// ch := rdch()
Wrch			: 14	// wrch(ch)
Unrdch			: 15	// unrdch()
Input			: 16	// stream_id := input()
Output			: 17	// stream_id := output()

Timeofday		: 27	// str := timeofday()
Time			: 28	// str := time()
Date			: 29	// str := date()
Stop			: 30	// stop(exit_code)
Level			: 31	// stack_pointer := level()
Longjump		: 32	// longjump(stack_pointer, label)
Rewind			: 35	// rewind()

Aptovec			: 40	// result := aptovec(function, vec_size)
Findoutput		: 41	// stream_id := findoutput(filename)
Findinput		: 42	// stream_id := findinput(filename)
Findappend		: 43	// stream_id := findappend(filename)
Endstream		: 45	// endstream(stream_id)
Endread			: 46	// endread()
Endwrite		: 47	// endwrite()
Filetable		: 48	// address of filetable - for diagnostics: 24-oct-2012
Rename			: 49	// result := rename(filename1, filename2)
Delete			: 50	// result := delete(filename)
Endtoinput		: 51	// endtoinput()
Getenv			: 52	// str := getenv(envvar_name)
Pathfindinput	: 53	// stream := pathfindinput(filename)
Findfile		: 54	// stream := findfile(filename, mode)
Fseek			: 55	// result = fseek(stream_id, character_posn)

Writes			: 60	// writes(string)
Writen			: 62	// writen(number)
Newline			: 63	// newline()
Newpage			: 64	// newpage()
Packstring		: 66	// char_length := packstring(vector, string)
Unpackstring	: 67	// unpackstring(string, vector)
Writed			: 68	// writed(number, width)
Readn			: 70	// number := readn()
Terminator		: 71	// last byte read by readn()

Capitalch		: 74	// ch := capitalch(ch)
Writehex		: 75	// writehex(number, width)
Writef			: 76	// writef(format_string, arg1, arg2, ..., arg11)
Writeoct		: 77	// writeoct(number, width)
Mapstore		: 78	// mapstore()
Swritef			: 79	// swritef(string, format_string, arg1, arg2, ..., arg11)

Getbyte			: 85	// ch := getbyte(string, character_offset)
Putbyte			: 86	// putbyte(string, character_offset, ch)
Getvec			: 87	// vec_address := getvec(word_size)
Freevec		: 88	// freevec(vec_address)

Rdargs			: 90	// rdargs(ignored, v, n)
Result2			: 91	// various secondary results
Strcat			: 92	// string := strcat(dest_string, srce_string)
Str2no			: 93	// number := str2no(string)
Str2numb		: 94	// str2numb(string, number)
Stackbase		: 95	// base of runtime stack
Stackend		: 96	// end of runtime stack
Argc			: 97	// argument (parameter) count
Argv			: 98	// argument (parameter) vectors
Param			: 99	// argv!1 or ""
$)


manifest $(
Sysin		= 0
Sysout		= 1
Syserr		= 2				// Standard input, output and error streams (preopened, set to console)

Endstreamch	= -1
Bytesperword= 4
Bitsperword	= 32
Maxstrlength= 255
Maxint		= $X7FFFFFFF
Minint		= $X80000000

Neggsz		= 32			// limit of negative GLOBAL numbers
Firstfreeglobal	= 100
Ug = 100					// synonym for Firstfreeglobal
$)
